program Compiler(input,output);


uses RB_unit0, CompilU1, mp_asmU0, mp_asmU9;

var
  boRB : boolean;


{============================================================================}


procedure  Block(tId : pIdentifier);                                 forward;
procedure  CodeTerm(var tRe1 : Result);                              forward;
procedure  Coding(var tRe : Result; bOrder, bLevel : byte);          forward;
procedure  GetVarType(tSt : pStructure);                             forward;
procedure  Statement;                                                forward;
procedure  UsesDeclaration;                                          forward;


{============================================================================}


procedure GetArray(tSt : pStructure);
var
  tBo : boolean;
  lMin : longint;
  tId, tId2, tIdS : pIdentifier;
  tRa, tRa2 : pRange;
  tSt2 : pStructure;
label PL2;
begin
  if not CheckSymbol(lBrack) then exit;

  tSt^.ArRange := nil;
  tSt^.DataPtr := nil;
  tSt^.DataSize := 0;
  tSt^.ArNum := 0;
  Symbol := comma;
  lMin := 1;

  while Symbol = comma do
   begin
    inc(tSt^.ArNum);
    GetSymbol;

    if Symbol in [ident, Minus, Plus, CharVal, RangeVal] then
     begin
      if (Symbol = ident) then
       begin
        tId := SearchIdAll(Id, '', Top, True);
        if (tId = nil) then begin Error(3); exit; end;

{**  Should be constant  **}
        if (tId^.group <> Konst) then
         begin
          Error(31);
          exit;
         end;

        if tId^.Structure^.sSymbol = SetItemSym then
         Symbol := tId^.Structure^.sSymbol;
       end;

      if (Symbol = SetItemSym) then
       begin
        tIdS := Search4Set(Id);         { Search for origin of this item }
        if not GetCheckSymbol(RangeSym) then exit;
        if not GetCheckSymbol(ident) then exit;
        tId2 := Search4Set(Id);         { Search for origin of this item }
        if (tId2 <> tIdS) then
         begin                          { not the same set }
          Error(26);
          exit;
         end;

        tBo := True;
        new(tRa);
        tRa^.SetId := tIdS;
        tRa^.RangeType := rSet;
        tRa^.nRange := nil;
        tRa^.lBegin := tId^.Start;

        tId := SearchIdAll(Id, '', Top, False);
        tRa^.lEnd := tId^.Start;
        GetSymbol;
       end
      else
       begin
        new(tRa);
        tRa^.nRange := nil;
        tRa^.RangeType := rInt;
        new (tSt2);
        tSt2^.boPointer := False;
        Calculation(tSt2, 0);

        if (Val2Sym(tSt2^.sSymbol) in NumberSys) then tRa^.lBegin := tSt2^.l
         else
        if (Val2Sym(tSt2^.sSymbol) = CharSym) then tRa^.lBegin := ord(tSt2^.c)
         else goto PL2;

        if not CheckSymbol(RangeSym) then
         begin
PL2:      Error(21);
          DisposeRange(tRa);
          exit;
         end;

        GetSymbol;
        Calculation(tSt2, 0);

        if (Val2Sym(tSt2^.sSymbol) in NumberSys) then tRa^.lEnd := tSt2^.l
         else
        if (Val2Sym(tSt2^.sSymbol) = CharSym) then tRa^.lEnd := ord(tSt2^.c)
         else goto PL2;

        DisposeStructure(tSt2);

  {**  Check if second value is greater then first one  **}
        if (tRa^.lBegin > tRa^.lEnd) then
         begin
          Error(28);
          DisposeRange(tRa);
          exit;
         end;

        tBo := True;
       end;
     end
    else
     begin
      Error(300);
      exit;
     end;

    if (tSt^.ArRange = nil) then
     begin
      tSt^.ArRange := tRa;
      tSt^.ArOrg := tBo;
     end
    else
     begin
      tRa2 := tSt^.ArRange;
      while tRa2^.nRange <> nil do tRa2 := tRa2^.nRange;
      tRa2^.nRange := tRa;
      tRa2^.nRaOrg := False;            { next range is subset }
     end;
   end;

  if not CheckSymbol(rBrack) then
   begin
    Error(54);
    exit;
   end;

  if not GetCheckSymbol(OfSym) then
   begin
    Error(93);
    exit;
   end;

  GetSymbol;
  new(tSt^.ArStruc);
  GetVarType(tSt^.ArStruc);
end;


function GetVarIdentifier(boProg, boVar, boParent : boolean) : pIdentifier;
{
 boProg:   used to insert the parameters behind 'Program xxx (....)'
 boVar:    parameters can be preceeded by "var" for functions/procedures
 boParent: parameters can end with ")" for functions/procedures and records
           with cases
}
var
  boVar2, VeryFirst, NotFirst : boolean;
  b : byte;
  plo : longint;
  tId, tId2, tIdF, tIdV : pIdentifier;
  tSt : pStructure;
begin
  VeryFirst := False;
  tIdF := nil;
  tIdV := nil;

  while (   (Symbol = ident)
         or ((Symbol = VarSym) and boVar)) do
   begin
    boVar2 := (Symbol = VarSym) and boVar;
    if boVar2 then if not GetCheckSymbol(ident) then exit;

    NotFirst := False;
    Symbol := comma;

    repeat
     if NotFirst then
      begin
       GetSymbol;
       if ((Symbol = VarSym) and boVar) then GetSymbol;
       if not CheckSymbol(ident) then exit;
      end;

     if boVar then tId := SearchChainId(tIdF, id, plo) else
      begin
       b := BlockLevel;
       tId := nil;

{* First check own function/procedure *}
       while ((tId = nil) and (b > 0)) do
        begin
         tId := SearchChainId(idProcParms[b], id, plo);
         dec(b);
        end;

       if (tId = nil) then
        tId := SearchChainId(Identifier[bNowUnit][Top], id, plo);
      end;

     if (tId <> nil) then begin Error(4); exit; end;

     tId := NewIdent;
     tId^.ProcVar := boVar2;

     if boVar then EnterIdLocal(tId, tIdF)
      else EnterIdGlobal(tId);

     if not NotFirst then
      begin
       tIdF := tId;               { save first entry for update of structure }
       NotFirst := True;

       if not VeryFirst then
        begin
         tIdV := tId;             { save first entry for update of record or }
         VeryFirst := True;       { Var decleraration }
        end;
      end;

     GetSymbol;
    until Symbol <> comma;

    if boProg then
     begin
      if not CheckSymbol(rParent) then exit;
      new(tSt);
      CreateTextStruc(tSt);
     end
    else
     begin
      if not CheckSymbol(colon) then exit;
      GetSymbol;
      new(tSt);
      GetVarType(tSt);
     end;

{**  link structure to all found variables  **}
    tId := tIdF;                          { start with first one }

    while tId <> nil do
     begin
      tId^.Structure := tSt;
      tId^.AssName := VarName(tId);
      tId^.UnitName := sPasFile;
      tId^.Level := UnitLevel;
      CalcStart(tId);
      tId := tId^.nlink;                  { look for next one }
     end;


    if not boProg then
     begin

{**  declarations can end with ) like with parameters of procedures  **}
      if (boParent and (Symbol = rParent)) then Break;
      if (Symbol = EndSym) then Break;
      if not CheckSymbol(semicolon) then exit;
      GetSymbol;
     end;
   end;

  GetVarIdentifier := tIdV;
end;


procedure GetRecord(tSt : pStructure);
var
  NotFirst, OldUpdate : boolean;
  tCa, tCa2, tCaF : pCaseStruc;
  tId, tId2, tIdC : pIdentifier;
  tRa, tRa2 : pRange;
  tSt2 : pStructure;
label L1;
begin
  inc(Top)                              { new identification level };
  OldUpdate := UpdateStart;
  UpdateStart := False;

  tSt^.Item := nil;
  tSt^.CaseStruc := nil;
  tSt^.CaseMembers := nil;
  tSt^.CaseItem := nil;

  if (Symbol = ident) then tSt^.Item := GetVarIdentifier(False, False, False);

  if (Symbol = CaseSym) then
   begin
    if not GetCheckSymbol(ident) then goto L1;
    tId := SearchId(id, '', Top, False);        { case XXX : YYY of }
    if (tId <> nil) then                        {      ^^^          }
     begin                                      { name already exists }
      Error(4);
      goto L1;
     end;

    tId := NewIdent;
    if not GetCheckSymbol(colon) then goto L1;

{**  Get SET of case  **}
    GetSymbol;
    if not (Symbol in [ident, CharSym, StringSym] + NumberSys) then goto L1;
    new(tSt2);
    GetVarType(tSt2);                   { case XXX : YYY of }
    tId^.Structure := tSt2;             {            ^^^    }
    CalcStart(tId);
    tId^.AssName := VarName(tId);
    tId^.UnitName := sPasFile;
    tId^.Level := UnitLevel;
    tSt^.CaseItem := tId;

    while (tId^.Structure^.sSymbol = TypeSym) do tId := tId^.Structure^.t;
    tId2 := tId^.Structure^.tSet;
    if not CheckSymbol(OfSym) then goto L1;
    GetSymbol;

    repeat
     NotFirst := False;

     repeat
      if NotFirst then GetSymbol;

      if (Symbol = ident) then
       if (SearchSet(id, tId2) = -1) then
        begin
         Error(3);
         goto L1;
        end;

      new(tCa);
      tCa^.NextCase := nil;
      tCa^.CsubPart := nil;
      tCa^.CsubType := Symbol;

      case Symbol of
       ByteVal,
       WordVal,
       IntVal,
       LongVal : tCa^.l := lFound;
       CharVal : tCa^.c := sString[1];
       StringVal : begin
         new(tCa^.s);
         tCa^.s^ := sString;
        end;
       Ident : tCa^.CsubName := id;
      end;

      if NotFirst then tCa2^.NextCase := tCa;
      tCa2 := tCa;

      if not NotFirst then
       begin
        tCaF := tCa;              { save first entry for update of structure }
        NotFirst := True;
      end;

      GetSymbol;
     until Symbol <> comma;

     if not CheckSymbol(colon) then goto L1;
     if not GetCheckSymbol(lParent) then goto L1;

     GetSymbol;
     if (Symbol <> rParent) then        { <set-item> : (); }
      begin
       if not CheckSymbol(ident) then goto L1;
       tCaF^.CsubPart := GetVarIdentifier(False, True, True);
       EnterIdLocal(tCaF^.CsubPart, tSt^.CaseMembers);
       if not CheckSymbol(rParent) then goto L1;
      end;

     if not GetCheckSymbol(semicolon) then goto L1;


{**  Copy CsubPart to other case elements (if exist)  **}
     tCa := tCaF^.NextCase;
     while (tCa <> nil) do
      begin
       tCa^.CsubPart := tCaF^.CsubPart;
       tCa := tCa^.NextCase
      end;

     if (tSt^.CaseStruc = nil) then tSt^.CaseStruc := tCaF else
      begin
       tCa2 := tSt^.CaseStruc;

       while (tCa2^.NextCase <> nil) do
        tCa2 := tCa2^.NextCase;

       tCa2^.NextCase := tCaF;
      end;

     GetSymbol;
    until Symbol = EndSym;
   end;

  if (Symbol = EndSym) then
   GetSymbol
  else
   begin
    Error(37);
    goto L1;
   end;

L1:
  Identifier[bNowUnit][Top] := nil;
  dec(Top);                             { original identification level }
  UpdateStart := OldUpdate;
end;


procedure GetVarType2(tSt : pStructure);
var
  tId : pIdentifier;
  tSt2 : pStructure;
  wSize : word;
begin
  tSt^.sSymbol := Val2Sym(Symbol);
  GetSymbol;

  if tSt^.sSymbol = ArraySym  then GetArray(tSt)        else
  if tSt^.sSymbol = BoolSym   then wSize := BooleanSize else
  if tSt^.sSymbol = ByteSym   then wSize := ByteSize    else
  if tSt^.sSymbol = CharSym   then wSize := CharSize    else
  if tSt^.sSymbol = FileSym   then GetFile(tSt)         else
  if tSt^.sSymbol = IntSym    then wSize := IntSize     else
  if tSt^.sSymbol = LongSym   then wSize := LongSize    else
  if tSt^.sSymbol = PointSym  then wSize := PointerSize else
  if tSt^.sSymbol = RecordSym then GetRecord(tSt)       else
  if tSt^.sSymbol = TextSym   then CreateTextStruc(tSt) else
  if tSt^.sSymbol = WordSym   then wSize := WordSize    else

  if tSt^.sSymbol = RealSym   then
   begin
    tSt^.rs := nil;
    wSize := RealSize;
   end
    else


  if tSt^.sSymbol = SetOfSym then
   begin
    if not CheckSymbol(OfSym) then exit;
    if not GetCheckSymbol(ident) then exit;

    tId := SearchIdAll(id, '', Top, True);
    if (tId = nil) then begin Error(3); exit; end;

    repeat
     if not (tId^.Structure^.sSymbol in [TypeSym, SetSym]) then
      begin Error(21); exit; end;

     if (tId^.Structure^.sSymbol = TypeSym) then
       tId := tId^.Structure^.t;
    until tId^.Structure^.sSymbol = SetSym;

    tSt^.tSetOf := tId;
    GetSymbol;
   end
    else

  if tSt^.sSymbol = StringSym then
   begin
    tSt^.s := nil;

    if (Symbol = lBrack) then
     begin
      tSt^.s := nil;
      GetSymbol;
      if not(Symbol in ConstSys) then begin Error(31); exit; end;
      new(tSt2);
      tSt2^.sSymbol := UnknownSym;
      tSt2^.s := nil;
      tSt2^.boPointer := False;

      Calculation(tSt2, 0);

  {* check found symbol and value of found number *}
      if (    (tSt2^.sSymbol in [ByteSym, IntSym, LongSym, WordSym])
          and (tSt2^.l > 0)
          and (tSt2^.l < 256)) then tSt^.StrSize := tSt2^.l + 1
       else Error(21);

      DisposeStructure(tSt2);
      if not CheckSymbol(rBrack) then exit;

      GetSymbol;
     end
      else tSt^.StrSize := StringSize + 1;
   end
  else
   begin
    Error(21);
    exit;
   end;

  if ((Symbol = Ident) and (short(id) = 'ABSOLUTE')) then HandleAbsolute;
end;


procedure GetVarType(tSt : pStructure);
var
  tId : pIdentifier;
begin
  tSt^.boPointer := (Symbol = dakje);         { pointer assignment }

  if tSt^.boPointer then
   begin
    GetSymbol;

    if not (Symbol in [ByteSym, IntSym, LongSym, WordSym, RealSym, ident,
                       CharSym, StringSym, ArraySym, RecordSym]) then
     begin Error(21); exit; end;
   end;

  if (Symbol = ident) then
   begin
    tId := SearchIdAll(Id, '', Top, True);
    if tId = nil then  begin Error(3); exit; end;
    if tId^.Group <> Types then begin Error(26); exit; end;
    tSt^.sSymbol := TypeSym;

    if (    (tId^.Structure^.sSymbol = TypeSym)
        and not tId^.Structure^.boPointer) then
      tSt^.t := tId^.Structure^.t
     else tSt^.t := tId;

    GetSymbol;
    if ((Symbol = Ident) and (short(id) = 'ABSOLUTE')) then HandleAbsolute;
   end
    else GetVarType2(tSt);
end;


procedure ConstDeclaration;
var
  bTotRange : byte;
  lPtr : longint;
  p : pArFFFE;
  tId: pIdentifier;
  tRa : pRange;
  tSt : pStructure;
  w1, w2 : word;

 procedure WriteArConst(b : byte; tSt : pStructure);
 var
   tSt2 : pStructure;
   sy : tSymbol;
   w1 : word;
 begin
   sy := tSt^.ArStruc^.sSymbol;

   if (b >= 1) then
    begin
{ find appropriate range }
     tRa := tSt^.ArRange;
     for w1 := b to bTotRange-1 do tRa := tRa^.nRange;

     GetSymbol;
     if (Symbol = CharVal) then Symbol := StringVal;

     if (   (b > 1)
         or (    (b = 1)
             and (   ((sy = CharSym) and (Symbol = lParent))
                  or ((b = 1) and (sy <> CharSym))))) then
      begin
       if not CheckSymbol(lParent) then exit;
       Symbol := Comma;

       for w1 := 1 to tRa^.lEnd - tRa^.lBegin + 1 do
        begin
         if not CheckSymbol(Comma) then exit;
         WriteArConst(b - 1, tSt);
        end;

       if not CheckSymbol(rParent) then exit;
       GetSymbol;
      end
       else

     if (Symbol = StringVal) then
      begin
       w2 := tRa^.lEnd - tRa^.lBegin + 1;

       if length(sString) > w2 then
        begin Error(25); exit; end;

       if Array2Symbol(tSt) = CharSym then
        begin
         for w1 := 1 to length(sString) do
          begin
           p^[lPtr] := ord(sString[w1]);
           inc(lPtr);
          end;
        end
       else
        begin
         p^[lPtr] := length(sString);
         if length(sString) < w2 then sString := ml(sString, w2, True);
         inc(lPtr);

         for w1 := 1 to w2 do
          begin
           p^[lPtr] := ord(sString[w1]);
           inc(lPtr);
          end;
        end;

       GetSymbol;
      end
     else Error(21);
    end
   else
    begin
     if not CheckSymbol(Comma) then exit;
     GetSymbol;
     new(tSt2);
     tSt2^.boPointer := False;
     Calculation(tSt2, 0);

     if not CompareSymbol(tSt2^.sSymbol, sy, Eql) then
      begin
       DisposeStructure(tSt2);
       Error(26);
       exit;
      end;

     case sy of
       ByteSym : begin
         p^[lPtr] := tSt2^.l and $FF;
         inc(lPtr);
        end;
       CharSym : begin
         p^[lPtr] := ord(tSt2^.c);
         inc(lPtr);
        end;
       FalseSym : begin
         p^[lPtr] := conFalse;
         inc(lPtr);
        end;
       IntSym,
       WordSym : begin
         p^[lPtr] := lo(tSt2^.l);
         inc(lPtr);
         p^[lPtr] := hi(tSt2^.l);
         inc(lPtr);
        end;
       LongSym : begin
         p^[lPtr] := lo(tSt2^.l and $FFFF);
         inc(lPtr);
         p^[lPtr] := hi(tSt2^.l and $FFFF);
         inc(lPtr);
         p^[lPtr] := lo((tSt2^.l shr 16) and $FFFF);
         inc(lPtr);
         p^[lPtr] := hi((tSt2^.l shr 16) and $FFFF);
         inc(lPtr);
        end;
       StringSym : begin
         w2 := tSt^.ArSize - 1;

         if tSt2^.StrSize > w2 then
          begin Error(25); exit; end;

         sString := tSt2^.s^;
         p^[lPtr] := tSt2^.StrSize;
         if length(sString) < w2 then sString := ml(sString, w2, True);
         inc(lPtr);

         for w1 := 1 to w2 do
          begin
           p^[lPtr] := ord(sString[w1]);
           inc(lPtr);
          end;
        end;
       TrueSym : begin
         p^[lPtr] := conTrue;
         inc(lPtr);
        end;
      end;

     DisposeStructure(tSt2);
    end;
 end;

begin
  UpdateStart := True;
  if not GetCheckSymbol(ident) then exit;

  while Symbol = ident do
   begin
    tId := NewIdent;
    tId^.Group := konst;
    tId^.UnitName := sPasFile;
    tId^.AssName := VarName(tId);

    new(tSt);
    tId^.Structure := tSt;
    tSt^.sSymbol := UnknownSym;
    tSt^.s := nil;
    tSt^.rs := nil;
    tSt^.boPointer := False;

    GetSymbol;
    GetSymbol;

    if (PrevSymbol = colon) then
     begin
{ Typed constants }
      GetVarType(tSt);
      if not CheckSymbol(eql) then exit;

      if (tSt^.sSymbol = ArraySym) then
       begin
{ How many dimensions? }
        bTotRange := 1;
        lPtr := 0;
        tRa := tSt^.ArRange;

        while (tRa^.nRange <> nil) do
         begin
          inc(bTotRange);
          tRa := tRa^.nRange;
         end;

        tId^.Size := SubSize(tSt, True);
        tSt^.DataSize := tId^.Size;
        GetMem(tSt^.DataPtr, tSt^.DataSize);
        p := tSt^.DataPtr;
        WriteArConst(bTotRange, tSt);
       end
      else
       begin
        GetSymbol;
        Calculation(tSt, 0);
        if tSt^.sSymbol = StringSym then tSt^.StrSize := length(tSt^.s^);
       end;
     end
      else

    if (PrevSymbol = eql) then
     begin
      Calculation(tSt, 0);
      if tSt^.sSymbol = StringSym then tSt^.StrSize := length(tSt^.s^);
     end
    else
     begin
      Error(90);
      exit;
     end;

    tId^.Structure := tSt;
    EnterIdGlobal(tId);

    if Symbol = semicolon then
     begin
      GetSymbol;
      if not (Symbol in BlockSys + [ident, ImplemSym]) then Error(21);
     end
      else Error(85);
   end;
end; {ConstDeclaration}


procedure LabelDeclaration;
var
  tId : pIdentifier;
  tSt: pStructure;
begin
  UpdateStart := False;
  if not GetCheckSymbol(ident) then exit;

  repeat
   tId := SearchId(id, '', Top, False);
   if (tId <> nil) then begin Error(4); exit; end;  { name exists }

   new(tSt);
   tSt^.sSymbol := LabelSym;
   tSt^.boPointer := False;

   tId := NewIdent;
   tId^.AssName := VarName(tId);
   tId^.UnitName := sPasFile;
   tId^.Structure := tSt;
   EnterIdGlobal(tId);
   CalcStart(tId);
   GetSymbol;
   if (Symbol = comma) then GetSymbol;
  until Symbol <> ident;

  if not CheckSymbol(semicolon) then exit;
  GetSymbol;
end;


procedure TypeDeclaration;
var
  b : byte;
  name : alfa;
  tId, tId2, tId3, tId4 : pIdentifier;
  tSt : pStructure;
begin
  UpdateStart := False;

  if not GetCheckSymbol(ident) then exit;

  while Symbol = ident do
   begin
    name := id;
    if not GetCheckSymbol(eql) then exit;
    GetSymbol;
    new(tSt);
    tId := NewIdent;
    tId^.group := Types;
    tId^.Structure := tSt;
    tId^.Size := 0;

    tSt^.boPointer := (Symbol = dakje);         { pointer assignment }
    if tSt^.boPointer then
     begin
      GetSymbol;

      if not (Symbol in [ByteSym, IntSym, LongSym, WordSym, RealSym, ident,
                         CharSym, StringSym]) then
       begin Error(26); exit; end;
     end;

    if (Symbol in ConstSys + [RangeVal]) then
     begin
      if (Symbol = ident) then
       begin
        tId2 := SearchIdAll(Id, '', Top, True);

        if (tId2 = nil) then
         begin
          if tSt^.boPointer then
           begin

{**  Pointer is already declared before the type itself  **}
            tSt^.sSymbol := To_do;
            new(tSt^.s);
            tSt^.s^ := id;              { save the name for later look-up }
            GetSymbol;
           end
          else begin Error(26); exit; end;
         end
          else

        if (tId2^.Group = Types) then
         begin
          tSt^.sSymbol := TypeSym;

          if (    (tId2^.Structure^.sSymbol = TypeSym)
              and not tId2^.Structure^.boPointer) then
            tSt^.t := tId2^.Structure^.t
           else tSt^.t := tId2;

          GetSymbol;
         end
          else

        if (tId2^.Group = Konst) then
         begin
          Error(301); exit;
          tSt^.sSymbol := RangeSym;     {#### never tested }
{          tSt^.Range := CreateRange;}
         end
        else begin Error(31); exit; end;
       end
      else
       begin
        Error(302); exit;
        tSt^.sSymbol := RangeSym;       {#### never tested }
{        tSt^.Range := CreateRange;}
       end;
     end
      else
    if (Symbol = lParent) then
     begin
      tSt^.sSymbol := SetSym;
      b := 0;
      new(tId3);
      tId3^.ProcVar := False;
      tSt^.tSet := tId3;

      repeat
       if not GetCheckSymbol(ident) then exit;

       tId3^.group := Konst;
       tId3^.name := '';
       tId3^.nlink := nil;

       tId2 := SearchIdAll(id, '', Top, False);
       if (tId2 <> nil) then begin Error(4); exit; end;  { name exists }

       new(tId3^.Structure);
       tId3^.Structure^.sSymbol := SetItemSym;
       tId3^.Structure^.si := b;
       tId3^.Structure^.boPointer := False;
       tId3^.Size := SetItemSize;
       tId3^.name := id;
       tId3^.Start := b;
       tId3^.AssName := '';
       tId3^.UnitName := sPasFile;
       tId3^.Level := UnitLevel;
       if (b = 0) then EnterIdGlobal(tId3);
       inc(b);
       GetSymbol;

       if (Symbol = comma) then
        begin
         new(tId2);
         tId3^.nlink := tId2;
         tId3 := tId2;
{
 Remark: because of direct coupling, "EnterIdGlobal" is not needed
}
        end;
      until (Symbol <> comma);

      if not CheckSymbol(rParent) then exit;
      GetSymbol;
     end
      else
    if tSt^.boPointer then GetVarType2(tSt) else
     GetVarType(tSt);

    if not CheckSymbol(semicolon) then exit;

    tId^.name := name;
    tId^.AssName := '';
    tId^.UnitName := sPasFile;
    tId^.Level := UnitLevel;
    tId^.nlink := nil;
    CalcStart(tId);
    EnterIdGlobal(tId);

    if Symbol = semicolon then
     begin
      GetSymbol;

      if not (Symbol in BlockSys + [ident]) then
       begin Error(26); exit; end;
     end
      else Error(85);
   end;


{ Check all possible TO_DO types }
  tId := Identifier[bNowUnit][Top];
  while (tId <> nil) do
   begin
    if (tId^.Structure^.sSymbol = To_do) then
     begin
      tId2 := SearchId(tId^.Structure^.s^, '', Top, False);
      dispose(tId^.Structure^.s);

      if (tId2 = nil) then begin Error(3); exit; end;
      if (tId2^.Group <> Types) then begin Error(26)
      ; exit; end;

      tId^.Structure^.sSymbol := TypeSym;

      if (    (tId2^.Structure^.sSymbol = TypeSym)
          and not tId2^.Structure^.boPointer) then
       tId^.Structure^.t := tId2^.Structure^.t
      else tId^.Structure^.t := tId2;
     end;

    tId := tId^.nlink;
   end;
end; {TypeDeclaration}


procedure VarDeclaration;
begin
  UpdateStart := True;
  if not GetCheckSymbol(ident) then exit;
  GetVarIdentifier(False, False, False);
end; {VarDeclaration}


procedure ProcDeclaration(IsFunction, IsUnit : boolean);
var
  sExitOrg, sFunctionNowOrg : alfa;
  b : byte;
  NotFound, First : boolean;
  lRelStack : longint;
  tId, tId2 : pIdentifier;
  tSt, tSt2 : pStructure;
  tWs : pWithStruc;
  pst, pst2 : string;
label PL1;
begin
  if not GetCheckSymbol(ident) then exit;   { name of procedure/function }

  sFunctionNowOrg := sFunctionNow;
  tId := SearchId(id, '', Top, False);
  NotFound := (tId = nil);

  if NotFound then
   begin
    new(tSt);
    if IsFunction then tSt^.sSymbol := FuncSym
     else tSt^.sSymbol := ProcSym;
    tSt^.Parameters := nil;
    tSt^.Functie := nil;
    tSt^.boPointer := False;
    tSt^.IsCompiled := False;

    tId := NewIdent;
    tId^.size := 0;
    tId^.AssName := VarName(tId);
    tId^.UnitName := sPasFile;
    tId^.Structure := tSt;
    tId^.Group := Unknown;
    EnterIdGlobal(tId);
   end
  else
   begin
    if (tId^.Group <> FPforward) then begin Error(4); exit; end;
    tSt := tId^.Structure;
   end;

  inc(BlockLevel);
  idProcParms[BlockLevel] := nil;
  inc(Top);                             { new level for identifiers }
  GetSymbol;

  if (Symbol = lParent) then            { parameters }
   begin
    GetSymbol;
    idProcParms[BlockLevel] := GetVarIdentifier(False, True, True);

    if not CheckSymbol(rParent) then
     begin
      dec(Top);
      exit;
     end;

    if NotFound then
     begin
      tSt^.Parameters := idProcParms[BlockLevel];
      tId2 := idProcParms[BlockLevel];

      while tId2 <> nil do
       begin
        tId2^.AssName[1] := 'P';
        tId2 := tId2^.nlink;
       end;
     end;

    GetSymbol;
   end;

  sFunctionNowOrg := sFunctionNow;
  sFunctionNow := '';
  sExitOrg := sExit;
  sExit := NextLabel;

  if IsFunction then                    { check for colon and type }
   begin
    sFunctionNow := tId^.name;
    if not CheckSymbol(colon) then goto PL1;
    GetSymbol;

    if (Symbol in [ident, BoolSym, ByteSym, CharSym, IntSym, LongSym, RealSym,
                   StringSym, WordSym]) then
     begin
      new(tSt2);
      GetVarType(tSt2);

      if NotFound then tSt^.Functie := TsT2
       else DisposeStructure(tSt2);
     end
    else begin Error(26); goto PL1; end;
   end;


{ Store / compare with original declaration }
  pst := upper(short(sRegel));
  pst2 := sRegel;

  while (pos(' ', pst) > 0) do
   begin
    b := pos(' ', pst);
    pst := copy(pst, 1, b-1) + copy(pst, b+1, length(pst) - b);
   end;


{
 Check found parameters against possible forward.
  the trick: just compare the text :)
}
  if NotFound then tSt^.OrgDeclaration := nil else
   begin
    if (tSt^.OrgDeclaration^ <> pst) then
     begin                              { forward not equal to declaration }
      Error(131);
      goto PL1;
     end;
   end;

  if not CheckSymbol(semicolon) then exit;

  GetSymbol;
  if ((Symbol = ForwardSym) or IsUnit) then
   begin
    if (tId^.Group <> Unknown) then
     begin
      Error(4);                         { already forwarded or declared? }
      goto PL1;
     end;

    tId^.Group := FPforward;            { mark as forwarded }

    if not IsUnit then
     if not GetCheckSymbol(semicolon) then exit;

    new(tSt^.OrgDeclaration);
    tSt^.OrgDeclaration^ := pst;
   end
  else
   begin
    if (tId^.Group = ProcFunc) then
     begin
      Error(4);                         { already defined }
      goto PL1;
     end;

    tId^.Group := ProcFunc;             { mark as defined }
    pst2[0] := pred(pst2[0]);
    Wr2ASMbodyLn(tId^.AssName);
    Wr2ASMbodyLn('; ' + pst2);
    Block(tId);
    if not CheckSymbol(semicolon) then exit;
    Wr2ASMbodyLn(sExit + ' ; End of subroutine/function');
    Wr2ASMbodyLn('');
   end;

  if not IsUnit then GetSymbol;

PL1:
  sFunctionNow := sFunctionNowOrg;
  sExit := sExitOrg;
  if not NotFound then DisposeIdentifier(idProcParms[BlockLevel]);
  idProcParms[BlockLevel] := nil;
  DisposeIdentifier(Identifier[bNowUnit][Top]);
  Identifier[bNowUnit][Top] := nil;
  dec(Top);                             { return to original level }
  dec(BlockLevel);
end;


procedure StoreReservedVar(tRe1 : Result; boIsUsed : boolean);
var
  tId : pIdentifier;
  tSt : pStructure;
begin
  tId := NewIdent;
  tId^.ProcVar := False;
  tId^.name := tRe1.Name;
  tId^.AssName := tRe1.Name;
  tId^.UnitName := sPasFile;
  tId^.Group := konst;
  tId^.boUsed := boIsUsed;
  new(tSt);
  tId^.Structure := tSt;
  tSt^.sSymbol := tRe1.Symbol;
  tSt^.s := nil;
  tSt^.boPointer := False;
  EnterIdLocal(tId,  Identifier[bNowUnit][0]);

  if (tRe1.Symbol = CharSym) then tSt^.c := tRe1.c else
  if (tRe1.Symbol in [WordSym, IntSym]) then tSt^.l := tRe1.l else
  if (tRe1.Symbol in [LongSym, PointSym]) then tSt^.l := tRe1.l else
  if (tRe1.Symbol = ByteSym) then tSt^.l := tRe1.l else
  if (tRe1.Symbol = SetItemSym) then tSt^.si := tRe1.l else
  if (tRe1.Symbol = BoolSym) then tSt^.b := tRe1.b else
  if (tRe1.Symbol = RealSym) then
   begin
    tSt^.r := tRe1.r;
    tSt^.rs := nil;

    if tRe1.s <> nil then
     begin
      new(tSt^.rs);
      tSt^.rs^ := tRe1.s^;
     end;
   end
    else

  if (tRe1.Symbol = StringSym) then
   begin
    new(tSt^.s);
    tSt^.s^ := tRe1.s^;
   end;
end;


procedure StoreKonst(var tRe1 : Result);
{--------------------------------------------------------------------------
Stores any found constant into the memory of the compiler and, as it is in
RAM now, marks it as a variable.
--------------------------------------------------------------------------}
var
  Found : boolean;
  tId : pIdentifier;
  tSt : pStructure;
  pst : str80;
  w, w2, w3 : word;
begin
  if (tRe1.Name <> '') then
   begin
    if ((tRe1.Symbol = StringSym) and (tRe1.s <> nil)) then dispose(tRe1.s);
    tRe1.s := nil;
    tRe1.Group := Vars;
   end
  else
   begin
    tId := Identifier[bNowUnit][0];
    Found := False;

    while ((tId <> nil) and not Found) do
     begin
      if (    (tId^.Group = Konst)
          and (tId^.Structure^.sSymbol = tRe1.Symbol)) then
       begin
        if tRe1.Symbol = StringSym then
             Found := (tId^.Structure^.s^ = tRe1.s^) else
        if tRe1.Symbol = CharSym then
             Found := (tId^.Structure^.c = tRe1.c) else
        if tRe1.Symbol = SetItemSym then
             Found := (tId^.Structure^.si = tRe1.l) else
        if tRe1.Symbol = RealSym then
             Found := (tId^.Structure^.r = tRe1.r) else
        if tRe1.Symbol in [WordSym, IntSym, LongSym, ByteSym] then
             Found := (tId^.Structure^.l = tRe1.l) else
        if tRe1.Symbol = BoolSym then
             Found := (tId^.Structure^.b = tRe1.b);
       end;

      if not Found then tId := tId^.nlink;
     end;

    if Found then
     begin
      tRe1.Name := tId^.AssName;
      tId^.boUsed := True;
     end
    else
     begin
      tRe1.Name := KonName;
      StoreReservedVar(tRe1, True);
     end;

    if tRe1.Symbol = StringSym then
     begin
      dispose(tRe1.s);
      tRe1.s := nil;
     end;

    tRe1.Group := Vars;

    if (tRe1.Symbol = CharSym) then tRe1.OrgName := tRe1.c else
    if (tRe1.Symbol in [WordSym, IntSym]) then
     tRe1.OrgName := '$' + Dec2Hex(tRe1.l, 4) else
    if (tRe1.Symbol = LongSym) then
     tRe1.OrgName := '$' + Dec2Hex(tRe1.l, 8) else
    if (tRe1.Symbol = ByteSym) then
     tRe1.OrgName := '$' + Dec2Hex(tRe1.l, 2) else
    if (tRe1.Symbol = RealSym) then
     begin
      if tRe1.s = nil then tRe1.OrgName := Real2String(tRe1.r) else
       begin
        tRe1.OrgName := tRe1.s^;
        dispose(tRe1.s);
        tRe1.s := nil;
       end;
     end;
   end;
end;


procedure StoreVar(var tRe1 : Result);
var a : alfa;
begin

{###  Hmmmm, what if tRe1.Name already is a result ie. $xxxx ??? }

  dec(tRe1.Offset, tRe1.l);
  a := ' $' + Dec2Hex(tRe1.Offset, 4);
  Wr2ASMbodyLn(' macVar2Stack ' + tRe1.Name + a);
  tRe1.Name := a;
end;


procedure GetParameter1(var tRe1 : Result; var pst : str80; SoS : SetOfSymbol);
begin
  GetSymbol;
  ClearTre(tRe1);
  Coding(tRe1, 0, 1);

  if (tRe1.Group = Konst) then StoreKonst(tRe1);

  if (SoS <> [AllSym]) then
   if not (tRe1.Symbol in SoS) then Error(26);

  if (tRe1.Group = Vars) then pst := pst + ' ' + tRe1.name
   else pst := pst + ' DStack-$' + Dec2Hex(tRe1.Offset, 4);

  pst := pst + ' ' + Symbol2Type(tRe1.Symbol);
end;


procedure GetParameter2(var tRe1 : Result; var pst : str80; SoS : SetOfSymbol);
begin
  GetSymbol;
  ClearTre(tRe1);
  Codeterm(tRe1);

  if (SoS <> [AllSym]) then
   if not (tRe1.Symbol in SoS) then Error(26);

  if not (tRe1.Group in [Vars, ASMstring]) then Error(26);
  pst := pst + ' ' + tRe1.name;
end;


procedure AddrProc(var tRe1 : Result; pbo : boolean);
{
 function Addr(X): pointer;
}
var
  tId : pIdentifier;
  pst : str80;
begin
  if pbo and not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack + PointerSize;
  pst := '';
  GetParameter2(tRe1, pst, [AllSym]);

  Wr2ASMbodyLn(' macAddrProc ' + pst + ' $' + Dec2Hex(tRe1.Offset, 4));

  if pbo and not CheckSymbol(rParent) then exit;
  tRe1.Group := ASMstring;
  tRe1.Symbol := PointSym;
  GetSymbol;
end;


procedure CopyDeleteProc(var tRe1 : Result; bo : boolean);
{
 Delete(var S: String; Index: Integer; Count:Integer);
  True  : Copy
  False : Delete
}
var
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';

  if bo then GetParameter1(tRe1, pst, AllCharSys)
   else GetParameter2(tRe1, pst, AllCharSys);

  if not CheckSymbol(comma) then exit;
  GetParameter1(tRe1, pst, AllNumberSys);
  if not CheckSymbol(comma) then exit;
  GetParameter1(tRe1, pst, AllNumberSys);

  if bo then Wr2ASMbodyLn(' macCopy ' + pst)
   else Wr2ASMbodyLn(' macDelete ' + pst);

  if not CheckSymbol(rParent) then exit;
  tRe1.Group := ASMstring;
  tRe1.Symbol := StringSym;
  GetSymbol;
end;


procedure DiskProc(var tRe1 : Result; b : byte);
{
}
var
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, AllNumberSys);

  case b of
    0 : Wr2ASMbodyLn(' macDiskFreeProc ' + pst);
    1 : Wr2ASMbodyLn(' macDiskSizeProc ' + pst);
   end;

  if not CheckSymbol(rParent) then exit;
  tRe1.Group := ASMstring;
  tRe1.Symbol := LongSym;
  GetSymbol;
end;


procedure EofEolnProc(var tRe1 : Result; bo : boolean);
{
 Typed or untyped files: function Eof(var F): Boolean;
 Text files: function Eof [ (var F: Text) ]: Boolean;
  True:  Eof
  False: Eoln
}
var
  tId1 : pIdentifier;
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  pst := '';
  tRe1.Offset := lStack;
  GetParameter1(tRe1, pst, [FileSym, TextSym]);

  if bo then Wr2ASMbodyLn(' macEof ' + pst)
   else Wr2ASMbodyLn(' macEoln ' + pst);

  if not CheckSymbol(rParent) then exit;
  tRe1.Group := ASMstring;
  tRe1.Symbol := BoolSym;
  GetSymbol;
end;


procedure FileProc(b : byte);
{
 function FilePos(var f) : longint;
 function FileSize(var f) : longint;
 procedure Close(var f);
 procedure Erase(var f);
}
var
  tRe1 : Result;
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter2(tRe1, pst, [FileSym, TextSym]);

  case b of
    0 : Wr2ASMbodyLn(' macFilePos ' + pst);
    1 : Wr2ASMbodyLn(' macFileSize ' + pst);
    2 : Wr2ASMbodyLn(' macCloseFile ' + pst);
    3 : Wr2ASMbodyLn(' macEraseFile ' + pst);
   end;

  if not CheckSymbol(rParent) then exit;
  tRe1.Symbol := LongSym;
  tRe1.Group := ASMstring;
  GetSymbol;
end;


procedure IntProc(var tRe1 : Result);
{
 Int(X: Real): Real;
}
var
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, [RealSym] + NumberSys);
  tRe1.Offset := tRe1.Offset + Symbol2Size(RealSym);
  tRe1.OrgName := Dec2Hex(tRe1.Offset, 4);
  pst := pst + ' ' + tRe1.OrgName;
  tRe1.Group := ASMstring;

  if tRe1.boDirect then Wr2ASMbodyLn(' macIntProc ' + pst)
    else Wr2ASMbodyLn(' macIntIndProc ' + pst);

  if not CheckSymbol(rParent) then exit;
  tRe1.Group := ASMstring;
  tRe1.Symbol := RealSym;
  tRe1.boDirect := True;
  GetSymbol;
end;


procedure MemPortProc(var tRe1 : Result; ty : byte; mp : boolean; ch : char);
var
  pst : str80;
begin
  if not GetCheckSymbol(lBrack) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, NumberSys);

  if mp then
   begin
    if not CheckSymbol(colon) then exit;

    if not tRe1.boDirect then
     begin
      tRe1.Offset := tRe1.Offset + 4;
      pst := 'Ind ' + pst + ' ' + Dec2Hex(tRe1.Offset, 4);
     end;

    Wr2ASMbodyLn(' macMemP0' + pst);
    pst := '';
    GetParameter1(tRe1, pst, NumberSys);
   end;

  if not CheckSymbol(rBrack) then exit;

  case ty of
    0 : tRe1.Symbol := ByteSym;
    1 : tRe1.Symbol := WordSym;
    2 : tRe1.Symbol := LongSym;
   end;

  tRe1.Offset := tRe1.Offset + 4;
  pst := pst + ' ' + Dec2Hex(tRe1.Offset, 4) + ' ' + Symbol2Type(tRe1.Symbol);
  if not tRe1.boDirect then pst := 'Ind ' + pst;

  if mp then Wr2ASMbodyLn(' macMem' + ch + pst)
   else Wr2ASMbodyLn(' macPort' + ch + pst);

  tRe1.boDirect := True;
  tRe1.Group := ASMstring;
end;


procedure fMemPortProc(var tRe1 : Result; ty : byte; mp : boolean);
var
  ch : char;
begin
  MemPortProc(tRe1, ty, mp, 'F');

{
  if not GetCheckSymbol(lBrack) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, NumberSys);

  if (Symbol = Colon) then GetParameter1(tRe1, pst, NumberSys)
   else pst := '0 $FF ' + pst;

  case ty of
    0 : tRe1.Symbol := ByteSym;
    1 : tRe1.Symbol := WordSym;
    2 : tRe1.Symbol := LongSym;
   end;

  pst := pst + ' ' + Dec2Hex(tRe1.Offset + 4, 4)
          + ' ' + Symbol2Type(tRe1.Symbol);

  if (mp = 0) then Wr2ASMbodyLn(' macMemF ' + pst)
   else Wr2ASMbodyLn(' macPortF ' + pst);

  if not CheckSymbol(rBrack) then exit;
  tRe1.Group := ASMstring;
  GetSymbol;
}
  if mp then Wr2ASMbodyLn(' macMemP2 ');
end;


procedure MemavailProc(var tRe1 : Result; b : byte);
begin
  case b of
    0 : Wr2ASMbodyLn(' macMaxAvail $' + Dec2Hex(tRe1.Offset + 4, 4));
    1 : Wr2ASMbodyLn(' macMemAvail $' + Dec2Hex(tRe1.Offset + 4, 4));
   end;

  tRe1.Group := ASMstring;
  tRe1.Symbol := LongSym;
  GetSymbol;
end;


procedure OfsSegProc(var tRe1 : Result; pbo : boolean);
{
 function Ofs(X): Word;
 function Seg(X): Word;
}
var
  tId : pIdentifier;
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack + PointerSize;
  pst := '';
  GetParameter1(tRe1, pst, [AllSym]);

  if pbo then
   Wr2ASMbodyLn(' macOfs ' + pst + ' $' + Dec2Hex(tRe1.Offset, 4))
  else
   Wr2ASMbodyLn(' macSeg ' + pst + ' $' + Dec2Hex(tRe1.Offset, 4));

  if not CheckSymbol(rParent) then exit;
  tRe1.Group := ASMstring;
  tRe1.Symbol := WordSym;
  GetSymbol;
end;


procedure ParamcountProc(var tRe1 : Result);
{
 function Paramcount : Byte;
}
var
  pst : str80;
begin
  Wr2ASMbodyLn(' macParamcount ');
  tRe1.Group := ASMstring;
  tRe1.Symbol := ByteSym;
  GetSymbol;
end;


procedure ParamstrProc(var tRe1 : Result);
{
 function Paramstr(Index) : String;
}
var
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, NumberSys);

  Wr2ASMbodyLn(' macParamstr ' + pst);

  tRe1.Group := ASMstring;
  if not CheckSymbol(rParent) then exit;
  tRe1.Symbol := StringSym;
  GetSymbol;
end;


procedure PosProc(var tRe1 : Result);
{
 function Pos(Substr: String; S: String): Byte;
}
var
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, AllCharSys);
  if not CheckSymbol(comma) then exit;
  GetParameter1(tRe1, pst, AllCharSys);

  Wr2ASMbodyLn(' macPos ' + pst);

  tRe1.Group := ASMstring;
  if not CheckSymbol(rParent) then exit;
  tRe1.Symbol := ByteSym;
  GetSymbol;
end;


procedure PtrProc(var tRe1 : Result);
{
 function Ptr(Seg, Ofs: Word): Pointer;
}
var
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, AllNumberSys);

  if (Symbol = Comma) then GetParameter2(tRe1, pst, AllNumberSys)
   else pst := pst + ' 0';

  Wr2ASMbodyLn(' macPrt ' + pst);

  if not CheckSymbol(rParent) then exit;
  tRe1.Group := ASMstring;
  tRe1.Symbol := PointSym;
  GetSymbol;
end;


procedure RandomProc(var tRe1 : Result);
var
  tId : pIdentifier;
  pst : str80;
begin
  if (Symbol = lParent) then
   begin
    tRe1.Offset := lStack;
    pst := '';
    GetParameter1(tRe1, pst, [RealSym] + NumberSys);
    if not CheckSymbol(rParent) then exit;
   end
  else
   begin
    pst := ' 0';
    tRe1.Symbol := RealSym;
   end;

  Wr2ASMbodyLn(' macRandom ' + pst);

  tRe1.Group := ASMstring;
  GetSymbol;
end;


procedure SizeOfProc(var tRe1 : Result);
var
  tId : pIdentifier;
  pst : str80;
begin
  if not CheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter2(tRe1, pst, [AllSym]);
  if not CheckSymbol(rParent) then exit;

{ tRe1.l contains length of variable, store it }
  tRe1.Group := Konst;
  tRe1.Symbol := LongSym;
  StoreKonst(tRe1);
  GetSymbol;
end;


procedure SqrProc(var tRe1 : Result);
var
  tId : pIdentifier;
  pst : str80;
begin
  if not CheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, [RealSym] + NumberSys);
  if not CheckSymbol(rParent) then exit;

  Wr2ASMbodyLn(' macSqr ' + pst);

  tRe1.Group := ASMstring;
  GetSymbol;
end;


procedure UpcaseProc(var tRe1 : Result);
var
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, [CharSym]);

  Wr2ASMbodyLn(' macUpcase ' + pst);

  if not CheckSymbol(rParent) then exit;
  tRe1.Group := ASMstring;
  tRe1.Symbol := CharSym;
  GetSymbol;
end;


procedure OneRealProc(var tRe1 : Result; b : byte);
var
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, [RealSym] + NumberSys);

  case b of
    0 : Wr2ASMbodyLn(' macArcTan ' + pst);
    1 : Wr2ASMbodyLn(' macCos ' + pst);
    2 : Wr2ASMbodyLn(' macExp ' + pst);
    3 : Wr2ASMbodyLn(' macLn ' + pst);
    4 : Wr2ASMbodyLn(' macSin ' + pst);
    5 : Wr2ASMbodyLn(' macTan ' + pst);
    6 : Wr2ASMbodyLn(' macFrac ' + pst);
    7 : Wr2ASMbodyLn(' macSqrt ' + pst);
   end;

  if not CheckSymbol(rParent) then exit;
  tRe1.Group := ASMstring;
  tRe1.Symbol := RealSym;
  GetSymbol;
end;


procedure OneOutProc(var tRe1 : Result; b : byte);
begin
  case b of
    0 : Wr2ASMbodyLn(' macWhereX $' + Dec2Hex(tRe1.Offset, 4));
    1 : Wr2ASMbodyLn(' macWhereY $' + Dec2Hex(tRe1.Offset, 4));
    2 : Wr2ASMbodyLn(' macKeyPressed $' + Dec2Hex(tRe1.Offset, 4));
    3 : Wr2ASMbodyLn(' macReadKey $' + Dec2Hex(tRe1.Offset, 4));
   end;

  case b of
    0, 1 : tRe1.Symbol := WordSym;
    2 : tRe1.Symbol := BoolSym;
    3 : tRe1.Symbol := CharSym;
   end;

  tRe1.Group := ASMstring;
  GetSymbol;
end;


procedure CodeTerm(var tRe1 : Result);
{
}
var
  arLo : array[1..MaxSubArray+1] of longint;
  boFirst : boolean;
  bSubRange, by : byte;
  c : char;
  i : integer;
  OrgDS, plo, lOffset, lCount : longint;
  tCs : pCaseStruc;
  tId, tId2 : pIdentifier;
  tRa : pRange;
  tSt : pStructure;
  tRe2, tRe3 : Result;
  pst, pst2 : Str80;
  sy, fSymbolOrg : tSymbol;
label L1, L2, L3;

 procedure AddTre2Tre1;
 begin
   if ((tRe2.Group = Konst) and (tRe2.l = 0)) then exit;

   if (tRe2.Group = Konst) then StoreKonst(tRe2);

   if (tRe2.Group = Vars) then pst := tRe2.Name
    else pst := 'DStack-$' + Dec2Hex(tRe2.Offset, 4);

   Wr2ASMbodyLn(' macPlusLo ' + Symbol2Type(LongSym)
                   + ' DStack-$' + Dec2Hex(tRe1.Offset, 4)
                   + ' '  + Symbol2Type(tRe2.Symbol)
                   + ' '  + pst
                   + ' ' + Dec2Hex(tRe1.Offset, 4));
 end;

begin
  if (Symbol = NilSym) then
   Symbol := Ident;

  if (Symbol = AtSym) then
   begin
    AddrProc(Tre1, False);
    exit;
   end
    else

  if (Symbol = MemSym) then fMemPortProc(Tre1, 0, True)
    else

  if (Symbol = MemLSym) then fMemPortProc(Tre1, 2, True)
    else

  if (Symbol = MemWSym) then fMemPortProc(Tre1, 1, True)
    else

  if (Symbol = PortSym) then fMemPortProc(Tre1, 0, False)
    else

  if (Symbol = PortWSym) then fMemPortProc(Tre1, 1, False)
    else

  if (Symbol = Ident) then
   begin
    pst := upper(short(id));

    if (pst = 'ADDR') then begin AddrProc(Tre1, True); exit; end;
    if (pst = 'ARCTAN') then begin OneRealProc(Tre1, 0); exit; end;
    if (pst = 'COPY') then begin CopyDeleteProc(Tre1, True); exit; end;
    if (pst = 'COS') then begin OneRealProc(Tre1, 1); exit; end;
    if (pst = 'DISKFREE') then begin DiskProc(Tre1, 0); exit; end;
    if (pst = 'DISKSIZE') then begin DiskProc(Tre1, 0); exit; end;
    if (pst = 'EOF') then begin EofEolnProc(Tre1, True); exit; end;
    if (pst = 'EOLN') then begin EofEolnProc(Tre1, False); exit; end;
    if (pst = 'EXP') then begin OneRealProc(Tre1, 2); exit; end;
    if (pst = 'FILEPOS') then begin FileProc(0); exit; end;
    if (pst = 'FILESIZE') then begin FileProc(1); exit; end;
    if (pst = 'FRAC') then begin OneRealProc(Tre1, 6); exit; end;
    if (pst = 'INT') then begin IntProc(Tre1); exit; end;
    if (pst = 'KEYPRESSED') then begin OneOutProc(tRe1, 2); exit; end;
    if (pst = 'LN') then begin OneRealProc(Tre1, 3); exit; end;
    if (pst = 'MAXAVAIL') then begin MemavailProc(Tre1, 0); exit; end;
    if (pst = 'MEMAVAIL') then begin MemavailProc(Tre1, 1); exit; end;
    if (pst = 'OFS') then begin OfsSegProc(Tre1, True); exit; end;
    if (pst = 'PARAMCOUNT') then begin ParamcountProc(Tre1); exit; end;
    if (pst = 'PARAMSTR') then begin ParamstrProc(Tre1); exit; end;
    if (pst = 'POS') then begin PosProc(Tre1); exit; end;
    if (pst = 'PTR') then begin PtrProc(Tre1); exit; end;
    if (pst = 'READKEY') then begin OneOutProc(tRe1, 3); exit; end;
    if (pst = 'SEG') then begin OfsSegProc(Tre1, False); exit; end;
    if (pst = 'SIN') then begin OneRealProc(Tre1, 4); exit; end;
    if (pst = 'SIZEOF') then begin SizeOfProc(Tre1); exit; end;
    if (pst = 'SQRT') then begin OneRealProc(Tre1, 7); exit; end;
    if (pst = 'TAN') then begin OneRealProc(Tre1, 5); exit; end;
    if (pst = 'UPCASE') then begin UpcaseProc(Tre1); exit; end;
    if (pst = 'WHEREX') then begin OneOutProc(tRe1, 0); exit; end;
    if (pst = 'WHEREY') then begin OneOutProc(tRe1, 1); exit; end;

    tId := SearchIdAll(Id, '', Top, True);
    if (tId = nil) then begin Error(3); exit; end;

    tSt := tId^.Structure;
    tRe1.Group := tId^.Group;
    Struc2Result(tRe1, tSt, True);
    tRe1.name := tId^.AssName;
    tRe1.OrgName := tId^.Name;
    tRe1.Ident := tId;

    if (tRe1.Symbol = SetOfSym) then
     begin
      GetSymbol;
      exit;
     end;

    if (tRe1.Symbol in [ProcSym, FuncSym]) then
     begin
      GetSymbol;

{
 If function and := then treat as identifier else ...
}
      if ((tRe1.Symbol = FuncSym) and (Symbol = Becomes)) then
       begin
        if (id = sFunctionNow) then
         begin
          tSt := tId^.Structure^.Functie;
          tRe1.Group := Vars;
          Struc2Result(tRe1, tSt, True);
          tRe1.name := 'O' + tId^.AssName;
          tRe1.OrgName := tId^.Name;
         end
        else Error(122);
       end
      else
       begin

{ If parameters are needed check for parameters }
L3:
        tId2 := tId^.Structure^.Parameters;
        tRe2.Offset := tRe1.Offset;
        plo := 0;

        if (tId2 <> nil) then
         begin
          if not CheckSymbol(lParent) then exit;
          Symbol := comma;
          OrgDs := tRe1.Offset;
          ClearTre(tRe3);

          repeat
           if not CheckSymbol(comma) then exit;
           Struc2Result(tRe3, tId2^.Structure, True);
           GetSymbol;
           ClearTre(tRe2);
           Coding(tRe2, 0, 1);

           if not CompareSymbol(tRe3.Symbol, tRe2.Symbol, plus) then
            begin
             Error(26);
             exit;
            end;

{ store the data to the stack }
           if tId2^.ProcVar then
            begin
             if not (tRe2.Group in [Vars, ASMstring]) then
              begin Error(20); exit; end;
            end
           else
            begin
             if (tRe2.Group = Konst) then StoreKonst(tRe2)
              else StoreVar(Tre2);
            end;

           tId2^.AssName := tRe2.Name;
           tId2 := tId2^.nlink;
           inc(plo);
          until tId2 = nil;

          if not CheckSymbol(rParent) then exit;
          GetSymbol;
         end;

        Wr2ASMbodyLn(' macProcedure ' + tId^.AssName + ' $'
           + Dec2Hex(tRe2.Offset, 4));

        tRe1.Group := ASMstring;

        if (tId^.Structure^.sSymbol = FuncSym) then
         begin
          tRe1.Symbol := tId^.Structure^.Functie^.sSymbol;

          if (tRe1.Symbol = TypeSym) then
           begin
            tId := tId^.Structure^.Functie^.t;

            while tId^.Structure^.sSymbol = TypeSym do
             tId := tId^.Structure^.t;

            tRe1.Symbol := tId^.Structure^.sSymbol;
           end;
         end;
       end;

      exit;
     end;

{ check if identifier is followed by ^, [, . etc. }
    GetSymbol;
    if (Symbol in [dakje, period, lBrack]) then
     begin
      lCount := 0;                      { to collect all constant parameters }
      OrgDS := tRe1.Offset + LongSize;
      tRe1.Offset := OrgDs;
      tRe1.Group := ASMstring;
      tRe1.boDirect := False;
      Wr2ASMbodyLn(' macAdrVar2Stk ' + tId^.AssName + ' ' + Dec2Hex(tRe1.Offset, 4));

{
 Store zero starting offset,reserve destination space.
}
      ClearTre(tRe3);                   { not really needed, just to empty }
                                        {  the names for debugging         }
      tRe2 := tRe1;
      tRe2.Offset := OrgDs + LongSize;  { tRe2 can grow }

      repeat
       if (Symbol = dakje) then         { ^ }
        begin
         if not CheckPointer(tId) then begin Error(3); exit; end;

         Struc2Result(tRe1, tId^.Structure, False);
         tRe1.name := tId^.AssName;
         tRe1.OrgName := tId^.Name;
         tRe1.Ident := tId;

         GetSymbol;
         if (Symbol = dakje) then begin Error(21); exit; end;

{  Let OrgDS point to actual data  }
         Wr2ASMbodyLn(' macPtr2Addr $' + Dec2Hex(tRe1.Offset, 4));
        end
         else

       if (Symbol = period) then           { . }
        begin
         tSt := tId^.Structure;

         if (tSt^.sSymbol = ProgSym) then  {explicit call to unit }
          begin
           pst := tId^.Name;
           GetSymbol;
           if (Symbol <> ident) then begin Error(2); exit; end;

           tId := SearchIdAll(id, pst, 0, True);
           if (tId = nil) then begin Error(3); exit; end;

           if (tId^.Structure^.sSymbol in [ProcSym, FuncSym]) then
            begin
             tRe1.Group := tId^.Group;
             Struc2Result(tRe1, tId^.Structure, True);
             tRe1.Ident := tId;
             GetSymbol;
             goto L3;
            end
           else begin Error(26); exit; end;
          end;

         if (tSt^.sSymbol <> RecordSym) then
          begin
           if (tSt^.sSymbol = ArraySym) then tSt := tSt^.ArStruc;

           if (tSt^.sSymbol = TypeSym) then
            repeat
             tSt := tSt^.t^.Structure;

             if (tSt^.sSymbol = ArraySym) then
              repeat
               tSt := tSt^.ArStruc;
              until tSt^.sSymbol <> ArraySym;
            until tSt^.sSymbol <> TypeSym;

           if (tSt^.sSymbol <> RecordSym) then begin Error(140); exit; end;
          end;

         GetSymbol;
         if (Symbol <> ident) then begin Error(2); exit; end;

         plo := 0;
         tId := SearchChainId(tSt^.item, id, plo);

         if (tId = nil) then
          begin
           if (tSt^.CaseItem <> nil) then
            begin
             if (short(upper(id)) = short(upper(tSt^.CaseItem^.Name))) then
              tId := tSt^.CaseItem
             else
              begin
               tCs := tSt^.CaseStruc;
               tId2 := tCs^.CsubPart;
               tId := nil;

               while ((tId = nil) and (tCs <> nil)) do
                begin
                 tId := SearchChainId(tId2, id, plo);
                 tCs := tCs^.NextCase;
                 tId2 := tCs^.CsubPart;
                end;
              end;
            end
           else begin Error(3); exit; end;
          end;

{  Determine what symbol of (possible) endresult should be  }
         if (tId <>nil) then
          begin
           Struc2Result(tRe3, tId^.Structure, True);
           tId2 := tId;

           repeat
            if (tRe3.Symbol = TypeSym) then
             begin
              tRe3.Symbol := tId2^.Structure^.t^.Structure^.sSymbol;
              tId2 := tId2^.Structure^.t;
             end;

            if (tRe3.Symbol = ArraySym) then
             tRe1.Symbol := tId2^.Structure^.ArStruc^.sSymbol;
           until not (tRe3.Symbol in [TypeSym, ArraySym]);
          end;

         tRe1.Symbol := tRe3.Symbol;
         tRe2.Symbol := LongSym;
         tRe2.l := plo;
         tRe2.Group := Konst;
         AddTre2Tre1;
         GetSymbol;
        end
         else

       if (Symbol = lBrack) then           { [ }
        begin
{
 Check if variable is indeed an array or string
}
         tSt := tId^.Structure;

         if not (tSt^.sSymbol in [ArraySym, stringSym]) then
          begin
           if (tSt^.sSymbol = TypeSym) then
            repeat
             tSt := tSt^.t^.Structure;
            until (tSt^.sSymbol <> TypeSym);
          end;

         if not (tSt^.sSymbol in [ArraySym, stringSym]) then
          begin Error(67); exit; end;

         if (tSt^.sSymbol = StringSym) then
          begin
L1:
           GetSymbol;
           ClearTre(tRe2);
           Coding(tRe2, 0, 1);

           if (not (tRe2.Symbol in NumberSys)) then
            begin Error(98); exit; end;

           if (tRe2.Group = Konst) then
            begin

{  Check if value is within given range  }
             if ((tRe2.l < 0) or (tRe2.l > tSt^.StrSize)) then
              begin Error(76); exit; end;
            end;

           tRe2.Symbol := LongSym;
           AddTre2Tre1;
           tRe1.Symbol := CharSym;
          end
         else
          begin

{ Determine how many subranges exist, save size of every subrange in arLo }
           for by := 2 to MaxSubArray+1 do arLo[by] := 1;

           by := 1;
           tRa := tSt^.ArRange;

           while (tRa <> nil) do
            begin
             arLo[by] := (tRa^.lEnd - tRa^.lBegin + 1);
             inc(by);
             tRa := tRa^.nRange;
            end;
           arLo[by] := tSt^.ArSize;

{ Check every subrange }
           bSubRange := 1;
           repeat

    { calculate  multiplying factor }
            lOffset := 1;
            for by := bSubRange+1 to MaxSubArray+1 do
             lOffset := lOffset * arLo[by];

    { Get parameter }
            GetSymbol;
            ClearTre(tRe2);
            Coding(tRe2, 0, 1); { here is where tRe2 needs room on the stack }

    { search for matching range }
            tRa := tSt^.ArRange;
            for by := 2 to bSubRange do tRa := tRa^.nRange;

    { do range and found type match? }
            if (   ((tRa^.Rangetype = rChar) and (tRe2.Symbol <> CharSym))
                or ((tRa^.Rangetype = rInt) and not (tRe2.Symbol in NumberSys))
                or ((tRa^.Rangetype = rSet) and (tRe2.Symbol <> SetItemSym))) then
             begin Error(26); exit; end;

            with tRa^ do
             begin
              if (tRe2.Group = Konst) then
               begin

{ Check if value is within given range }
                if (   (    (tRe2.Symbol in NumberSys)
                        and ((tRe2.l < lBegin) or (tRe2.l > lEnd)))
                    or (    (tRe2.Symbol = CharSym)
                        and ((tRe2.c < chr(lBegin)) or (tRe2.c > chr(lEnd))))
                    or (    (tRe2.Symbol = SetItemSym)
                        and (not SearchInSet(tRe2.OrgName, '', SetId))) ) then
                 begin Error(76); exit; end;

{ Calculate offset from beginning of array }
                if (tRe2.Symbol in NumberSys) then tRe2.l := tRe2.l - lBegin
                 else
                if (tRe2.Symbol = SetItemSym) then tRe2.l := tId2^.Structure^.si
                 else
                if (tRe2.Symbol = CharSym) then tRe2.l := ord(tRe2.c) - lBegin;

                lCount := lCount + tRe2.l * lOffset;
               end
              else
               begin  { tRe <> constant }
                if (lOffset <> 1) then
                 begin

{ Multiply found value with offset of subrange }
                  tRe3.Symbol := LongSym;
                  tRe3.l := lOffset;
                  StoreKonst(tRe3);

                  if (tRe2.Group = Vars) then pst := tRe2.Name
                   else pst := '$' + Dec2Hex(tRe2.Offset, 4);

                  Wr2ASMbodyLn(' macLongMult ' + Symbol2Type(tRe3.Symbol)
                                 + ' '  + tRe3.Name
                                 + ' '  + Symbol2Type(tRe2.Symbol)
                                 + ' '  + pst
                                 + ' $' + Dec2Hex(tRe2.Offset, 4));
                  tRe2.Group := ASMstring;
                 end;

{  Add to already found offset  }
                AddTre2Tre1;
               end;
             end;

            inc(bSubRange);

            if (bSubRange <= tSt^.ArNum) then
             begin
              if (Symbol = rBrack) then GetCheckSymbol(lBrack) else
               if not CheckSymbol(comma) then exit;
             end;
           until bSubRange > tSt^.ArNum;
          end;

{ pst : array[0..5] of string;   c := pst[2, 30]   c := pst[2][30] }
         if (Symbol = Comma) then
          begin

{ Check if it is a string-array }
L2:        tSt := tSt^.ArStruc;

           while (tSt^.sSymbol = TypeSym) do
            tSt := tSt^.t^.Structure;

           if (tSt^.sSymbol = StringSym) then goto L1 else
            begin Error(66); exit; end;
          end
         else
          begin
           if not CheckSymbol(rBrack) then exit;
           if tRe1.Symbol = ArraySym then
            tRe1.Symbol := Array2Symbol(tRe1.Ident^.Structure);
           GetSymbol;
           if (Symbol = lBrack) then goto L2;
          end;
        end;

        if (lCount > 0) then
         begin
          tRe2.l := lCount;
          tRe2.Group := Konst;
          tRe2.Symbol := LongSym;
          sy := tRe1.Symbol;
          tRe1.Symbol := WordSym;       {#### 16 bits for the moment}
          AddTre2Tre1;
          tRe1.Symbol := sy;
         end;
       until not (Symbol in [dakje, period, lBrack]);

      exit;
     end
    else exit;
   end
    else

  if (Symbol in [minus, NotSym]) then
   begin
    sy := Symbol;
    GetSymbol;
    CodeTerm(tRe1);

    if (tRe1.Group = Konst) then
     begin
      if sy = Minus then
       begin
        if not (tRe1.Symbol in [RealSym] + NumberSys) then
         begin Error(79); exit; end;

        if tRe1.Symbol = RealSym then
         begin
          tRe1.r := -tRe1.r;
          if tRe1.s <> nil then tRe1.s^ := '-' + tRe1.s^;
         end
        else
         begin
          if tRe1.Symbol = ByteSym then tRe1.Symbol := IntSym else
           if tRe1.Symbol = WordSym then tRe1.Symbol := LongSym;
          tRe1.l := -tRe1.l;
         end;

        exit;
       end;

      StoreKonst(tRe1);
     end;

    if (tRe1.Group = Vars) then
     begin
      pst := tRe1.name;
      tRe1.Offset := tRe1.Offset + Symbol2Size(tRe1.Symbol);
     end
      else pst := '$' + Dec2Hex(tRe1.Offset, 4);

    tRe1.OrgName := '$' + Dec2Hex(tRe1.Offset, 4);
    pst := pst + ' ' + tRe1.OrgName;

    if (sy = NotSym) then
     begin
      if not (tRe1.Symbol in [BoolSym] + NumberSys) then
       begin Error(98); exit; end;

      case tRe1.Symbol of
        BoolSym,
        ByteSym : Wr2ASMbodyLn(' macByteNot ' + pst);
        LongSym : Wr2ASMbodyLn(' macLongNot ' + pst);
        IntSym,
        WordSym : Wr2ASMbodyLn(' macWordNot ' + pst);
       end;
     end
    else
     begin
      if not (tRe1.Symbol in [RealSym] + NumberSys) then
       begin Error(79); exit; end;

      case tRe1.Symbol of
        ByteSym : Wr2ASMbodyLn(' macByteNeg ' + pst);
        LongSym : Wr2ASMbodyLn(' macLongNeg ' + pst);
        RealSym : Wr2ASMbodyLn(' macRealNeg ' + pst);
        IntSym,
        WordSym : Wr2ASMbodyLn(' macWordNeg ' + pst);
       end;
     end;

    tRe1.Group := ASMstring;
    exit;
   end
    else

  if (Symbol = Plus) then               { ignore }
    else

  if (Symbol = lBrack) then             { set }
   begin
{
 How to store the items

type value/address 1 type value/address 1
        single               single
type value/address 2 type value/address 0
                 range                  end
}
    boFirst := True;
    Symbol := Comma;
    ClearTre(tRe2);
    tRe1.Name := KonName + 'RANGE';
    tRe1.Group := Vars;
    Wr2ASMheaderLn(tRe1.Name);

    while (Symbol = Comma) do
     begin
      if not boFirst then Wr2ASMheaderLn(' .by 1');        { , }
      ClearTre(tRe2);
      tRe2.Offset := tRe1.Offset;
      GetSymbol;

      if (Symbol = RangeVal) then               { 32.. }
       begin
        sString[0] := chr(ord(sString[0]) - 2);
        val(sString, lFound, i);                { no check on i needed }

        case MaxRange of
          2 : tRe2.Symbol := ByteSym;
          4 : tRe2.Symbol := IntSym;
          8 : tRe2.Symbol := LongSym;
         end;

        Wr2ASMheaderLn(' .by ' + Symbol2Type(tRe1.Symbol));
        Wr2ASMheaderLn(' .dw $' + Dec2Hex(lFound, MaxRange));
        Wr2ASMheaderLn(' .by 2');               { .. }
        Symbol := Comma;
        continue;
       end
      else
       begin
        Coding(tRe2, 0, 1);
        if (tRe2.Group) = Konst then StoreKonst(tRe2);

        if (tRe2.Group = Vars) then pst := tRe2.Name
         else pst := '$' + Dec2Hex(tRe2.Offset, 4);

        Wr2ASMheaderLn(' .by $FF');
        Wr2ASMheaderLn(' .wo ' + pst);
       end;


      if boFirst then
       begin
        sy := tRe2.Symbol;
        boFirst := False;
       end;

      if not CompareSymbol(sy, tRe2.Symbol, eql) then
       begin Error(26); exit; end;

      if (Symbol = RangeSym) then               { .. }
       begin
        Wr2ASMheaderLn(' .by 2');
        Symbol := Comma;
       end;
     end;

    if not CheckSymbol(rBrack) then exit;
    tRe1.Symbol := sy;
    Wr2ASMheaderLn(' .by 0');
   end
    else

  if (Symbol = StanFunc) then
   begin
    if not GetCheckSymbol(lParent) then exit;
    fSymbolOrg := fSymbol;
    pst := '';
    GetParameter1(tRe1, pst, [AllSym]);
    sy := Symbol;
    fSymbol := fSymbolOrg;
    tRe1.Group := ASMstring;

    if (fSymbol = AbsSym) then
     begin
      if not (tRe1.Symbol in [RealSym] + NumberSys) then
       begin Error(79); exit; end;

      tRe1.Offset := tRe1.Offset + Symbol2Size(tRe1.Symbol);
      tRe1.OrgName := Dec2Hex(tRe1.Offset, 4);
      pst := pst + ' ' + tRe1.OrgName;

      if tRe1.boDirect then Wr2ASMbodyLn(' macAbs ' + pst)
       else Wr2ASMbodyLn(' macAbsInd ' + pst);
     end
      else

    if (fSymbol = ChrSym) then
     begin
      if not (tRe1.Symbol in NumberSys) then begin Error(98); exit; end;
      tRe1.Offset := tRe1.Offset + Symbol2Size(CharSym);
      tRe1.OrgName := Dec2Hex(tRe1.Offset, 4);
      pst := pst + ' ' + tRe1.OrgName;
      tRe1.Symbol := CharSym;

      if tRe1.boDirect then Wr2ASMbodyLn(' macChr ' + pst)
       else Wr2ASMbodyLn(' macChrInd ' + pst);
     end
      else

    if (fSymbol in [HiSym, LoSym]) then
     begin
      if not (tRe1.Symbol in NumberSys) then begin Error(98); exit; end;
      tRe1.Offset := tRe1.Offset + Symbol2Size(ByteSym);
      tRe1.OrgName := Dec2Hex(tRe1.Offset, 4);
      pst := pst + ' ' + tRe1.OrgName;
      tRe1.Symbol := ByteSym;
      if fSymbol = HiSym then pst2 := ' macHi' else pst2 := ' macLo';
      if not tRe1.boDirect then pst2 := pst2 + 'Ind';
      Wr2ASMbodyLn(pst2 + ' ' + pst);
     end
      else

    if (fSymbol = LengthSym) then
     begin
      if not (tRe1.Symbol in [CharSym, StringSym]) then
       begin Error(66); exit; end;

      tRe1.Offset := tRe1.Offset + Symbol2Size(IntSym);
      tRe1.OrgName := Dec2Hex(tRe1.Offset, 4);
      pst := pst + ' ' + tRe1.OrgName;
      tRe1.Symbol := IntSym;

      if tRe1.boDirect then Wr2ASMbodyLn(' macLength ' + pst)
       else Wr2ASMbodyLn(' macLengthInd ' + pst);
     end
      else

    if (fSymbol = OddSym) then
     begin
      if not (tRe1.Symbol in NumberSys) then begin Error(98); exit; end;
      tRe1.Offset := tRe1.Offset + Symbol2Size(BoolSym);
      tRe1.OrgName := Dec2Hex(tRe1.Offset, 4);
      pst := pst + ' ' + tRe1.OrgName;
      tRe1.Symbol := BoolSym;

      if tRe1.boDirect then Wr2ASMbodyLn(' macOdd ' + pst)
       else Wr2ASMbodyLn(' macOddInd ' + pst);
     end
      else

    if (fSymbol = OrdSym) then
     begin
      if (tRe1.Symbol <> CharSym) then begin Error(106); exit; end;
      tRe1.Offset := tRe1.Offset + Symbol2Size(ByteSym);
      tRe1.OrgName := Dec2Hex(tRe1.Offset, 4);
      pst := pst + ' ' + tRe1.OrgName;
      tRe1.Symbol := ByteSym;

      if tRe1.boDirect then Wr2ASMbodyLn(' macOrd ' + pst)
       else Wr2ASMbodyLn(' macOrdInd ' + pst);
     end
      else

    if (fSymbol in [PredSym, SuccSym]) then
     begin
      if not (tRe1.Symbol in [CharSym] + NumberSys) then
       begin Error(26); exit; end;

      tRe1.Offset := tRe1.Offset + Symbol2Size(tRe1.Symbol);
      tRe1.OrgName := Dec2Hex(tRe1.Offset, 4);
      pst := pst + ' ' + tRe1.OrgName;

      if fSymbol = PredSym then pst2 := ' macPred' else pst2 := ' macSucc';

      if (tRe1.Symbol in NumberSys) then
       begin
        pst2 := pst2 + 'Num';
        tRe1.Symbol := LongSym;
       end
      else
       begin
        pst2 := pst2 + 'Char';
        tRe1.Symbol := CharSym;
       end;

      if not tRe1.boDirect then pst2 := pst2 + 'Ind';
      Wr2ASMbodyLn(pst2 + ' ' + pst);
     end
      else

    if (fSymbol in [RoundSym, TruncSym]) then
     begin
      if not (tRe1.Symbol in [RealSym] + NumberSys) then
       begin Error(79); exit; end;

      tRe1.Offset := tRe1.Offset + Symbol2Size(LongSym);
      tRe1.OrgName := Dec2Hex(tRe1.Offset, 4);
      pst := pst + ' ' + tRe1.OrgName;
      tRe1.Symbol := LongSym;

      if fSymbol = RoundSym then pst2 := ' macRound'
       else pst2 := ' macTrunc';

      if not tRe1.boDirect then pst2 := pst2 + 'Ind';
      Wr2ASMbodyLn(pst2 + ' ' + pst);
     end
      else

    if (fSymbol = SwapSym) then
     begin
      if not (tRe1.Symbol in NumberSys) then begin Error(98); exit; end;

      tRe1.Offset := tRe1.Offset + Symbol2Size(tRe1.Symbol);
      tRe1.OrgName := Dec2Hex(tRe1.Offset, 4);
      pst := pst + ' ' + tRe1.OrgName;

      if tRe1.boDirect then Wr2ASMbodyLn(' macSwap ' + pst)
       else Wr2ASMbodyLn(' macSwapInd ' + pst);
     end;

    if not CheckSymbol(rParent) then exit;
    tRe1.boDirect := True;
    GetSymbol;
    exit;                               { skip GetSymbol }
   end
    else

  if (Symbol = lParent) then
   begin
    GetSymbol;
    Coding(tRe1, 0, 1);
    if not CheckSymbol(rParent) then exit;
   end
    else

   begin
    tRe1.Symbol := Val2Sym(Symbol);
    tRe1.Group := Konst;

{**  Simple type is found, so what is the actual value?  **}
    if (tRe1.Symbol in NumberSys) then tRe1.l := lFound
     else if (tRe1.Symbol = CharSym) then tRe1.c := sString[1]
     else if (tRe1.Symbol = RealSym) then
      begin
       tRe1.r := rFound;
       if sString = '' then tRe1.s := nil else
        begin
         new(tRe1.s);
         tRe1.s^ := sString;
        end;
      end
     else if (tRe1.Symbol = NilSym) then
     else

    if (tRe1.Symbol = StringSym) then
     begin
      new(tRe1.s);
      tRe1.s^ := sString;
     end
      else

    if (tRe1.Symbol in [FalseSym, TrueSym]) then
     begin
      tRe1.name := '';
      tRe1.Symbol := BoolSym;
      tRe1.b := (Symbol = TRueSym);
      tRe1.Group := Konst;
     end
    else begin Error(26); exit; end;
   end;

  GetSymbol;
end;


procedure Coding(var tRe : Result; bOrder, bLevel : byte);
{
 Code arithmic constructions like "a+b-c+d*e div f mod g"
}
var
  aName : alfa;
  tOrder, t : byte;
  OrgDS : longint;
  tSt, tSt2 : pStructure;
  tRe1, tRe2 : Result;
  pst : str80;
  Op1 : tSymbol;                                { found operator }

 procedure AddSubComment(pst : Str80; Size : word);
 begin
   tRe1.Offset := OrgDS + Size;
   tRe1.OrgName := Dec2Hex(tRe1.Offset, 4);
   Wr2ASMbodyLn(pst+ ' ' + tRe1.OrgName);       { plus address result }
 end;

begin {coding}
  aName := tRe.Name;
  ClearTre(tRe1);
  ClearTre(tRe2);
  tRe1.Offset := tRe.Offset;
  OrgDS := tRe.Offset;
  CodeTerm(tRe1);                               { first term }

  if (tRe1.Symbol = UnknownSym) then begin Error(3); exit; end;

{
 If tRe1 is a result of another operation, tRe1.Offset contains the location
 of the result. Otherwise it hasn't changed.
}
  tRe := tRe1;

  while not (Symbol in [semicolon, rParent, rBrack, comma, ThenSym, ElseSym,
                        DoSym, OfSym, EndSym, ToSym, DowntoSym, Colon,
                        RangeSym]) do
   begin
    if not (Symbol in [eql, neq, lss, leq, gtr, geq, InSym, plus, minus,
             slash, star, DivSym, ModSym, OrSym, AndSym, ShlSym, ShrSym,
             XorSym]) then
     begin Error(42); exit; end;

{ What is the level of the operator? }
    case Symbol of
      InSym                        : tOrder := 1;
      eql, neq, lss, leq, gtr, geq : tOrder := 2;
      plus, minus, OrSym, XorSym   : tOrder := 3;
      slash, star, DivSym, ModSym, AndSym, ShlSym, ShrSym : tOrder := 4;
     end;

    if (tOrder <= bOrder) then exit;      { same or less the previous -> exit }

    Op1 := Symbol;
    GetSymbol;
    ClearTre(tRe2);
    tRe2.Offset := tRe1.Offset;
    Coding(tRe2, tOrder, bLevel + 1);     { get second term }

    if (tRe2.Symbol = UnknownSym) then begin Error(3); exit; end;

{
 Check if second term matches first one using the found operator
}
    if not CompareSymbol(tRe1.Symbol, tRe2.Symbol, Op1) then
     begin Error(26); exit; end;

{
 If both operands are constants, then calculate the result
}
    if (tRe1.Group = Konst) and (tRe2.Group = Konst) then
     begin
      new(tSt);
      tSt^.boPointer := False;
      tSt^.sSymbol := tRe1.Symbol;
      case tRe1.Symbol of
        BoolSym : tSt^.b := tRe1.b;
        CharSym : tSt^.c := tRe1.c;
        RealSym : begin
          tSt^.r := tRe1.r;
          tSt^.rs := nil;

          if tRe1.s <> nil then
           begin
            dispose(tRe1.s);
            tRe1.s := nil;
           end;
         end;
        StringSym : begin
          new(tSt^.s);
          tSt^.s^ := tRe1.s^;
         end;
          else tSt^.l := tRe1.l;
       end;

      new(tSt2);
      tSt^.boPointer := False;
      tSt2^.sSymbol := tRe2.Symbol;
      case tRe2.Symbol of
        BoolSym : tSt2^.b := tRe2.b;
        CharSym : tSt2^.c := tRe2.c;
        RealSym : begin
          tSt2^.r := tRe2.r;
          tSt2^.rs := nil;

          if tRe2.s <> nil then
           begin
            dispose(tRe2.s);
            tRe2.s := nil;
           end;
         end;
        StringSym : begin
          new(tSt2^.s);
          tSt2^.s^ := tRe2.s^;
         end;
          else tSt2^.l := tRe2.l;
       end;

      CalcResult(tSt, tSt2, Op1);
      Struc2Result(tRe1, tSt, True);
      if (tRe2.Symbol = StringSym) then dispose(tRe2.s);
      DisposeStructure(tSt);
      DisposeStructure(tSt2);

      tRe := tRe1;
      Continue;
     end;

{
 tRe2.Offset points to the last occupied location of the DStack. Store the
 value of a found constant.
}
    if (tRe1.Group = Konst) then StoreKonst(tRe1);
    if (tRe2.Group = Konst) then StoreKonst(tRe2);

{
 Now give all info to a macro
}
    pst := Symbol2Type(tRe1.Symbol);             { type operand 1 }

    if (tRe1.Group = Vars) then pst := pst + ' ' + tRe1.name
     else pst := pst + ' $' + Dec2Hex(tRe1.Offset, 4);

    pst := pst + ' ' + Symbol2Type(tRe2.Symbol);      { type operand 2 }

    if (tRe2.Group = Vars) then pst := pst + ' ' + tRe2.name
     else pst := pst + ' $' + Dec2Hex(tRe2.Offset, 4);

    if (Op1 = plus) then
     begin
      if (tRe1.Symbol in [CharSym, StringSym]) then
       AddSubComment(' macStringPlus ' + pst, StringSize + 1)
        else

      if (tRe1.Symbol = SetOfSym) then
       AddSubComment(' macSetOfPlus ' + pst, SetItemSize)
        else AddSubComment(' macPlus ' + pst, RealSize);
     end
      else

    if (Op1 = minus) then AddSubComment(' macMinus ' + pst, RealSize) else
    if (Op1 = slash) then AddSubComment(' macSlash ' + pst, RealSize) else
    if (Op1 = star) then AddSubComment(' macMult ' + pst, RealSize) else
    if (Op1 in [eql, neq, lss, leq, gtr, geq]) then
     begin
      if ((tRe1.Symbol = StringSym) or (tRe2.Symbol = StringSym)) then
       AddSubComment(' macComp' + Symbol2Char(Op1) + 'St ' + pst, BooleanSize)
      else
       AddSubComment(' macComp' + Symbol2Char(Op1) + ' ' + pst, BooleanSize);
     end
      else

    if (Op1 in [XorSym, OrSym, AndSym]) then
     begin
      if (tRe1.Symbol = BoolSym) then
       case OP1 of
         AndSym : AddSubComment(' macAndBool ' + pst, BooleanSize);
         OrSym  : AddSubComment(' macOrBool ' + pst, BooleanSize);
         XorSym : AddSubComment(' macXorBool ' + pst, BooleanSize);
       end
      else
       case OP1 of
         AndSym : AddSubComment(' macAndLong ' + pst, LongSize);
         OrSym  : AddSubComment(' macOrLong ' + pst, LongSize);
         XorSym : AddSubComment(' macXorLong ' + pst, LongSize);
       end;
     end
      else

    if (Op1 = ShlSym) then AddSubComment(' macLongShl ' + pst, LongSize)
      else

    if (Op1 = ShrSym) then AddSubComment(' macLongShr ' + pst, LongSize)
      else

    if (Op1 = DivSym) then AddSubComment(' macLongDiv ' + pst, LongSize)
      else

    if (Op1 = InSym) then AddSubComment(' macIn ' + pst, BooleanSize)
      else

    if (Op1 = ModSym) then AddSubComment(' macLongMod ' + pst, LongSize);

{
 Tell the compiler what the possible result is. The value returned by
 CALCULATE can be different. Adding two bytes can result in a word. The
 procedure that called CODING will use only the part it needs.
}
    if (Op1 = slash) then tRe1.Symbol := RealSym
      else
    if (Op1 in [AndSym, OrSym, XorSym, minus, plus, star, DivSym, ModSym
                 , ShrSym, ShlSym]) then
     begin
      if (tRe2.Symbol in [CharSym, StringSym]) then tRe1.Symbol := StringSym
        else
      if (tRe1.Symbol = RealSym) or (tRe2.Symbol = RealSym) then
       tRe1.Symbol := RealSym
        else
      if (tRe1.Symbol in NumberSys) or (tRe2.Symbol in NumberSys) then
       tRe1.Symbol := LongSym;
     end
      else tRe1.Symbol := BoolSym;

    tRe1.Group := ASMstring;

    if (tRe1.s <> nil) then
     begin
      dispose(tRe1.s);
      tRe1.s := nil;
     end;

    if (tRe2.s <> nil) then
     begin
      dispose(tRe2.s);
      tRe2.s := nil;
     end;

    tRe := tRe1;
   end;  {while}
end;


procedure WrPascode;
begin
  Wr2ASMbodyLn(PasCode);
  str(LineCount+1:4, PasCode);
  PasCode := '; ' + PasCode + ' ';
end;


procedure AsmProc;
var b : byte;
begin
  Wr2ASMbodyLn(PasCode);
  PasCode := '';
  Symbol := Semicolon;
  boASMcode := True;

  while (Symbol <> EndSym) do
   begin
    if (pos(#10, PasCode) > 0) then
     begin
      write(ASMbody, PasCode);
      PasCode := '';
     end;

    GetSymbol;
   end;

  boASMcode := False;
  b := pos('END', upper(PasCode)) - 1;
  while (PasCode[b] = ' ') do dec(b);
  write(ASMbody, copy(PasCode, 1, b));
  delete(PasCode, 1, b);
  Wr2ASMbodyLn('; ' + PasCode);
  GetSymbol;
end;


procedure BeginProc;
begin
  WrPascode;
  Symbol := Semicolon;
  GetSymbol;

  repeat
   Statement;
   if (Symbol = semicolon) then GetSymbol;
  until (Symbol in [EndSym, UnknownSym]);

  if (Symbol = UnknownSym) then exit;
  WrPascode;
  GetSymbol;
end;


procedure CaseProc;
var
  c1 : char;
  tRe1, tRe2 : Result;
  tLabel1, tLabel2, tLabel999 : Str16;
  pst, pst2 : str80;
begin
{
 The algorithm:

 case ...
         CodeTerm
 of ...
         CodeTerm
         Calculate result
               lda OrgDs
               bne tLabel1        if True, -> tLabel1

               jmp tLabel2

 : ...
tLabel1        ... Statement ...

               jmp tLabel999


tLabel999        ; end of case
}
  tLabel999 := NextLabel;
  ClearTre(tRe1);
  tRe1.Offset := lStack;
  GetSymbol;
  Coding(tRe1, 0, 1);

  if not CheckSymbol(OfSym) then exit;

  if (   ((tRe1.Group = Konst) and (tRe1.Name = ''))
      or not (tRe1.Symbol in
                 [BoolSym, CharSym, SetItemSym, SetSym] + NumberSyS)) then
   begin Error(26); exit; end;

  if (tRe1.Group = Konst) then StoreKonst(tRe1);

  if (tRe1.Group = Vars) then pst2 := tRe1.name
   else pst2 := '$' + Dec2Hex(tRe1.Offset, 4);

  WrPascode;
  inc(tRe1.Offset, BooleanSize);
  GetSymbol;

  repeat
   tLabel1 := NextLabel;

   repeat
    tLabel2 := NextLabel;

    ClearTre(tRe2);
    tRe2.Offset := tRe1.Offset;
    Codeterm(tRe2);

    if not (Symbol in [Comma, Colon]) then begin Error(86); exit; end;

    if (tRe2.Group <> Konst) then begin Error(31); exit; end;

    if not CompareSymbol(tRe1.Symbol, tRe2.Symbol, eql) then
     begin Error(26); exit; end;

    StoreKonst(tRe2);

{ Now give all info to a macro }
    pst := Symbol2Type(tRe1.Symbol);                   { type operand 1 }
    pst := pst + ' '  + pst2;
    pst := pst + ' '  + Symbol2Type(tRe2.Symbol);      { type operand 2 }
    pst := pst + ' $' + Dec2Hex(tRe2.Offset, 4);
    pst := pst + ' $' + Dec2Hex(tRe1.Offset, 4);       { address result }

    if (tRe1.Symbol in [BoolSym] + NumberSys) then
     Wr2ASMbodyLn(' macCompEqlLo ' + pst)
    else Wr2ASMbodyLn(' macCompEqlSt ' + pst);

    c1 := PasCode[length(PasCode)];

{ GetChar is a bit too RAW, so adjust PasCode if needed }
    if (c1 in [',', ':']) then WrPascode else
     begin
      PasCode[0] := pred(PasCode[0]);
      WrPascode;
      PasCode := PasCode + ' ' + c1;
     end;

    Wr2ASMbodyLn(' macCompJump $' + Dec2Hex(tRe1.Offset, 4) + ' '
                      + tLabel1 + ' ' + tLabel2);

    if not (Symbol in [Comma, Colon]) then begin Error(26); exit; end;

    if (Symbol = Comma) then Wr2ASMbodyLn(tLabel2);
    GetSymbol;
   until (PrevSymbol = Colon);

   Wr2ASMbodyLn(tLabel1);

   if (Symbol <> semicolon) then
    begin
     PrevSymbol := semicolon;
     Statement;
    end;

   Wr2ASMbodyLn(' macJump ' + tLabel999);
   if (Symbol = Semicolon) then GetSymbol;

   if not (Symbol in [ElseSym, EndSym]) then
    begin
     if (PrevSymbol <> Semicolon) then begin Error(85); exit; end;
    end
   else
    if (PrevSymbol = Semicolon) then WrPascode;

   Wr2ASMbodyLn(tLabel2);
  until (Symbol in [ElseSym, EndSym]);


  if (Symbol = ElseSym) then
   begin
    Symbol := Semicolon;
    GetSymbol;
    Statement;
    if (Symbol = Semicolon) then GetSymbol;

    if (Symbol <> EndSym) then begin Error(37); exit; end;
   end;

  Wr2ASMbodyLn(tLabel999);
  GetSymbol;
end;


procedure ExitProc;
begin
  WrPascode;
  Symbol := Semicolon;
  Wr2ASMbodyLn(' macJump ' + sExit);
  GetSymbol;
end;


procedure SubForIdent(var tRe1, tRe2 : Result);
{
 Copy the contents of the data represented by Tre2 to the place represented
 by tRe1.
}
var
  pst : Str80;
begin
  if (tRe2.Group) = Konst then StoreKonst(tRe2);

  if (tRe2.Group = Vars) then pst := tRe2.Name
   else pst := 'DStack-$' + Dec2Hex(tRe2.Offset, 4);

  if (tRe1.Symbol = RealSym) and (tRe2.Symbol <> RealSym)  then
   begin
    Wr2ASMbodyLn(' macOper2Fac ' + Symbol2Type(tRe2.Symbol)+ ' ' + pst);
    pst := 'FAC';
   end
  else if tRe1.Symbol <> tRe2.Symbol then
   begin
    Wr2ASMbodyLn(' macOper2Fac ' + Symbol2Type(tRe2.Symbol)+ ' ' + pst);
    pst := Dec2Hex(tRe2.Offset, 2) + '-' + Int2Str(LongSize);
    Wr2ASMbodyLn(' macFac2Oper ' + pst);
    pst := ' DStack-$' + pst;
   end;

  if (tRe1.Group = ASMstring) then
   begin
    pst := pst + ' DStack-$' + Dec2Hex(tRe1.Offset, 4);

    case tRe1.Symbol of
      CharSym,
      BoolSym,
      ByteSym    : Wr2ASMbodyLn(' macAd2AdIndBy ' + pst);
      LongSym,
      PointSym   : Wr2ASMbodyLn(' macAd2AdIndLo ' + pst);
      RealSym    : Wr2ASMbodyLn(' macAd2AdIndRe ' + pst);
      SetOfSym   : Wr2ASMbodyLn(' macAd2AdIndSO ' + pst + ' $'
                               + Dec2Hex(tRe2.l, 2));
      SetItemSym : Wr2ASMbodyLn(' macAd2AdIndSe ' + pst);
      StringSym  : Wr2ASMbodyLn(' macAd2AdIndSt ' + pst + ' $'
                               + Dec2Hex(tRe1.l - 1, 2));
      WordSym,
      IntSym     : Wr2ASMbodyLn(' macAd2AdIndWo ' + pst);
      ArraySym,
      RecordSym  : Wr2ASMbodyLn(' macAd2AdIndAR ' + pst + ' $'
                               + Dec2Hex(tRe1.l, 2));
       else Wr2ASMbodyLn(' macAd2AdInd???? ' + pst);
     end;
   end
  else
   begin
    pst := pst + ' ' + tRe1.Name;

    case tRe1.Symbol of
      BoolSym    : Wr2ASMbodyLn(' macAd2AdBo ' + pst);
      CharSym,
      ByteSym    : Wr2ASMbodyLn(' macAd2AdBy ' + pst);
      LongSym,
      PointSym   : Wr2ASMbodyLn(' macAd2AdLo ' + pst);
      RealSym    : Wr2ASMbodyLn(' macAd2AdRe ' + pst);
      SetOfSym   : Wr2ASMbodyLn(' macAd2AdSO ' + pst + ' $'
                               + Dec2Hex(tRe2.l, 2));
      SetItemSym : Wr2ASMbodyLn(' macAd2AdSe ' + pst);
      StringSym  : Wr2ASMbodyLn(' macAd2AdSt ' + pst + ' $'
                               + Dec2Hex(tRe1.l - 1, 2));
      WordSym,
      IntSym     : Wr2ASMbodyLn(' macAd2AdWo ' + pst);
      ArraySym,
      RecordSym : Wr2ASMbodyLn(' macAd2AdAR ' + pst + ' $'
                               + Dec2Hex(tRe1.l, 2));
       else Wr2ASMbodyLn(' macAd2Ad???? ' + pst);
     end;
   end;
end;


procedure ForProc;
var
  sBreakOrg, sContinueOrg : Str16;
  c1 : char;
  TmpStore : longint;
  tRe1, tRe2 : Result;
  tLabel1 : Str16;
  pst : str80;
  tSym : tSymbol;
begin
  sBreakOrg := sBreak;
  sContinueOrg := sContinue;
  ClearTre(tRe1);
  TmpStore := lStack + BooleanSize;
  tRe1.Offset := TmpStore;
  GetSymbol;
  Codeterm(tRe1);

  if (   (tRe1.Group = Konst)
      or not (tRe1.Symbol in [SetItemSym, CharSym] + NumberSyS)) then
   begin Error(26); exit; end;

  if not CheckSymbol(Becomes) then exit;

  GetSymbol;
  tRe2 := tRe1;
  Coding(tRe2, 0, 1);
  if (tRe2.Group = Konst) then StoreKonst(tRe2);

  if not CompareSymbol(tRe1.Symbol, tRe2.Symbol, eql) then
   begin Error(26); exit; end;

  if not (Symbol in [ToSym, DowntoSym]) then    { look for TO or DOWNTO }
   begin Error(58); exit; end;

  SubForIdent(tRe1, tRe2);                 { Fill variable with first value }
  tSym := Symbol;
  GetSymbol;
  ClearTre(tRe2);
  Coding(tRe2, 0, 1);
  if (tRe2.Group = Konst) then StoreKonst(tRe2);

  if not CompareSymbol(tRe1.Symbol, tRe2.Symbol, eql) then
   begin Error(26); exit; end;

  if not CheckSymbol(DoSym) then                { look for DO }
   begin Error(50); exit; end;

  WrPascode;
  sContinue := NextLabel;
  tLabel1 := NextLabel;
  sBreak := NextLabel;

{ Now compare variable with second value }
  Wr2ASMbodyLn(sContinue);
  pst := Symbol2Type(tRe1.Symbol);              { type operand 1 }

  if (tRe1.Group = Vars) then pst := pst + ' ' + tRe1.name
   else pst := pst + ' $' + Dec2Hex(tRe1.Offset, 4);

  pst := pst + ' ' + Symbol2Type(tRe2.Symbol);      { type operand 2 }

  if (tRe2.Group = Vars) then pst := pst + ' ' + tRe2.name
   else pst := pst + ' $' + Dec2Hex(tRe2.Offset, 4);

  pst := pst + ' $' + Dec2Hex(TmpStore, 4);          { address result }

{ Treat all possibilities as number }
  if (tSym = ToSym) then Wr2ASMbodyLn(' macCompLeq ' + pst)
   else Wr2ASMbodyLn(' macCompGeq ' + pst);

  Wr2ASMbodyLn(' macCompJump $' + Dec2Hex(TmpStore, 4) + ' '
                + tLabel1 + ' ' + sBreak);

  Wr2ASMbodyLn(tLabel1);
  Symbol := semicolon;
  GetSymbol;

  if (Symbol <> Semicolon) then
   begin
    Statement;

    if (tSym = ToSym) then Wr2ASMbodyLn(' macInc ' + pst)
     else Wr2ASMbodyLn(' macDec ' + pst);

    Wr2ASMbodyLn(' macJump ' + sContinue);
   end;

  if (Symbol = Semicolon) then GetSymbol;
  Wr2ASMbodyLn(sBreak);
  sBreak := sBreakOrg;
  sContinue := sContinueOrg;
end;


procedure GotoProc;
var
  tId : pIdentifier;
begin
  GetSymbol;
  tId := SearchId(id, '', Top, True);
  if (tId = nil) then begin Error(3); exit; end;

  Wr2ASMbodyLn('  ');
  WrPascode;
  Wr2ASMbodyLn(' macJump ' + tId^.AssName);
  GetSymbol;
end;


procedure AssignProc(b : byte);
{
 Assign(var f; String);
}
var
  tRe1 : Result;
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter2(tRe1, pst, [FileSym, TextSym]);
  if not CheckSymbol(comma) then exit;
  GetParameter1(tRe1, pst, AllCharSys);

  case b of
    0 : Wr2ASMbodyLn(' macAssignFile ' + pst);
    1 : Wr2ASMbodyLn(' macRenameFile ' + pst);
   end;

  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure BlockReadWriteProc(pbo : boolean);
{
 procedure BlockWrite(var f: File; var Buf; Count: Word [; var Result: Word]);
 procedure BlockRead(var F: File; var Buf; Count: Word [; var Result: Word]);
 where:
   F        untyped file variable
   Buf      any variable
   Count    an expression of type Word
   Result   a variable of type Word
}
var
  tRe1 : Result;
  pst : Str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  pst := '';
  tRe1.Offset := lStack;
  GetParameter2(tRe1, pst, [FileSym]);

  if (tRe1.Ident^.Structure^.f^.fType <> FileSym) then
   begin Error(77); exit; end;

  if not CheckSymbol(Comma) then exit;
  GetParameter2(tRe1, pst, [AllSym]);
  if not CheckSymbol(Comma) then exit;
  GetParameter1(tRe1, pst, AllNumberSys);

  if (Symbol = Comma) then
    GetParameter2(tRe1, pst, [IntSym, WordSym, LongSym])
  else pst := pst + ' 0';

  if pbo then Wr2ASMbodyLn(' macBlkWrite ' + pst)
   else Wr2ASMbodyLn(' macBlkRead ' + pst);

  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure BreakProc;
begin
  if (sBreak = '') then begin Error(109); exit; end;
  Wr2ASMbodyLn(' macBreak ' + sBreak);
  GetSymbol;
end;


procedure ContinueProc;
begin
  if (sContinue = '') then begin Error(109); exit; end;
  Wr2ASMbodyLn(' macContinue ' + sContinue);
  GetSymbol;
end;


procedure DecIncProc(bo : Boolean);
{
 Dec / Inc (var X[ , N: Longint]);
  True  : Dec
  False : Inc
}
var
  tRe1 : Result;
  pst : str80;
  sy : tSymbol;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter2(tRe1, pst, NumberSys);

  if (Symbol = comma) then GetParameter1(tRe1, pst, AllNumberSys)
   else pst := pst + ' 0';            { 0 = ignore extra info }

  if bo then Wr2ASMbodyLn(' macDecSym ' + pst)
   else Wr2ASMbodyLn(' macIncSym ' + pst);

  if not CheckSymbol(rParent) then exit;
  WrPascode;
  GetSymbol;
end;


procedure FindFirstProc;
{
 procedure FindFirst(Path: PChar; Attr: Word; var F: TSearchRec);
                            ^^^
                  but string works fine as well
}
var
  tRe1 : Result;
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, AllCharSys);
  if not CheckSymbol(comma) then exit;
  GetParameter1(tRe1, pst, NumberSys);
  if not CheckSymbol(comma) then exit;
  GetParameter2(tRe1, pst, [RecordSym]);
  Wr2ASMbodyLn(' macFindFirst ' + pst);
  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure FindNextProc;
{
 procedure FindNext(var F: TSearchRec);
}
var
  tRe1 : Result;
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter2(tRe1, pst, [RecordSym]);
  Wr2ASMbodyLn(' macFindNext ' + pst);
  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure FsearchProc;
{
 function FSearch(Path: PathStr; DirList: string): PathStr;
}
var
  tRe1 : Result;
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, AllCharSys);
  if not CheckSymbol(comma) then exit;
  GetParameter1(tRe1, pst, AllCharSys);
  Wr2ASMbodyLn(' macFsearch ' + pst);
  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure FsplitProc;
{
 procedure FSplit(Path: PathStr; var Dir: DirStr; var Name: NameStr;
   var Ext: ExtStr);
}
var
  b : byte;
  tRe1 : Result;
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, AllCharSys);

  for b := 1 to 3 do
   begin
    if not CheckSymbol(comma) then exit;
    GetParameter2(tRe1, pst, [StringSym]);
   end;

  Wr2ASMbodyLn(' macFsplit ' + pst);

  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure GetDirProc;
var
  tRe1 : Result;
  pst : Str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, AllNumberSys);
  if not CheckSymbol(Comma) then exit;
  GetParameter2(tRe1, pst, [StringSym]);

  Wr2ASMbodyLn(' macGetDir ' + pst);

  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure GotoXYProc;
{
 procedure GotoXY(X, Y: Byte);
}
var
  tRe1 : Result;
  pst : Str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, AllNumberSys);
  if not CheckSymbol(Comma) then exit;
  GetParameter1(tRe1, pst, AllNumberSys);

  Wr2ASMbodyLn(' macGotoXY ' + pst);

  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure HaltProc;
{
 Val(S; var V; var Code: Integer);
}
var
  tRe1 : Result;
  pst : str80;
begin
  GetSymbol;
  tRe1.Offset := lStack;

  if (Symbol = lParent) then
   begin
    pst := '';
    GetParameter1(tRe1, pst, AllNumberSys);
    if not CheckSymbol(rParent) then exit;
    GetSymbol;
   end
  else pst := ' 0';

  Wr2ASMbodyLn(' macHalt ' + pst);
end;


procedure InsertProc;
{
  procedure Insert(Source: String; var S: String; Index: Integer);
}
var
  tRe1 : Result;
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, AllCharSys);
  if not CheckSymbol(comma) then exit;
  GetParameter2(tRe1, pst, AllCharSys);
  if not CheckSymbol(comma) then exit;
  GetParameter1(tRe1, pst, AllNumberSys);

  Wr2ASMbodyLn(' macInsertProc ' + pst);

  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure MemProc(b : byte);
{
 procedure GetMem(var P: Pointer; Size: Word);
 procedure FreeMem(var P: Pointer; Size: Word);

 Heap starts after global variables unless otherway stated. "lStart" points
 to the end of the variables/beginning of the heap.

 Format:
 1 byte : status
    bit 0 :  0 = free           1 = occupied
    bit 1 :  0 = last block     1 = followed by another block
 3 bytes: future
 4 bytes: size
 4 bytes: address of next dynamic variable
 ? bytes: data
}
var
  tRe1 : Result;
  pst   : Str80;
begin
  GetSymbol;
  if not CheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter2(tRe1, pst, [pointSym]);

  if (tRe1.Group = Vars) then
   begin
    inc(tRe1.Offset, LongSize);
    Wr2ASMbodyLn(' macAdrVar2Stk ' + tRe1.Name + ' ' + Dec2Hex(tRe1.Offset, 4));
   end;
  pst := '$' + Dec2Hex(tRe1.Offset, 4);

  if not CheckSymbol(comma) then exit;
  GetParameter1(tRe1, pst, AllNumberSys);
  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure MoveProc;
{
 procedure Move(var Source, Dest; Count: Word);
}
var
  tRe1 : Result;
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter2(tRe1, pst, [AllSym]);
  if not CheckSymbol(comma) then exit;
  GetParameter2(tRe1, pst, [AllSym]);
  if not CheckSymbol(comma) then exit;
  GetParameter1(tRe1, pst, AllNumberSys);

  Wr2ASMbodyLn(' macMove ' + pst);

  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure NewDisposeProc(b : byte);
{
 procedure New(var P: Pointer);       reserves memory for dynamic variables
 procedure Dispose(var P: Pointer);   frees memory
}
var
  tRe1 : Result;
  pst : Str80;
begin
  GetSymbol;
  if not CheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter2(tRe1, pst, [pointSym]);

  if (tRe1.Group = Vars) then
   begin
    inc(tRe1.Offset, LongSize);
    Wr2ASMbodyLn(' macAdrVar2Stk ' + tRe1.Name + ' ' + Dec2Hex(tRe1.Offset, 4));
   end;
  pst := '$' + Dec2Hex(tRe1.Offset, 4);

  if (b = 1) then Wr2ASMbodyLn(' macNew ' + pst)
   else Wr2ASMbodyLn(' macDispose ' + pst);

  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure ReadProc(bo : boolean);
{
 Typed files: procedure Read(F , V1 [, V2,...,Vn ] );
 Text files: procedure Read( [ var F: Text; ] V1 [, V2,...,Vn ] );
  True:  ReadLN
  False: Read
}
var
  boFile : boolean;
  f :pFileDef;
  tRe1 : Result;
  pst : str80;
begin
  GetSymbol;
  if (Symbol = Semicolon) and bo then
   begin
    Wr2ASMbodyLn(' macReadLn');
    exit;
   end;

  if not CheckSymbol(lParent) then exit;
  boFile := False;
  GetSymbol;

  CleartRe(tRe1);
  Codeterm(tRe1);

  if bo then
   begin                                { ReadLn }
    if (tRe1.Symbol = FileSym) then begin Error(77); exit; end;
    if (tRe1.Symbol = TextSym) then boFile := True;
   end
  else
   begin                                { Read }
    if not (tRe1.Symbol in [FileSym, TextSym]) then
     begin Error(77); exit; end;

    boFile := True;
   end;

  pst := tRe1.name;
  CleartRe(tRe1);

  if boFile then
   begin
    if (Symbol <> comma) then begin Error(87); exit; end;
    GetSymbol;
    Coding(tRe1, 0, 1);

    if (tRe1.Group <> Vars) then begin Error(20); exit; end;
    pst := pst + ' ' + tRe1.name;

    if bo then Wr2ASMbodyLn(' macReadLnFile ' + pst)
     else Wr2ASMbodyLn(' macReadFile ' + pst);
   end
  else
   if bo then Wr2ASMbodyLn(' macReadLn ' + pst)
    else Wr2ASMbodyLn(' macRead ' + pst);

  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure ResetProc(bo : boolean);
{
 Reset / Rewrite(var F [: File; Recsize: Word ] );
  True:  Reset
  False: Rewrite
}
var
  f :pFileDef;
  tId : pIdentifier;
  tRe1 : Result;
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  GetSymbol;
  CleartRe(tRe1);
  Codeterm(tRe1);

  if not (tRe1.Symbol in [FileSym, TextSym]) then
   begin Error(77); exit; end;

  f := tRe1.Ident^.Structure^.f;
  pst := tRe1.name;

  if (Symbol = comma) then
   begin
    CleartRe(tRe1);
    if (f^.fType <> FileSym) then begin Error(77); exit; end;
    GetSymbol;
    Coding(tRe1, 0, 1);
    if (tRe1.Group = Konst) then StoreKonst(tRe1);

    if not (tRe1.Symbol in NumberSys) then begin Error(98); exit; end;

    if (tRe1.Group = Vars) then pst := pst + ' ' + tRe1.name
     else pst := pst + ' $' + Dec2Hex(tRe1.Offset, 4);
   end
  else pst := pst + '0';

  if bo then Wr2ASMbodyLn(' macResetFile ' + pst)
   else Wr2ASMbodyLn(' macRewriteFile ' + pst);

  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure SeekProc;
var
  tRe1 : Result;
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter2(tRe1, pst, [FileSym, TextSym]);
  if not CheckSymbol(comma) then exit;
  GetParameter1(tRe1, pst, AllNumberSys);

  Wr2ASMbodyLn(' macSeekFile ' + pst);

  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure StrProc;
{
 Str(X [: Width [: Decimals ]]; var S:string);
}
var
  tRe1 : Result;
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, AllNumberSys);

  if (Symbol = colon) then
   begin
    GetParameter1(tRe1, pst, AllNumberSys);
    pst := pst + ' $' + Dec2Hex(tRe1.Offset, 4);

    if (Symbol = colon) then
     begin
      GetParameter1(tRe1, pst, AllNumberSys);
      pst := pst + ' $' + Dec2Hex(tRe1.Offset, 4);
     end
    else pst := pst + ' 0';
   end
  else pst := pst + ' 0 0';

  if not CheckSymbol(comma) then exit;
  GetParameter2(tRe1, pst, AllCharSys);
  Wr2ASMbodyLn(' macStr ' + pst);
  tRe1.Symbol := StringSym;
  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure ValProc;
{
 Val(S; var V; var Code: Integer);
}
var
  tRe1 : Result;
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, AllCharSys);
  if not CheckSymbol(comma) then exit;
  GetParameter2(tRe1, pst, [RealSym] + AllNumberSys);
  if not CheckSymbol(comma) then exit;
  GetParameter2(tRe1, pst, AllNumberSys);
  Wr2ASMbodyLn(' macValSym ' + pst);
  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure WindowProc;
{
 procedure Window(X1, Y1, X2, Y2: Byte);
}
var
  tRe1 : Result;
  pst : Str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, AllNumberSys);
  if not CheckSymbol(Comma) then exit;
  GetParameter1(tRe1, pst, AllNumberSys);
  if not CheckSymbol(Comma) then exit;
  GetParameter1(tRe1, pst, AllNumberSys);
  if not CheckSymbol(Comma) then exit;
  GetParameter1(tRe1, pst, AllNumberSys);
  if not CheckSymbol(Comma) then exit;
  GetParameter1(tRe1, pst, AllNumberSys);

  Wr2ASMbodyLn(' macWindow ' + pst);

  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure OneCommand(b : byte);
begin
  case b of
    0 : Wr2ASMbodyLn(' macClrScr');
    1 : Wr2ASMbodyLn(' macClrEol');
    2 : Wr2ASMbodyLn(' macDelLine');
    3 : Wr2ASMbodyLn(' macInsLine');
    4 : Wr2ASMbodyLn(' macRandomize');
    5 : Wr2ASMbodyLn(' macHighVideo');
    6 : Wr2ASMbodyLn(' macLowVideo');
    7 : Wr2ASMbodyLn(' macNormVideo');
   end;

  GetSymbol;
end;


procedure OnePointerProc(b : byte);
var
  tRe1 : Result;
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter2(tRe1, pst, [PointSym]);

  case b of
    0 : Wr2ASMbodyLn(' macMark ' + pst);
    1 : Wr2ASMbodyLn(' macRelease ' + pst);
   end;

  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure OneStringProc(b : byte);
var
  tRe1 : Result;
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, AllCharSys);

  case b of
    0 : pst := ' macChDirFile ' + pst;
    1 : pst := ' macMkDirFile ' + pst;
    2 : pst := ' macRmDirFile ' + pst;
    3 : pst := ' macNosoundFile ' + pst;
   end;

  Wr2ASMbodyLn(pst);

  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure OneWordProc(b : byte);
var
  tRe1 : Result;
  pst : str80;
begin
  if not GetCheckSymbol(lParent) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, AllNumberSys);

  case b of
    0 : Wr2ASMbodyLn(' macDelay ' + pst);
    1 : Wr2ASMbodyLn(' macSound ' + pst);
    2 : Wr2ASMbodyLn(' macTextColor ' + pst);
    3 : Wr2ASMbodyLn(' macTextBckGr ' + pst);
    4 : Wr2ASMbodyLn(' macTextMode ' + pst);
   end;

  if not CheckSymbol(rParent) then exit;
  GetSymbol;
end;


procedure IdentMem(var tRe1 : Result);
var
  tRe2 : Result;
begin
  if not CheckSymbol(becomes) then exit;
  GetSymbol;
  tRe2 := tRe1;

  if (tRe1.Group <> Vars) then Coding(tRe2, 0, 1)
   else Coding(tRe2, 0, 0);

{**  Check if second term matches first one using the found operator  **}
  if not CompareSymbol(tRe1.Symbol, tRe2.Symbol, becomes) then
   begin Error(26); exit; end;

  SubForIdent(tRe1, tRe2);
end;


procedure pMemPortProc(ty : byte; mp : boolean);
var
  pbo : boolean;
  tRe1 : Result;
  pst : str80;
begin
  MemPortProc(tRe1, ty, mp, 'P');
{
  if not GetCheckSymbol(lBrack) then exit;
  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, NumberSys);

  if mp then
   begin
    if not CheckSymbol(colon) then exit;

    if not tRe1.boDirect then
     begin
      tRe1.Offset := tRe1.Offset + 4;
      pst := 'Ind ' + pst + ' ' + Dec2Hex(tRe1.Offset, 4);
     end;

    Wr2ASMbodyLn(' macMemP0' + pst);
    pst := '';
    GetParameter1(tRe1, pst, NumberSys);
   end;

  if not CheckSymbol(rBrack) then exit;

  case ty of
    0 : tRe1.Symbol := ByteSym;
    1 : tRe1.Symbol := WordSym;
    2 : tRe1.Symbol := LongSym;
   end;

  tRe1.Offset := tRe1.Offset + 4;
  pst := pst + ' ' + Dec2Hex(tRe1.Offset, 4);
  if not tRe1.boDirect then pst := 'Ind ' + pst;

  if mp then Wr2ASMbodyLn(' macMemP' + pst)
   else Wr2ASMbodyLn(' macPortP' + pst);

  tRe1.Group := ASMstring;
  GetSymbol;
}
  GetSymbol;
  IdentMem(tRe1);
  if mp then Wr2ASMbodyLn(' macMemP2 ');
  WrPascode;
end;


procedure IdentProc;
{
 Declaration of
   identifier: <identifier> := ......
   label:      <Label>:
}
var
  tId, tId2 : pIdentifier;
  tSt : pStructure;
  tRe2, tRe1 : Result;
  pst : str16;
label PL1;
begin
{
 Check for standard procedures like STR, INC etc.
}
  pst := upper(short(id));

  if (pst = 'ASSIGN') then begin AssignProc(0); exit; end;
  if (pst = 'BREAK') then begin BreakProc; exit; end;
  if (pst = 'BLOCKREAD') then begin BlockReadWriteProc(True); exit; end;
  if (pst = 'BLOCKWRITE') then begin BlockReadWriteProc(False); exit; end;
  if (pst = 'CHDIR') then begin OneStringProc(0); exit; end;
  if (pst = 'CLOSE') then begin FileProc(2); exit; end;
  if (pst = 'CLREOL') then begin OneCommand(1); exit; end;
  if (pst = 'CLRSCR') then begin OneCommand(0); exit; end;
  if (pst = 'CONTINUE') then begin ContinueProc; exit; end;
  if (pst = 'DEC') then begin DecIncProc(True); exit; end;
  if (pst = 'DELAY') then begin OneWordProc(0); exit; end;
  if (pst = 'DELETE') then begin CopyDeleteProc(tRe2, False); exit; end;
  if (pst = 'DELLINE') then begin OneCommand(2); exit; end;
  if (pst = 'DISPOSE') then begin NewDisposeProc(2); exit; end;
  if (pst = 'ERASE') then begin FileProc(3); exit; end;
  if (pst = 'FINDFIRST') then begin FindFirstProc; exit; end;
  if (pst = 'FINDNEXT') then begin FindNextProc; exit; end;
  if (pst = 'FREEMEM') then begin MemProc(0); exit; end;
  if (pst = 'FSEARCH') then begin FsearchProc; exit; end;
  if (pst = 'FSPLIT') then begin FsplitProc; exit; end;
  if (pst = 'GETDIR') then begin GetDirProc; exit; end;
  if (pst = 'GETMEM') then begin MemProc(1); exit; end;
  if (pst = 'GOTOXY') then begin GotoXYProc; exit; end;
  if (pst = 'HALT') then begin HaltProc; exit; end;
  if (pst = 'HIGHVIDEO') then begin OneCommand(5); exit; end;
  if (pst = 'INC') then begin DecIncProc(False); exit; end;
  if (pst = 'INSERT') then begin InsertProc; exit; end;
  if (pst = 'INSLINE') then begin OneCommand(3); exit; end;
  if (pst = 'LOWVIDEO') then begin OneCommand(6); exit; end;
  if (pst = 'MARK') then begin OnePointerProc(0); exit; end;
  if (pst = 'MKDIR') then begin OneStringProc(1); exit; end;
  if (pst = 'MOVE') then begin MoveProc; exit; end;
  if (pst = 'NEW') then begin NewDisposeProc(1); exit; end;
  if (pst = 'NORMVIDEO') then begin OneCommand(7); exit; end;
  if (pst = 'NOSOUND') then begin OneStringProc(3); exit; end;
  if (pst = 'RANDOMIZE') then begin OneCommand(4); exit; end;
  if (pst = 'READ') then begin ReadProc(False); exit; end;
  if (pst = 'READLN') then begin ReadProc(True); exit; end;
  if (pst = 'RELEASE') then begin OnePointerProc(1); exit; end;
  if (pst = 'RENAME') then begin AssignProc(1); exit; end;
  if (pst = 'RESET') then begin ResetProc(True); exit; end;
  if (pst = 'REWRITE') then begin ResetProc(False); exit; end;
  if (pst = 'RMDIR') then begin OneStringProc(2); exit; end;
  if (pst = 'SEEK') then begin SeekProc; exit; end;
  if (pst = 'SOUND') then begin OneWordProc(1); exit; end;
  if (pst = 'STR') then begin StrProc; exit; end;
  if (pst = 'TEXTCOLOR') then begin OneWordProc(2); exit; end;
  if (pst = 'TEXTBACKGROUND') then begin OneWordProc(3); exit; end;
  if (pst = 'TEXTMODE') then begin OneWordProc(4); exit; end;
  if (pst = 'VAL') then begin ValProc; exit; end;
  if (pst = 'WHEREX') then begin OneWordProc(2); exit; end;
  if (pst = 'WHEREY') then begin OneWordProc(3); exit; end;
  if (pst = 'WINDOW') then begin WindowProc; exit; end;

{
 Check for label
}
  tId := SearchId(id, '', Top, True);

  if ((tId <> nil) and (tId^.Structure^.sSymbol = LabelSym)) then
   begin
    tId^.boUsed := True;
    GetCheckSymbol(Colon);
    Wr2ASMbodyLn(tId^.AssName);
    WrPascode;
    Symbol := SemiColon;
    GetSymbol;
    exit;
   end;

{
 Identifier
}
  tId := SearchIdAll(Id, '', Top, True);
  if (tId = nil) then begin Error(3); exit; end;

  tId^.boUsed := True;
  ClearTre(tRe1);
  tRe1.Offset := lStack;
  CodeTerm(tRe1);

  if (   (    (tId^.Structure^.sSymbol = FuncSym)
          and (Symbol <> becomes))
      or (tRe1.Symbol = ProcSym)) then
   begin
    WrPascode;
    exit;
   end;

  IdentMem(tRe1);
  WrPascode;
end;


procedure IfProc;
var
  tRe1: Result;
  tLabel1, tLabel2, tLabel3 : Str16;
  pst : str80;
begin
{
 The algorithm:

 if ...
               lda OrgDs
               bne tLabel1        if True, -> tLabel1

               jmp tLabel2

 then ...
tLabel1        ... Statement ...

               jmp tLabel3

 else ...
tLabel2        ... Statement ...

tLabel3        ; end of if then
}
  ClearTre(tRe1);
  tRe1.Offset := lStack;
  GetSymbol;
  Coding(tRe1, 0, 1);
  if (tRe1.Symbol <> BoolSym) then begin Error(40); exit; end;

  if not CheckSymbol(ThenSym) then exit;
  WrPascode;
  GetSymbol;
  if (Symbol = Semicolon) then exit;    { nothing to do }

  tLabel1 := NextLabel;
  tLabel2 := NextLabel;
  tLabel3 := NextLabel;

  if (tRe1.Group = Konst) then StoreKonst(tRe1);

  if (tRe1.Group = Vars) then pst := tRe1.name
   else pst := '$' + Dec2Hex(tRe1.Offset, 4);

  Wr2ASMbodyLn(' macCompJump ' + pst + ' ' + tLabel1 + ' ' + tLabel2);
  Wr2ASMbodyLn(tLabel1);

  if (Symbol <> ElseSym) then
   begin
    PrevSymbol := semicolon;
    Statement;
   end;

  if (Symbol <> semicolon) then Wr2ASMbodyLn(' macJump ' + tLabel3);
  Wr2ASMbodyLn(tLabel2);

  if not (Symbol in [semicolon, EndSym]) then
   begin
    if (Symbol <> ElseSym) then begin Error(203); exit; end;
    GetSymbol;

    if (Symbol <> semicolon) then
     begin
      PrevSymbol := semicolon;
      Statement;
     end;
   end;

  Wr2ASMbodyLn(tLabel3);
end;


procedure RepeatProc;
var
  sBreakOrg, sContinueOrg : Str16;
  tRe1 : Result;
  pst : str80;
begin
{
 The algorithm:

 repeat ...
tLabel1        ... Statement ...
 until ...
               lda OrgDs
               beq tLabel2        if False, -> tLabel2

               jmp tLabel1

tLabel2
}
  sBreakOrg := sBreak;
  sContinueOrg := sContinue;
  sContinue := NextLabel;
  sBreak := NextLabel;
  Wr2ASMbodyLn(sContinue);
  WrPascode;
  Symbol := semicolon;
  GetSymbol;

  while (Symbol <> UntilSym) do
   begin
    Statement;

    if (Symbol = Semicolon) then GetSymbol else
     if (Symbol <> UntilSym) then begin Error(204); exit; end;
   end;

  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, [BoolSym]);
  WrPascode;
  Wr2ASMbodyLn(' macCompJump ' + pst + ' ' + sBreak + ' ' + sContinue);
  Wr2ASMbodyLn(sBreak);
  sBreak := sBreakOrg;
  sContinue := sContinueOrg;
end;


procedure SemiColonProc;
begin
  Wr2ASMbodyLn('  ');
  WrPascode;
  GetSymbol;
  Wr2ASMbodyLn('  ');
  WrPascode;
end;


procedure WhileProc;
var
  sBreakOrg, sContinueOrg : Str16;
  tRe1 : Result;
  tLabel2 : Str16;
  pst : str80;
begin
{
 The algorithm:

tLabel1
 while ...
               lda OrgDs
               bne tLabel2        if True, -> tLabel2

               jmp tLabel3

 do ...
tLabel2        ... Statement ...
               jmp tLabel1

tLabel3
}
  sBreakOrg := sBreak;
  sContinueOrg := sContinue;
  sContinue := NextLabel;
  tLabel2 := NextLabel;
  sBreak := NextLabel;
  Wr2ASMbodyLn(sContinue);

  tRe1.Offset := lStack;
  pst := '';
  GetParameter1(tRe1, pst, [BoolSym]);
  if not CheckSymbol(DoSym) then exit;
  WrPascode;
  GetSymbol;
  if (Symbol = Semicolon) then exit;    { nothing to do }
  Wr2ASMbodyLn(' macCompJump ' + pst + ' ' + tLabel2 + ' ' + sBreak);
  PrevSymbol := semicolon;
  Wr2ASMbodyLn(tLabel2);
  Statement;
  Wr2ASMbodyLn(' macJump ' + sContinue);
  Wr2ASMbodyLn(sBreak);
  sBreak := sBreakOrg;
  sContinue := sContinueOrg;
end;


procedure WithProc;
var
  b : byte;
  tId : pIdentifier;
  tWs1, tWs2 : pWithStruc;
  tRe1 : Result;
  pst : Str80;
begin
  inc(WithTop);
  WithStruc[WithTop] := nil;

  repeat
   tRe1.Offset := lStack;
   pst := '';
   GetParameter2(tRe1, pst, [RecordSym]);

   new(tWs2);
   tWs2^.ThisWith := tRe1.Ident;
   tWs2^.NextWith := nil;
   tWs1 := WithStruc[WithTop];

   if tWs1 = nil then WithStruc[WithTop] := tWs2 else
    begin
     while (tWs1^.NextWith <> nil) do tWs1 := tWs1^.NextWith;
     tWs1^.NextWith := tWs2;
    end;
  until (Symbol <> comma);

  if not CheckSymbol(DoSym) then exit;

  str(LineCount:4, PasCode);
  PasCode := '; ';
  Symbol := Semicolon;
  GetSymbol;
  Statement;


{ Dispose stored With pointers }
  tWs1 := WithStruc[WithTop];
  WithStruc[WithTop] := nil;

  while (tWs1 <> nil) do
   begin
    tWs2 := tWs1^.NextWith;
    dispose(tWs1);
    tws1 := tWs2;
   end;

  dec(WithTop);
end;


procedure WriteProc(bo : boolean);
{
 True:  writeln
 False: write
}
var
  sCol1, sCol2 : alfa;
  by, bCount : byte;
  boFile : boolean;
  i : integer;
  OrgDS, DS2 : longint;
  tRe1 : Result;
  s1 : str16;
  pst, pst2 : str80;
label L1;

 procedure Check4colon;
 var
  tRe1, tRe2 : Result;
  sy : tSymbol;
 begin
   sy := tRe1.symbol;

   if (Symbol = colon) then
    GetParameter1(tRe1, pst, AllNumberSys)
   else if not boStored00 then
     begin
      tRe1.Name := '';
      tRe1.Group := Konst;
      tRe1.Symbol := ByteSym;
      tRe1.l := 0;
      StoreKonst(tRe1);
     end;

   sCol1 := tRe1.Name;

   if (Symbol = colon) then
    GetParameter1(tRe2, pst, AllNumberSys)
   else if not boStoredFF then
     begin
      tRe2.Name := '';
      tRe2.Group := Konst;
      tRe2.Symbol := ByteSym;
      tRe2.l := $FF;
      StoreKonst(tRe2);
     end;

   sCol2 := tRe2.Name;
 end;

begin
  GetSymbol;

  if (Symbol = semicolon) then          { writeln; }
   begin
    if bo then Wr2ASMbodyLn(' macWriteLn 0');
    WrPascode;
    exit;
   end;

  if Symbol = EndSym then exit;
  if not CheckSymbol(lParent) then exit;

  boFile := False;
  GetSymbol;
  bCount := 0;
  pst := '';
  ClearTre(tRe1);
  OrgDS := lStack;
  tRe1.Offset := lStack;
  DS2 := tRe1.Offset;
  Coding(tRe1, 0, 1);

  if (tRe1.Group = Konst) then
   begin
    if tRe1.Symbol <> CharSym then StoreKonst(tRe1);
   end
  else
   begin
    if bo then
     begin                                { WriteLn }
      if (tRe1.Symbol = FileSym) then begin Error(42); exit; end;
      boFile := (tRe1.Symbol = TextSym);
     end
    else boFile := (tRe1.Symbol in [FileSym, TextSym]);
   end;

  if boFile then pst := tRe1.Name else goto L1;

  while (Symbol = comma) do
   begin
    pst := '';
    GetParameter1(tRe1, pst2, [BoolSym, RealSym] + AllNumberSys + AllCharSys);
L1:
    if (tRe1.Group = Konst) and (tRe1.Symbol = CharSym) then
     begin
      if boFile then s1 := ' macWriteCharF'
       else s1 := ' macWriteChar';
     end
    else
     begin
      if boFile then s1 := ' macWriteF'
       else s1 := ' macWrite';
     end;

    if (tRe1.Group = Konst) and (tRe1.Symbol = CharSym) then
     begin
      pst2 := s1 + ' ' + tRe1.c;
      if boFile then pst2 := pst2 + ' ' + pst;
     end
    else
     begin
      if tRe1.Symbol = ArraySym then
       begin
        tRe1.Symbol := StringSym;
        tRe1.Name := tRe1.Name + '-1';
       end;

      if not tRe1.boDirect then s1 := s1 + 'Ind';
      s1 := s1 + ' ' + Symbol2type(tRe1.Symbol);
      if tRe1.Symbol in [RealSym] + NumberSys then Check4Colon;

      if tRe1.Group = ASMstring then
       begin
        tRe1.Name := 'DStack-$' + Dec2Hex(tRe1.Offset, 4);
        tRe1.Offset := DS2;
       end;

      pst2 := ' ' + s1;
      if boFile then pst2 := pst2 + ' ' + pst;
      pst2 := pst2 + ' ' + tRe1.Name;

      if tRe1.Symbol in [RealSym] + NumberSys then
       pst2 := pst2 + ' ' + sCol1 + ' ' + sCol2;
     end;

    pst2 := pst2 + ' X X';
    Wr2ASMbodyLn(pst2);
    inc(bCount);
   end;

  if bo then
   begin
    if boFile then Wr2ASMbodyLn(' macWriteLnFile')
     else Wr2ASMbodyLn(' macWriteLn');
   end;

  if not CheckSymbol(rParent) then exit;
  WrPascode;
  GetSymbol;
end;


procedure Statement;
begin
{
if linecount mod 100 = 0 then write(linecount:5);
if boRB then
if Linecount = 6117 then
 writeln(linecount:7, memavail:10);
}
{!2!}
  repeat
   if not (PrevSymbol in [Semicolon, UnknownSym]) then
    begin Error(42); exit; end;

   case Symbol of
     AsmSym : AsmProc;
     BeginSym : BeginProc;
     CaseSym : CaseProc;
     CompDir1Sym,
     CompDir2Sym : SkipDirective;
     EndSym : ;
     ExitSym: ExitProc;
     ForSym : ForProc;
     GotoSym : GotoProc;
     ident : IdentProc;
     IfSym : IfProc;
     MemSym : pMemPortProc(0, True);
     MemWSym : pMemPortProc(1, True);
     MemLSym : pMemPortProc(2, True);
     PortSym : pMemPortProc(0, False);
     PortWSym : pMemPortProc(1, False);
     RepeatSym : RepeatProc;
     Semicolon : SemiColonProc;
     UnknownSym : ;
     WhileSym : WhileProc;
     WithSym : WithProc;
     WriteSym : WriteProc(False);
     WritelnSym : WriteProc(True);
    else begin Error(3); exit; end;
   end;
  until (Symbol in [UntilSym, ElseSym, EndSym, semicolon, period, UnknownSym]);

  if (Symbol = UnknownSym) then PrevSymbol := UnknownSym;
end;


procedure UsesDeclaration;
{
 Searches for all used units with their constants, types and variables
}
var
  bNowUnitOld : byte;
  sPasFileOld : alfa;
  UnL : pUnitList;
begin
  UnitLevel := 1;
  bNowUnitOld := bNowUnit;
  sPasFileOld := sPasFile;
  Symbol := Comma;

  repeat
   if not CheckSymbol(Comma) then exit;
   GetSymbol;
   sPasFile := upper(short(id));

   InsertUnit(sPasFileOld);
   if InsertProgram then
    begin
     writeln('Checking ', sPasFile + '.PAS');
     LineCount := 1;
     Close(fInput);
     assign(fInput, sPasFile + '.PAS');
     {$I-} reset(fInput); {$I+}
     if (IOresult <> 0) then begin Error(15); exit; end;

     ch := ' ';
     EndOfLine := True;
     if not GetCheckSymbol(UnitSym) then exit;

     GetSymbol;
     if (upper(short(id)) <> sPasFile) then begin Error(69); exit; end;

     if not GetCheckSymbol(semicolon) then exit;

     repeat
      GetSymbol;
      if Symbol in [CompDir1Sym, CompDir2Sym] then SkipDirective;
     until not (Symbol in [CompDir1Sym, CompDir2Sym]);
     if (upper(short(id)) <> 'INTERFACE') then begin Error(55); exit; end;

     GetSymbol;
     if (Symbol = UsesSym) then UsesDeclaration;

     while (Symbol in [ConstSym, TypeSym, VarSym, ProcSym, FuncSym]) do
      begin
       case Symbol of
         constsym : ConstDeclaration;
         procsym,
         funcsym  : begin
           GetSymbol;                   { name }
           GetSymbol;

           repeat
            if not (SymBol in [Colon, SemiColon, lParent]) then
             begin Error(85); exit; end;

            if (Symbol = lParent) then
             begin
              repeat GetSymbol until SymBol = rParent;
              GetSymbol;
             end;

            if (Symbol = Colon) then
             repeat GetSymbol until SymBol = SemiColon;
            until Symbol = SemiColon;

           GetSymbol;
          end;
         typesym  : TypeDeclaration;
         varsym   : VarDeclaration;
        end;
      end;

     if not CheckSymbol(ImplemSym) then exit;
     UnitLevel := 0;
     GetSymbol;
     if (Symbol = UsesSym) then UsesDeclaration;
     Close(fInput);

{ search for original USES string and then for next entry }
     writeln('Returning to ', sPasFileOld);
     UnitLevel := 1;
     LineCount := 1;
     bNowUnit := bNowUnitOld;
     assign(fInput, sPasFileOld + '.PAS');
     reset(fInput);
     repeat GetSymbol until Symbol = UsesSym;
     UnL := ListUnits[bNowUnit].UnitList;
     while (UnL^.NextUnit <> nil) do UnL := UnL^.NextUnit;

     repeat
      GetSymbol;
     until ((Symbol = Ident) and (upper(short(id)) = UnL^.UnitName));
    end;

   GetSymbol;
  until Symbol = semicolon;

  sPasFile := sPasFileOld;
  GetSymbol;
end; {UsesDeclaration}


procedure UsesSymbol;
var
  sPasFileOld : alfa;
begin
  sPasFileOld := sPasFile;
  UsesDeclaration;
  Close(fInput);

{ Then check the functions/procedures in the interface of all found units }
  bNowUnit := 2;
  while (ListUnits[bNowUnit].ProgName <> '') do
   begin
    sPasFile := ListUnits[bNowUnit].ProgName;
    LineCount := 1;
    writeln('Checking interface of ', sPasFile+ '.PAS');
    assign(fInput, sPasFile+ '.PAS');
    {$I-} reset(fInput); {$I+}
    if (IOresult <> 0) then begin Error(15); exit; end;
    ch := ' ';
    GetSymbol;

    repeat
     case Symbol of
       procsym, funcsym : ProcDeclaration(SymBol = funcsym, True);
       CompDir1Sym : Compiler2Directive;
       CompDir2Sym : SkipDirective;
      else GetSymbol;
     end;
    until (upper(short(id)) = 'IMPLEMENTATION');

    Close(fInput);
    inc(bNowUnit);
   end;

{ Last step: compile the implementation of the units }
  bNowUnit := 2;
  while (ListUnits[bNowUnit].ProgName <> '') do
   begin
    sPasFile := ListUnits[bNowUnit].ProgName;
    LineCount := 1;
    writeln('Checking implementation of ', sPasFile+ '.PAS');
    assign(fInput, sPasFile+ '.PAS');
    {$I-} reset(fInput); {$I+}

    repeat
     GetSymbol;
     if Symbol in [CompDir1Sym, CompDir2Sym] then SkipDirective;
    until (upper(short(id)) = 'IMPLEMENTATION');

    GetSymbol;
    if (Symbol = BeginSym) then PrevSymbol := Semicolon;
    if (Symbol = UsesSym) then
     begin
      repeat GetSymbol until Symbol = SemiColon;
      GetSymbol;
     end;

    Block(nil);

    if not CheckSymbol(period) then exit;
    Close(fInput);
    inc(bNowUnit);
   end;

  UnitLevel := 1;
  LineCount := 1;
  bNowUnit := 0;
  sPasFile := sPasFileOld;
  writeln('Returning to ', sPasFile + '.PAS');
  assign(fInput, sPasFile + '.PAS');
  reset(fInput);
  repeat GetSymbol until Symbol = UsesSym;
  repeat GetSymbol until Symbol = SemiColon;
  GetSymbol;
end;


procedure UnitDeclaration;
{
 Handles units
}
begin
  GetSymbol;
  if (upper(short(id)) <> sPasFile) then begin Error(69); exit; end;

  if not GetCheckSymbol(semicolon) then exit;

  repeat
   GetSymbol;
   if Symbol in [CompDir1Sym, CompDir2Sym] then SkipDirective;
  until not (Symbol in [CompDir1Sym, CompDir2Sym]);
  if (upper(short(id)) <> 'INTERFACE') then begin Error(55); exit; end;

  GetSymbol;
  if (Symbol = UsesSym) then UsesSymbol;

  while (Symbol in [CompDir1Sym, CompDir2Sym, ConstSym, TypeSym, VarSym
                    , ProcSym, FuncSym]) do
   begin
    case Symbol of
      CompDir1Sym : Compiler2Directive;
      CompDir2Sym : SkipDirective;
      constsym    : ConstDeclaration;
      procsym,
      funcsym     : ProcDeclaration(SymBol = funcsym, True);
      typesym     : TypeDeclaration;
      varsym      : VarDeclaration;
     end;
   end;

  if not CheckSymbol(ImplemSym) then exit;
  UnitLevel := 0;
  GetSymbol;
  if (Symbol = UsesSym) then UsesSymbol;
end;


procedure Block(tId : pIdentifier);
{ In fact the main part of the compiler }
var
  lTel : word;
  tId2 : pIdentifier;
  pst : Str80;
begin
  while (Symbol in [ConstSym, TypeSym, VarSym, LabelSym, ProcSym,
                    FuncSym, UnitSym]) do
   begin
    case Symbol of
      CompDir1Sym : Compiler2Directive;
      CompDir2Sym : SkipDirective;
      constsym    : ConstDeclaration;
      labelsym    : LabelDeclaration;
      procsym,
      funcsym     : ProcDeclaration(SymBol = funcsym, False);
      typesym     : TypeDeclaration;
      varsym      : VarDeclaration;
      Unitsym     : UnitDeclaration;
     end;
   end;

{  Calculate the offset for the variables used in procedures/functions }
  if tId <> nil then
   begin
    lTel := 0;
    tId2 := Identifier[bNowUnit][Top];

    while tId2 <> nil do
     begin
      pst := '.eq ' + tId2^.AssName + ' = $' + Dec2Hex(lTel, 4);
      writeln(ASMeql, pst);
      inc(lTel, tId2^.Size);
      tId2 := tId2^.nlink;
     end;

    tId2 := tId^.Structure^.Parameters;

    while tId2 <> nil do
     begin
      pst := '.eq ' + tId2^.AssName + ' = $' + Dec2Hex(lTel, 4);
      writeln(ASMeql, pst);
      inc(lTel, PointerSize);
      tId2 := tId2^.nlink;
     end;

    tId^.Structure^.TotSize := lTel;
   end;

  PasCode := '; begin';
  Statement;
end;


procedure Wr2ASMcommon(Re1 : string);
var
  bTel, b1 : byte;
  Re2 : string;
begin
  bTel := 0;
  Re2 := '';

  for b1 := 1 to length(Re1) do
   if (Re1[b1] <> #9) then Re2 := Re2 + Re1[b1] else
    Re2 := ml(Re2, (((length(Re2) + 1) div 8) + 1) * 8, True);

  Writeln(Re2);
end;



procedure Main;
const
  pst1 = '; === Variables === ';
  pst2 = 'HEAP .by $00, $00, $00, $00, $00, $00, $00, $00';
var
  sPasFileOld : alfa;
  b, b2 : byte;
  l1, l2 : longint;
  UnL1, Unl2 : pUnitList;
  Regel : str80;

{
ASMfile : str80;
ASMfil : text;
}

begin
  writeln;
  writeln;
  writeln;

  l1 := MemAvail;
writeln(l1);
boRB := False;

  assign(ASMbody, 'compiler.bod');
  rewrite(ASMbody);
  assign(ASMeql, 'compiler.eql');
  rewrite(ASMeql);
  assign(ASMheader, 'compiler.hea');
  rewrite(ASMheader);
  assign(ASMmid, 'compiler.mid');
  rewrite(ASMmid);

{ Init variables }
  boAbsolute := False;
  boASMcode := False;
  boComment := True;
  boHeapUsed := False;
  boReported := False;
  EndOfProg := True;
  EndOfLine := True;

  sBreak := '';
  sContinue := '';
  ch := ' ';
  sRegel := '';
  sFunctionNow := '';
  sMachine := 'C64.P65';
  sCPU := '6502';

  BlockLevel := 0;
  UnitLevel := 1;
  chCounter := 0;
  NrErrors := 0;
  Top := 0;
  WithTop := 0;
  LabelCounter := 0;
  wKonCounter := 0;
  lStartAddr := 0;
  wVarCounter := 0;
  LineCount := 1;

  PlaceHeap.bType := 1;
  PlaceVar.bType := 1;

  lBOrgAddress := $0801;

{ Stackpointer points to last OCCUPIED space }
  OrgDStack := $A000;          {## fixed for the moment}
  lStack := 0;
  lStart := 0;

  for b := 0 to MaxUnits do ListUnits[b].ProgName := '';

  Keyword[andsym    ] := ml('and           ', MaxLngIdent, True);
  Keyword[arraysym  ] := ml('array         ', MaxLngIdent, True);
  Keyword[AsmSym    ] := ml('asm           ', MaxLngIdent, True);
  Keyword[beginsym  ] := ml('begin         ', MaxLngIdent, True);
  Keyword[BoolSym   ] := ml('boolean       ', MaxLngIdent, True);
  Keyword[ByteSym   ] := ml('byte          ', MaxLngIdent, True);
  Keyword[casesym   ] := ml('case          ', MaxLngIdent, True);
  Keyword[CharSym   ] := ml('char          ', MaxLngIdent, True);
  Keyword[constsym  ] := ml('const         ', MaxLngIdent, True);
  Keyword[divsym    ] := ml('div           ', MaxLngIdent, True);
  Keyword[dosym     ] := ml('do            ', MaxLngIdent, True);
  Keyword[downtosym ] := ml('downto        ', MaxLngIdent, True);
  Keyword[elsesym   ] := ml('else          ', MaxLngIdent, True);
  Keyword[ExitSym   ] := ml('Exit          ', MaxLngIdent, True);
  Keyword[endsym    ] := ml('end           ', MaxLngIdent, True);
  Keyword[FalseSym  ] := ml('false         ', MaxLngIdent, True);
  Keyword[filesym   ] := ml('file          ', MaxLngIdent, True);
  Keyword[forsym    ] := ml('for           ', MaxLngIdent, True);
  Keyword[forwardsym] := ml('forward       ', MaxLngIdent, True);
  Keyword[funcsym   ] := ml('function      ', MaxLngIdent, True);
  Keyword[gotosym   ] := ml('goto          ', MaxLngIdent, True);
  Keyword[ifsym     ] := ml('if            ', MaxLngIdent, True);
  Keyword[InSym     ] := ml('in            ', MaxLngIdent, True);
  Keyword[ImplemSym ] := ml('implementation', MaxLngIdent, True);
  Keyword[IntSym    ] := ml('integer       ', MaxLngIdent, True);
  Keyword[LabelSym  ] := ml('label         ', MaxLngIdent, True);
  Keyword[LongSym   ] := ml('longint       ', MaxLngIdent, True);
  Keyword[MemSym    ] := ml('mem           ', MaxLngIdent, True);
  Keyword[MemlSym   ] := ml('meml          ', MaxLngIdent, True);
  Keyword[MemwSym   ] := ml('memw          ', MaxLngIdent, True);
  Keyword[modsym    ] := ml('mod           ', MaxLngIdent, True);
  Keyword[NilSym    ] := ml('nil           ', MaxLngIdent, True);
  Keyword[notsym    ] := ml('not           ', MaxLngIdent, True);
  Keyword[ofsym     ] := ml('of            ', MaxLngIdent, True);
  Keyword[orsym     ] := ml('or            ', MaxLngIdent, True);
  Keyword[packedsym ] := ml('packed        ', MaxLngIdent, True);
  Keyword[PointSym  ] := ml('pointer       ', MaxLngIdent, True);
  Keyword[PortSym   ] := ml('port          ', MaxLngIdent, True);
  Keyword[PortwSym  ] := ml('portw         ', MaxLngIdent, True);
  Keyword[procsym   ] := ml('procedure     ', MaxLngIdent, True);
  Keyword[progsym   ] := ml('program       ', MaxLngIdent, True);
  Keyword[RealSym   ] := ml('real          ', MaxLngIdent, True);
  Keyword[recordsym ] := ml('record        ', MaxLngIdent, True);
  Keyword[repeatsym ] := ml('repeat        ', MaxLngIdent, True);
  Keyword[SetOfSym  ] := ml('set           ', MaxLngIdent, True);
  Keyword[ShlSym    ] := ml('shl           ', MaxLngIdent, True);
  Keyword[ShrSym    ] := ml('shr           ', MaxLngIdent, True);
  Keyword[StringSym ] := ml('string        ', MaxLngIdent, True);
  Keyword[TextSym   ] := ml('text          ', MaxLngIdent, True);
  Keyword[thensym   ] := ml('then          ', MaxLngIdent, True);
  Keyword[tosym     ] := ml('to            ', MaxLngIdent, True);
  Keyword[TrueSym   ] := ml('true          ', MaxLngIdent, True);
  Keyword[typesym   ] := ml('type          ', MaxLngIdent, True);
  Keyword[untilsym  ] := ml('until         ', MaxLngIdent, True);
  Keyword[varsym    ] := ml('var           ', MaxLngIdent, True);
  Keyword[whilesym  ] := ml('while         ', MaxLngIdent, True);
  Keyword[withsym   ] := ml('with          ', MaxLngIdent, True);
  Keyword[UnitSym   ] := ml('unit          ', MaxLngIdent, True);
  Keyword[UsesSym   ] := ml('uses          ', MaxLngIdent, True);
  Keyword[WordSym   ] := ml('word          ', MaxLngIdent, True);
  Keyword[WriteSym  ] := ml('write         ', MaxLngIdent, True);
  Keyword[WritelnSym] := ml('writeln       ', MaxLngIdent, True);
  Keyword[XorSym    ] := ml('xor           ', MaxLngIdent, True);

  aFunction[AbsSym    ] := ml('abs      ', MaxLngIdent, True);
  aFunction[ChrSym    ] := ml('chr      ', MaxLngIdent, True);
  aFunction[FileSizSym] := ml('filesize ', MaxLngIdent, True);
  aFunction[HiSym     ] := ml('hi       ', MaxLngIdent, True);
  aFunction[LengthSym ] := ml('length   ', MaxLngIdent, True);
  aFunction[LoSym     ] := ml('lo       ', MaxLngIdent, True);
  aFunction[OddSym    ] := ml('odd      ', MaxLngIdent, True);
  aFunction[OrdSym    ] := ml('ord      ', MaxLngIdent, True);
  aFunction[predsym   ] := ml('pred     ', MaxLngIdent, True);
  aFunction[Roundsym  ] := ml('round    ', MaxLngIdent, True);
  aFunction[SizeOfSym ] := ml('sizeof   ', MaxLngIdent, True);
  aFunction[SuccSym   ] := ml('succ     ', MaxLngIdent, True);
  aFunction[SwapSym   ] := ml('swap     ', MaxLngIdent, True);
  aFunction[TruncSym  ] := ml('trunc    ', MaxLngIdent, True);


  BlockSys  := [labelsym, constsym, typesym, varsym, procsym, funcsym,
                beginsym];
  ConstSys  := [plus, minus, ByteVal, CharVal, IntVal, LongVal, RealVal,
                StringVal, WordVal, ident, TrueSym, FalseSym, StanFunc];
  NumberSys := [bytesym, intsym, longsym, wordsym];
  AllCharSys := [CharSym, CharVal, StringVal, StringSym];
  AllNumberSys := NumberSys + [byteval, intval, longval, realsym, realval, wordval];

  for b := 0 to MaxProcParms do idProcParms[b] := nil;
  for b := 1 to MaxWith do WithStruc[b] := nil;

  for b := MaxUnits downto 0 do
   for b2 := MaxTop downto 0 do Identifier[b][b2] := nil;

sPasFile := 'RB_UNIT0';
sPasFile := 'MP-ASM';
sPasFile := 'COMPILU1';
sPasFile := 'COMPILER';
sPasFile := 'OK';
{!0!}

  InsertProgram;
  writeln('Checking ', sPasFile + '.PAS');
  assign(fInput, sPasFile + '.PAS');
  reset(fInput);
  Symbol := Semicolon;
  GetSymbol;

{ Check the line "Program (<name>, <name>, ....)" }
  if Symbol = progsym then
   begin
    if not GetCheckSymbol(ident) then exit;

    GetSymbol;
    if not (Symbol in [lParent, semicolon]) then Error(85);

    if Symbol = lParent then
     begin
      GetSymbol;
      GetVarIdentifier(True, False, False);      { Treat parameters as TEXT }
      if not CheckSymbol(rParent) then exit;
      GetSymbol;
     end;

    if CheckSymbol(semicolon) then GetSymbol
     else exit;
   end;

{ Proces compiler directives }
  while (Symbol in [CompDir1Sym, CompDir2Sym]) do
   begin
    if Symbol = CompDir1Sym then Compiler1Directive;
    if Symbol = CompDir2Sym then Compiler2Directive;
   end;

  if not exists(sMachine) then
   begin
    Error(216);
    exit;
   end;

  Wr2ASMheaderLn('.eq DStack'#9'= $' + Dec2Hex(OrgDStack, 4));
  Wr2ASMheaderLn('.UU ' + sMachine);
  Wr2ASMheaderLn('.P' + sCPU);

  if lStartAddr = 0 then
   begin
    Wr2ASMheaderLn('.ba $' + Dec2Hex(lBOrgAddress, 4));
    Wr2ASMheaderLn(#9#9'macBasicStart ' + Dec2Hex(lBOrgAddress + 11, 4));
    Wr2ASMheaderLn('; ');
   end
  else Wr2ASMheaderLn('.ba $' + Dec2Hex(lStartAddr, 4));

  Wr2ASMheaderLn(ASMline(' macJump zFirstLine'));
  Wr2ASMheaderLn('.UP');
  Wr2ASMheaderLn(' ');
  Wr2ASMbodyLn('  ');
  Wr2ASMmidLn('zFirstLine ');
  Close(fInput);

{ Store reserved variables like NIL }
  sPasFileOld := sPasFile;
  sPasFile := 'RESERVED';
  writeln('Checking ', sPasFile + '.PAS');

  InsertProgram;
  InsertUnit(sPasFileOld);

  with tReM do
   begin
    Name := 'NIL';
    l := 0;
    Symbol := PointSym;
    StoreReservedVar(tReM, False);
   end;

  LineCount := 1;
  assign(fInput, sPasFile+ '.PAS');
  {$I-} reset(fInput); {$I+}

  if (IOresult <> 0) then begin Error(15); exit; end;

  ch := ' ';
  EndOfLine := True;
  GetSymbol;
  Block(nil);

  if not CheckSymbol(period) then begin Error(94); exit; end;

{ search for original USES string and then for next entry }
  close(fInput);
  writeln('Returning to ', sPasFileOld + '.PAS');
  sPasFile := sPasFileOld;

  LineCount := 1;
  bNowUnit := 0;
  assign(fInput, sPasFile + '.PAS');
  reset(fInput);
  ch := ' ';
  EndOfLine := True;
  Symbol := Semicolon;
  GetSymbol;

  if (Symbol = ProgSym) then
   begin
    repeat GetSymbol until Symbol = SemiColon;
    GetSymbol;
   end;

  while Symbol in [CompDir1Sym, CompDir2Sym] do SkipDirective;

  if (Symbol = UsesSym) then UsesSymbol;

{!1!}
  Block(nil);

  if CheckSymbol(period) then
   begin
{writeln(memavail);}
    writeln('Storing constants and variables....');
    Wr2ASMbodyLn(' macEndOfProgram ');
    Wr2ASMbodyLn('EndOfProgram ');
    Wr2ASMbodyLn(' ');

    Wr2ASMheaderLn(' ');
    Wr2ASMheaderLn('; === Constants === ');
    WriteConst;
    Wr2ASMheaderLn(' ');

    if (PlaceVar.bType <> 2) then
     begin
      if (PlaceVar.bType = 1) then Wr2ASMbodyLn(pst1)
       else Wr2ASMheaderLn(pst1);
      WriteVars;
     end;

    if (PlaceHeap.bType <> 2) and boHeapUsed then
     Wr2ASMbodyLn(pst2);

    if (PlaceVar.bType = 2) then
     begin
      Wr2ASMbodyLn(' ');
      Wr2ASMbodyLn(pst1);
      Wr2ASMbodyLn('.ba $' + Dec2Hex(PlaceVar.Address, 4));
      WriteVars;
     end;

    if (PlaceHeap.bType = 2) and boHeapUsed then
     begin
      Wr2ASMbodyLn(' ');
      Wr2ASMbodyLn('.ba $' + Dec2Hex(PlaceHeap.Address, 4));
      Wr2ASMbodyLn(pst2);
     end;

    Wr2ASMbodyLn('.en');
    Wr2ASMbodyLn(' ');
{writeln(memavail);}
   end;

  close(ASMbody);
  close(ASMeql);
  close(ASMheader);
  close(ASMmid);


  if (Symbol <> UnknownSym) then
   begin
ASMfile := 'OK.ASM';

    assign(ASMfil, ASMfile);
    rewrite(ASMfil);

    reset(ASMeql);
    repeat
     readln(ASMeql, Regel);
     writeln(ASMfil, Regel);
    until EOF(ASMeql);
    close(ASMeql);

    reset(ASMheader);
    repeat
     readln(ASMheader, Regel);
     writeln(ASMfil, Regel);
    until EOF(ASMheader);
    close(ASMheader);

    reset(ASMmid);
    repeat
     readln(ASMmid, Regel);
     writeln(ASMfil, Regel);
    until EOF(ASMmid);
    close(ASMmid);

    reset(ASMbody);
    repeat
     readln(ASMbody, Regel);
     writeln(ASMfil, Regel);
    until EOF(ASMbody);
    close(ASMbody);
    close(ASMfil);
   end;

  close(fInput);
  erase(ASMeql);
  erase(ASMheader);
  erase(ASMmid);
  erase(ASMbody);

{ Dispose all used NEW-memory }
  for b2 := MaxUnits downto 0 do
   for b := MaxTop downto 0 do DisposeIdentifier(Identifier[b2][b]);

  b := 0;
  while ListUnits[b].ProgName <> '' do
   begin
    UnL1 := ListUnits[b].UnitList;

    while UnL1 <> nil do
     begin
       UnL2 := UnL1;
       UnL1 := UnL2^.NextUnit;
       Dispose(UnL2);
     end;

    inc(b);
   end;

  l2 := MemAvail;

  if (Symbol <> UnknownSym) then
   begin
    if l1 <> l2 then
     begin
      writeln;
      writeln(l1, ' ', l2, '    Press ENTER');
      readln;
     end;

    ASMmain;

    assign(fb1, 'ok.prg');
    assign(fb2, 'c:\winnt\profiles\eb35002\winvice\ok');
    assign(fb2, 'D:\util\winvice\ok');
{    assign(fb2, 'E:\Ruud\winvice\ok');}
    reset(fb1);
    rewrite(fb2);

    repeat
     read(fb1, b);
     write(fb2, b);
    until EOF(fb1);

    close(fb1);
    close(fb2);
   end;
end;


begin
  Main;
end.


