unit mp_asmu0;


interface

uses RB_unit0, mp_asmU9, mp_asmU1, mp_asmU2, mp_asmU3;


procedure  ASMmain;
procedure  ReadParameters;


{============================================================================}



implementation

{
var
}

procedure HelpMessage;
begin
  writeln;
  writeln('Usage: MP-ASM /F<filename> [/L] [/R$aaaa-$bbbb]',#13#10);
  writeln('/L              = save Labels in <filename>.LBL');
  writeln('/R$aaaa-$bbbb   = range of bytes which should be saved');
  writeln;
  writeln;
  Halt(1);
end;


procedure pass;
var
  i1, i2 : integer;
  lCmt : longint;
  Teller : word;
  CmtRegel, pst : str80;
begin
  reset(ft);
  RegelNr := 0;
  boEOF := false;
  boMacro := false;
  lCmt := 0;
  lBlkEaddress := 0;

  repeat
   bCodeType := 0;
   if boEOF then ErrorEnd(21);                         { no .EN found }

   inc(RegelNr);
   readln(ft, Regel);
   val(short(copy(Regel, 1, 6)), RegelNr2, i1); { extract original line number }
   delete(Regel, 1, 6);
   LabelName := '';
   Opcode    := '';
   Directive := '';
   if (bPass = 3) then LstRegel := '$' + Dec2Hex(BufPtr, 6) + '     ';


   pst := short(regel);
   if ((pst[1] = ';') or (pst = '')) then
    begin
     OrgRegel := Regel;
     Write_Lst;
     continue;
    end;

{ Check for & = Macro parameter }
   if pos('&', Regel) > 0 then
    begin
     CheckMacro(Regel);
     CheckMacro(OrgRegel);
    end;

   OrgRegel := Regel;


{### debuging tool ###}

if (RegelNr2 = 18) {and (bPass = 3)} then
 pst := dec2hex(Bufptr, 4);

{######################}


{ First character is SPACE, TAB or part of label or Directive }
   if not (Regel[1] in [' ', '.', #9]) then
    begin                                               { found label }
     Teller := 0;

     while (    not(Regel[Teller+1] in [' ', #9])
            and (Teller < length(Regel))
           ) do inc(Teller);

     LabelName := upper(copy(Regel,1,Teller));

     if Teller = length(Regel) then Regel := ''
      else DeleteS8(Regel, 1, Teller);
    end;

   Regel := short(Regel);

{ Either Directive or Opcode/comment must be first now }
   if (Regel <> '') then
    begin
     if (Regel[1] = '.') then
      begin

  { found Directive }
       Teller := 0;

       while (    not(Regel[Teller+1] in [' ',#9])
              and (Teller<length(Regel))
             ) do inc(Teller);

       Directive := upper(copy(Regel, 1, Teller));

       if Teller = length(Regel) then Regel := ''
        else DeleteS8(Regel, 1, Teller);
      end
       else
      begin

  { found Opcode/comment }
       if (Regel[1] <> ';') then
        begin

    { found Opcode }
         Teller := 0;

         while (not(Regel[Teller+1] in [' ',#9])
            and (Teller<length(Regel))) do inc(Teller);

         Opcode := Upper(copy(Regel,1,Teller));

{ Rest of line is operand and/or comment }
         if Teller <= length(Regel) then
          DeleteS8(Regel, 1, Teller);

         if (Regel[1] = ';') then
          begin

      { Comment }
           Commentaar := Regel;
           Regel := '';
          end
           else commentaar := '';
        end;
      end;
    end;

{ Validate label }
   if (LabelName <> '') then
    begin
     if length(LabelName)>17 then ErrorEnd(13);   { max length = 16 }

     for Teller := 1 to length(LabelName) do
      if not(LabelName[Teller] in ['A'..'Z','0'..'9','_']) then ErrorEnd(17);

     if LabelName[1] in ['0'..'9'] then ErrorEnd(17);

  { Some names are not allowed }
     if (   (LabelName = 'A')                   { 65xxx registers }
         or (LabelName = 'D')
         or (LabelName = 'DBR')
         or (LabelName = 'M')
         or (LabelName = 'P')
         or (LabelName = 'PBR')
         or (LabelName = 'S')
         or (LabelName = 'X')
         or (LabelName = 'Y')
         or (LabelName = 'B')
         or (LabelName = 'C')
         or (LabelName = 'E')
         or (LabelName = 'G')
         or (LabelName = 'J')
         or (LabelName = 'CPU')                 { for internal use }
        ) then ErrorEnd(12);

     if (bPass = 1) then
      begin

{ Check if label already exists }
       Teller := 0;
       while (    (LabelName <> Labels^[Teller]._naam)
              and (Teller < wLabelTot)
             ) do inc(Teller);

       if (Teller < wLabelTot) then ErrorEnd(22);

{ Now add to table }
       Labels^[wLabelTot]._naam := LabelName;

       if boMoved then Labels^[wLabelTot]._Value := BufPtr + lRaddress
        else Labels^[wLabelTot]._Value := BufPtr;

       Labels^[wLabelTot]._type := Value2Type(Labels^[wLabelTot]._Value);
       inc(wLabelTot);
      end
       else
      begin

{ Look for label and validate it }
       Teller := 0;
       while Labels^[Teller]._naam <> LabelName do inc(Teller);
       if boMoved then Labels^[Teller]._Value := BufPtr + lRaddress
        else Labels^[Teller]._Value := BufPtr;
      end;
    end;

{ Value Directive }
   if ((Directive <> '') and fDirective) then exit;

{ Validate Opcode }
   if (Opcode <> '') then
    begin

  {  operand  }
     Teller := length(Regel);
     while ((Teller > 0) and (Regel[Teller] <> ';')) do dec(Teller);
     if Teller > 0 then
      begin
       Commentaar := copy(Regel, Teller, length(Commentaar)-Teller-1);
       Regel := short(copy(Regel, 1, Teller-1));
      end;

  {  no characters used -> everything Upcase  }
     if (pos(#34, Regel) or pos(#39, Regel)) = 0 then
      Regel := Upper(Regel);

     case uPmode of
       0, 7 : CheckOpcode65;
       8    : CheckOpcodeGideon;
       10   : CheckOpcodeZ80;
      end;
    end;


{ Value comment }
   if ((Commentaar <> '') and (Commentaar[1] <> ';')) then ErrorEnd(6);
   Write_Lst;
  until false;
end;


(*
procedure passX;
var
  i1, i2 : integer;
  lCmt : longint;
  Teller : word;
  sRegelNr, CmtRegel, pst : str80;
begin
  reset(ft);
  assign(ftN, NewFil2);
  rewrite(ftN);
  RegelNr := 0;
  sRegelNr := '    0 ';
  boEOF := false;
  boMacro := false;
  lCmt := 0;
  lBlkEaddress := 0;
  boInitPass := True;
  RegelNr2 := -1;

  repeat
   bCodeType := 0;
   if boEOF then ErrorEnd(21);          { no .EN found }

   if boMacro then

{ Read Macro }
    repeat
     readln(fMac[bMacroNest], Regel);

  {  Discard large areas between /* and */  }
     if copy(short(Regel), 1, 2) = '/*' then
      begin
       repeat
        readln(fMac[bMacroNest], Regel);
        boEOF := EOF(fMac[bMacroNest]);
       until ((copy(short(Regel), 1, 2) = '*/') or boEOF);

       if not boEOF then readln(fMac[bMacroNest], Regel);
      end;

     boEOF := EOF(fMac[bMacroNest]) or boEOF;
    until (((Regel[1] <> ';') and (short(Regel) <> '')) or boEOF)
   else
    begin
     readln(ft, Regel);
     sRegelNr := short(copy(Regel, 1, 6));
     val(sRegelNr, RegelNr2, i1);       { extract original line number }
     delete(Regel, 1, 6);
     boEOF := EOF(ft) or boEOF;
    end;

   inc(RegelNr);
   LabelName := '';
   Opcode    := '';
   Directive := '';
   if (bPass = 3) then LstRegel := '$' + Dec2Hex(BufPtr, 6) + '     ';

   pst := short(regel);
   if ((pst[1] = ';') or (pst = '')) then
    begin
     writeln(ftN, sRegelNr + Regel);
     Write_Lst;
     continue;
    end;

{### debuging tool ###}

if (RegelNr = 33) {and (bPass = 3)} then
 pst := dec2hex(Bufptr, 4);

{######################}


{ Check for & = Macro parameter }
   if pos('&', Regel) > 0 then CheckMacro(Regel);

   OrgRegel := Regel;

{ First character is SPACE, TAB or part of label or Directive }
   if not (Regel[1] in [' ', '.', #9]) then
    begin                                               { found label }
     Teller := 0;

     while (    not(Regel[Teller+1] in [' ', #9])
            and (Teller < length(Regel))
           ) do inc(Teller);

     LabelName := upper(copy(Regel,1,Teller));

     if Teller = length(Regel) then Regel := ''
      else DeleteS8(Regel, 1, Teller);
    end;

   Regel := short(Regel);

{ Either Directive or Opcode/comment must be first now }
   if (Regel <> '') then
    begin
     if (Regel[1] = '.') then
      begin

  { found Directive }
       Teller := 0;

       while (    not(Regel[Teller+1] in [' ',#9])
              and (Teller<length(Regel))
             ) do inc(Teller);

       Directive := upper(copy(Regel, 1, Teller));

       if Teller = length(Regel) then Regel := ''
        else DeleteS8(Regel, 1, Teller);
      end
       else
      begin

  { found Opcode/comment }
       if (Regel[1] <> ';') then
        begin

    { found Opcode }
         Teller := 0;

         while (not(Regel[Teller+1] in [' ',#9])
            and (Teller<length(Regel))) do inc(Teller);

         Opcode := Upper(copy(Regel,1,Teller));

{ Rest of line is operand and/or comment }
         if Teller <= length(Regel) then
          DeleteS8(Regel, 1, Teller);

         if (Regel[1] = ';') then
          begin

      { Comment }
           Commentaar := Regel;
           Regel := '';
          end
           else commentaar := '';
        end;
      end;
    end;

{ Validate label }
   if (LabelName <> '') then
    begin
     if length(LabelName)>17 then ErrorEnd(13);   { max length = 16 }

     for Teller := 1 to length(LabelName) do
      if not(LabelName[Teller] in ['A'..'Z','0'..'9','_']) then ErrorEnd(17);

     if LabelName[1] in ['0'..'9'] then ErrorEnd(17);

  { Some names are not allowed }
     if (   (LabelName = 'A')                   { 65xxx registers }
         or (LabelName = 'D')
         or (LabelName = 'DBR')
         or (LabelName = 'M')
         or (LabelName = 'P')
         or (LabelName = 'PBR')
         or (LabelName = 'S')
         or (LabelName = 'X')
         or (LabelName = 'Y')
         or (LabelName = 'B')
         or (LabelName = 'C')
         or (LabelName = 'E')
         or (LabelName = 'G')
         or (LabelName = 'J')
         or (LabelName = 'CPU')                 { for internal use }
        ) then ErrorEnd(12);

     if bPass = 1 then
      begin

{ Check if label already exists }
       Teller := 0;
       while (    (LabelName <> Labels^[Teller]._naam)
              and (Teller<wLabelTot)
             ) do inc(Teller);

       if (Teller < wLabelTot) then ErrorEnd(22);

{ Now add to table }
       Labels^[wLabelTot]._naam := LabelName;

       if boMoved then Labels^[wLabelTot]._Value := BufPtr + lRaddress
        else Labels^[wLabelTot]._Value := BufPtr;

       Labels^[wLabelTot]._type := Value2Type(Labels^[wLabelTot]._Value);
       inc(wLabelTot);
      end
       else

     if bPass > 1 then
      begin

{ Look for label and validate it }
       Teller := 0;
       while Labels^[Teller]._naam <> LabelName do inc(Teller);

       if boMoved then Labels^[Teller]._Value := BufPtr + lRaddress
        else Labels^[Teller]._Value := BufPtr;
      end;
    end;

{ Value Directive }
   if ((Directive <> '') and fDirective) then
    begin
     writeln(ftN, sRegelNr + OrgRegel);
     exit;
    end;

{ Validate Opcode }
   if (Opcode <> '') then
    begin

  {  operand  }
     Teller := length(Regel);
     while ((Teller > 0) and (Regel[Teller] <> ';')) do dec(Teller);
     if Teller > 0 then
      begin
       Commentaar := copy(Regel, Teller, length(Commentaar)-Teller-1);
       Regel := short(copy(Regel, 1, Teller-1));
      end;

  {  no characters used -> everything Upcase  }
     if (pos(#34, Regel) or pos(#39, Regel)) = 0 then
      Regel := Upper(Regel);

    if (copy(Opcode,1 ,3) = 'MAC') then
     begin
      writeln(ftN, sRegelNr + Labelname);
      Look4Macro;
      Continue;
     end
    else
     case uPmode of
       0, 7 : CheckOpcode65;
       10   : CheckOpcodeZ80;
      end;
    end;

{ Value comment }
   if ((Commentaar <> '') and (Commentaar[1] <> ';')) then ErrorEnd(6);
   writeln(ftN, sRegelNr + OrgRegel);
   Write_Lst;
  until false;

  close(ft);
  erase(ft);
  close(ftN);
  assign(ft,NewFil2);
  rename(ft,NewFile);
  reset(ft);
end;
*)


procedure ReadParameters;
{---------------------------------------------------------------------------
Reads parameters behind the command and checks if they are valid
 in:  -
 out: -
---------------------------------------------------------------------------}
var
  pbo          : boolean;
  by           : byte;
  I,i2         : integer;
  plo          : longint;
  Cmd,pst,pst2 : string;
begin
  AsmFile  := '';
  pbo      := false;
  boLabels := false;


{ Check number of parameters }
  if paramcount = 0 then HelpMessage;

{ Check parameters one by one }
  for I := 1 to ParamCount do
   begin

    Cmd := Upper(ParamStr(I));
    if Copy(Cmd, 1, 2) = '/F' then
     begin

  { Parameter is filename }
      AsmFile := copy(Cmd, 3, length(Cmd)-2);
     end
      else
    if Copy(Cmd, 1, 2) = '/L' then
     begin

  { print Labels }
      boLabels := true;
     end
      else
    if (Cmd = '/?') Or (Cmd = '/H') then
     begin

  { Helpmessage }
      HelpMessage;
     end
      else
    if Copy(Cmd, 1, 2) = '/R' then
     begin

  { Range of bytes actualy to write to disk }
      pst := copy(Cmd, 3, length(Cmd)-2);
      by := pos('-', pst);
      pst2 := copy(pst, by+1, length(pst) - by);
      pst[0] := chr(by-1);

      val(pst, plo, I2);
      pbo := (I2 > 0);
      lBaddress := plo and $FFFFFF;

      val(pst2, plo, I2);
      pbo := pbo or (I2 > 0);
      lEaddress := plo and $FFFFFF;

  { Check range and position }
      pbo := pbo or (lEaddress < lBaddress);
     end
      else
     pbo := true;
   end;

{ (PBO = true) = Error! }
  if (pbo or (AsmFile = '')) then HelpMessage;
end;


procedure ASMmain;
var
  by, bLoopCnt : byte;
  f : file;
  fb : file of byte;
  fsize, plo : longint;
  tmUI : pUnitInfo;
  pst : str16;
  ft4 : text;
  ComLabel : Tlabel;
  tl, tl2, Last, Teller, wLabelTot2 : word;
begin

{ Check existence ASM-file }
  if not exists(AsmFile) then AsmFile := AsmFile + '.A64';
  if not exists(AsmFile) then
   begin
    writeln(zin(51));
    beeep;
    halt(1);
   end;

  by := length(AsmFile);
  while ((by > 0) and (AsmFile[by] <> '.')) do dec(by);
  if by = 0 then by := length(AsmFile) else dec(by);
  ASMFil2 := copy(AsmFile, 1, by) + '.AS2';
  ASMFil3 := copy(AsmFile, 1, by) + '.AS3';
  NewFile := copy(AsmFile, 1, by) + '.NEW';
  NewFil2 := copy(AsmFile, 1, by) + '.NE2';
  LstFile := copy(AsmFile, 1, by) + '.LST';
  BinFile := copy(AsmFile, 1, by) + '.ROM';
  PrgFile := copy(AsmFile, 1, by) + '.PRG';
  LabFile := copy(AsmFile, 1, by) + '.LBL';
  ResFile := copy(AsmFile, 1, by) + '.RES';


{  Look for .BA, must be "first", and look for possible .UP and .UU  }
  assign(ft,AsmFile);
  reset(ft);
  Found := false;
  RegelNr := 0;
  boUseUP := False;

  repeat
   readln(ft, Regel);
   Regel := upper(short(Regel));
   inc(RegelNr);

   found := (    (Regel[1] <> ';')              { not starting with comment}
             and (Regel <> '')                  { not empty }
             and (copy(Regel, 1, 3) <> '.CO')   { no assembling comment }
             and (copy(Regel, 1, 3) <> '.EI')   { no end of IF }
             and (copy(Regel, 1, 3) <> '.EL')   { no ELSE }
             and (copy(Regel, 1, 3) <> '.EQ')   { no EQUAL }
             and (copy(Regel, 1, 3) <> '.FI')   { no FILE loading }
             and (copy(Regel, 1, 3) <> '.IF')   { no IF }
             and (copy(Regel, 1, 3) <> '.MA')   { no MACRO }
             and (copy(Regel, 1, 2) <> '.P')    { no CPU }
             and (copy(Regel, 1, 3) <> '.ME')   { no end of macro }
             and (copy(Regel, 1, 3) <> '.UU')); { no Use Units }

   boUseUnits := boUseUnits or (copy(Regel, 1, 3) = '.UU');
   boUseUP := boUseUP or (copy(Regel, 1, 3) = '.UP');
  until found or EOF(ft);

  if copy(Regel, 1, 3) <> '.BA' then ErrorEnd(11);

  while not boUseUP and not EOF(ft) do
   begin
    readln(ft, Regel);
    Regel := upper(short(Regel));
    inc(RegelNr);
    boUseUP := (copy(Regel, 1, 3) = '.UP');
   end;


  new(Buffer);
  new(UnknLabel);
  new(Labels);

  bMacroNest := 0;
  lBlkBaddress := $FFFFFF;
  BAfound := false;
  BufPtr := 0;
  wCondPtr := 0;
  lBlkEaddress := 0;
  boDelR6 := True;
  boInternVar := false;
  boFIfound := false;
  boMoved := false;
  boNotFound := true;
  lRaddress := 0;
  uPmode := 0;
  boWrLine := false;
  bVarTeller := 0;
  ActualMacro := nil;
  UnitInfo := nil;

{ Translate macros to readable text and collect external procedures. }
  writeln(zin(37));
  new(MarInfo);

  for Teller := 0 to maxMarInfo do
   begin
    MarInfo^[Teller].Name := '';
    MarInfo^[Teller].Used := False;
   end;

  wMarInfoTel := 0;
  wLabelTot := 0;
  wLabelTot2 := 0;
  pass0;

{ Get all .EQ's from external units }
  if boUseUnits then
   begin
    close(ft);
    boDelR6 := False;
    tmUI := UnitInfo;

    while tmUI <> nil do
     begin
      assign(ft, tmUI^.Name);
      reset(ft);
      boEOF := false;

      repeat
       repeat
        readln(ft, Regel);

     {*  Discard large areas between /* and */  *}
        if copy(short(Regel), 1, 2) = '/*' then
         begin
          repeat
           readln(ft, Regel);
           boEOF := EOF(ft);
          until ((copy(short(Regel), 1, 2) = '*/') or boEOF);

          if not boEOF then readln(ft, Regel);
         end;

        boEOF := EOF(ft) or boEOF;
        Regel := short(Regel);
       until (((Regel[1] <> ';') and (Regel <> '')) or boEOF);

      if (Regel <> '') and (Regel[1] = '.') then
       begin

   {* found Directive *}
        Teller := 0;

        while (    not(Regel[Teller+1] in [' ',#9])
               and (Teller<length(Regel))
              ) do inc(Teller);

        Directive := upper(copy(Regel, 1, Teller));

        if Teller = length(Regel) then Regel := ''
         else DeleteS8(Regel, 1, Teller);

        if not (   (Directive = '.AL') or (Directive = '.EQ')
                or (Directive = '.IF') or (Directive = '.EL')
                or (Directive = '.CO') or (Directive = '.EI')
                or (Directive = '.MA') or (Directive = '.MP')) then
             ErrorEnd(9);

        fDirective;
       end;
      until boEOF;

      close(ft);
      tmUI := tmUI^.Next;
     end;

    wLabelTot2 := wLabelTot;
    boDelR6 := True;
    assign(ft, NewFile);
    reset(ft);
   end;

  repeat
   repeat
    boLoop := False;
    boNotFound := true;
    wLabelTot := wLabelTot2;
    wUnknownTot := 0;
    pass1;
   until not boLoop;

{ Determine roughly place of Labels etc. }
   bPass := 1;
   BufPtr := 0;
   boNotFound := true;
   wLabelTot := wLabelTot2;
   wUnknownTot := 0;
   pass;

{ Use all found Labels to determine global positioning }
   bPass := 2;
   wUnknownTot := 0;
   BufPtr := 0;
   boNotFound := true;
   pass;

   if boLoop then
    begin
     boLoop := False;
     if not boUseUP then
      begin
       writeln;
       for Teller := wMarInfoTel-1 downto 0 do writeln(MarInfo^[Teller].Name);
       ErrorEnd(59);
      end;

{ Split file up in two parts }
     reset(ft);
     assign(ft2,NewFil2);
     rewrite(ft2);

     repeat
      readln(ft, Regel);
      writeln(ft2, Regel);
      pst := copy(Regel, 1, 6);
      delete(Regel, 1, 6);
     until (copy(upper(short(Regel)), 1, 3) = '.UP');

{ Insert found procedure }
     for Teller := wMarInfoTel-1 downto 0 do
      if not MarInfo^[Teller].Used then
       Look4ExtProc(MarInfo^[Teller], pst);

     writeln(ft2, ' ');

     repeat
      readln(ft, Regel);
      writeln(ft2, Regel);
     until EOF(ft);

     close(ft);
     erase(ft);
     close(ft2);
     assign(ft,NewFil2);
     rename(ft,NewFile);
     reset(ft);
    end;
  until not boLoop;

  dispose(MarInfo);


(*
{ Found unknown Labels? }
  if wUnknownTot>0 then
   begin                                  { Yes }
    RegelNr2 := UnknLabel^[0];
    RegelNr := 0;
    ErrorEnd(18);
   end;
*)

{ Try do determine if Labels have been validated }
  boNotFound := true;
  bLoopCnt := 0;
  wNestCnt1 := 255;
  wNestCnt2 := 0;
  boNesting := false;

  while not boNotFound do
   begin
    if bLoopCnt > 3 then
     begin
      if wNestCnt2 = wNestCnt1 then
       begin

  { Number of nested Labels does NOT change !!! }
        if boNesting then halt(1) else
         begin
          writeln(zin(52), #10);
          boNesting := true;                 { start to display them }
         end;
       end
        else wNestCnt1 := wNestCnt2;
     end;

    wNestCnt2 := 0;
    if not boNesting then writeln(zin(32));
    wUnknownTot := 0;
    BufPtr := 0;
    boNotFound := true;
    pass;
    inc(bLoopCnt);
   end;

{ Load ROM file to be overwritten }
  for tl := 8 to $FFFF do Buffer^[tl] := $FF;
  if boFIfound then
   begin
    assign(fb,Filenaam);
    reset(fb);
    fsize := filesize(fb);

    if (lFIptr and $FFFF) + fsize > $FFFF then ErrorEnd(41);

    writeln(zin(26), Filenaam, zin(27), Dec2Hex(lFIptr, 6)
              , zin(28), Dec2Hex(lFIptr + fsize - 1, 6));
    for plo := 0 to fsize-1 do
     begin
      read(fb, by);
      Buffer^[(lFIptr + plo) and $FFFF] := by;
     end;

    if lBlkEaddress < lFIptr + fsize - 1 then lBlkEaddress := lFIptr + fsize - 1;
    close(fb);
   end;

{ Final determination of place of all Labels }
  writeln('Final pass...');
  assign(ft3,ResFile);
  rewrite(ft3);
  assign(ft2,LstFile);
  rewrite(ft2);
  bPass := 3;
  wUnknownTot := 0;
  BufPtr := 0;
  pass;
  close(ft2);


{ Use FILE to speed up saving }
  if lBlkEaddress - lBlkBaddress + 1 > 0 then
   begin
    assign(f,PRGfile);
    rewrite(f, lBlkEaddress - lBlkBaddress + 3);
    Buffer^[8] := lo(lBlkBaddress);
    Buffer^[9] := hi(lBlkBaddress);
    for tl := lBlkBaddress to lBlkEaddress do
      Buffer^[10 + tl - lBlkBaddress] := Buffer^[tl];
    blockwrite(f, Buffer^, 1);
    close(f);

    assign(f,binfile);
    rewrite(f, lBlkEaddress - lBlkBaddress + 1);
    for tl := lBlkBaddress to lBlkEaddress do
      Buffer^[8 + tl - lBlkBaddress] := Buffer^[10 + tl - lBlkBaddress];
    blockwrite(f, Buffer^, 1);
    close(f);
   end
    else writeln(zin(31));

  dispose(Buffer);
  close(ft3);
  if ((not boLabels) or (wLabelTot = 0)) then exit;

{ Print all Labels }
  writeln('Saving ', wLabelTot, ' Labels...');
  assign(ft4, Labfile);
  rewrite(ft4);

 { Sort on value }
  for tl := 0 to wLabelTot-1 do
   begin
    Last := tl;
    for tl2 := tl+1 to wLabelTot-1 do
      if (Labels^[tl2]._Value < Labels^[last]._Value) then last := tl2;
    ComLabel := Labels^[tl];
    Labels^[tl] := Labels^[last];
    Labels^[last] := ComLabel;
    with Labels^[tl] do
      pst := ml(_naam, 17, true) + _type + ' $' + Dec2Hex(_Value, 6);
    writeln(ft4, pst);
   end;

  pst := ' ';
  writeln(ft4, pst);

 { Sort on name }
  for tl := 0 to wLabelTot-1 do
   begin
    Last := tl;
    for tl2 := tl+1 to wLabelTot-1 do
      if (upper(Labels^[tl2]._naam) < upper(Labels^[last]._naam)) then
        last := tl2;
    ComLabel := Labels^[tl];
    Labels^[tl] := Labels^[last];
    Labels^[last] := ComLabel;
    with Labels^[tl] do
      pst := ml(_naam, 17, true) + _type + ' $' + Dec2Hex(_Value, 6);
    writeln(ft4, pst);
   end;

  close(ft);
  close(ft4);
  writeln;
  writeln;
  dispose(Labels);
  dispose(UnknLabel);
end;


begin
end.

(**
.al = ALter value of label
.ap = APpend file
.ba = Begin Address
.by = BYte
.co = COmment to be displayed on screen during 3rd pass
.ei = End If, conditional programming
.el = Else, conditional programming
.en = ENd of text
.eq = EQuals (permanent)
.fb = Fill Byte xxxx times
.fd = Fill Doubleword xxxx times
.fi = FIle as base
.fw = Fill Word xxxx times
.if = IF, conditional programming
.ma = MAcro
.me = Macro End
.rb = Re-address Begin
.re = Re-address End
.tx = TeXt
.wo = WOrd
;   = remark
**)
