unit mp_asmu2;


interface


uses RB_unit0, MP_ASMU1, MP_ASMU4, MP_ASMU9;


procedure  CheckOpcode65;
procedure  CheckOpcodeGideon;


{============================================================================}



implementation



function ChkLabel(var Soort : byte) : boolean;
{-----------------------------------------------------------------------------
Checks if operand is empty or is a known register. Used for ASL, ROR etc.
-----------------------------------------------------------------------------}
var
  by : byte;
  pst1, pst2 : string;
begin
  Soort := 0;
  by := pos(';', Regel);

  if by > 0 then
   begin                                { comment found }
    pst1 := copy(Regel, 1, by-1);
    pst2 := copy(Regel, by+1, length(Regel)-by);
   end
  else
   begin
    pst1 := Regel;
    pst2 := '';
   end;

  if (   (pst1 = '')
      or (    (pst1[1] in ['A', 'C', 'G', 'J', 'P', 'T', 'X', 'Y', 'Z'])
          and ((pst1[0] = #1) or (pst1[2] = '!'))
         )
     ) then
   begin
    if (pst1 = '') then cSrcReg := 'A' else cSrcReg := pst1[1];
    Soort := 14;
    Regel := '';
    Commentaar := pst2;
   end;

  ChkLabel := (Soort = 0);
end;


procedure CheckExtension;
var
  b1 : byte;
begin
{* Check for GZ extensions *}
  b1 := pos('.', Opcode);

  if (b1 > 0) then
   begin
    if not(upMode in [7, 8]) then ErrorEnd(46);

    GZextension := upper(copy(Opcode, b1 + 1, length(Opcode) - b1));

    if (pos(GZextension, 'B') > 0) then bMemWidth := $00 else
    if (pos(GZextension, 'W') > 0) then bMemWidth := $01 else
    if (pos(GZextension, 'H') > 0) then bMemWidth := $02 else
    if (pos(GZextension, 'D') > 0) then bMemWidth := $03;

    if (pos(GZextension, 'S') > 0) then bAddrWidth := $00 else
    if (pos(GZextension, 'L') > 0) then bAddrWidth := $01 else
    if (pos(GZextension, 'F') > 0) then bAddrWidth := $03;

    if upMode = 8 then Opcode[0] := chr(b1 - 1);
   end
    else GZextension := '';
end;


procedure CheckWidth(data : longint; bw : byte);
begin
  if ((bw = 0) and ((data < 0) or (data > $FF))) then ErrorEnd(99) else
  if ((bw < 3) and ((data < 0) or (data > $FFFF))) then ErrorEnd(99);
end;


procedure DestReg2Code(c : char);
begin
  case chr(ord(c) and $DF) of
   'C' : bDesReg := $1C;
   'G' : bDesReg := $10;
   'J' : bDesReg := $14;
   'S' : bDesReg := $18;
   'T' : bDesReg := $00;
   'X' : bDesReg := $08;
   'Y' : bDesReg := $0C;
   'Z' : bDesReg := $00;
    else bDesReg := $04;
  end;
end;


procedure OperBranchGZ(Opc1, Opc2, OpcO : byte);
var
  VOSoort : char;
  tel : integer;
  OValue, plo, plo2 : longint;
  pst : string;
begin
  if ((OpcO = 0) and (UpMode = 0)) then ErrorEnd(46);
  bRecurLevel := 0;
  ValidateOperand(OValue, VOSoort, cSrcReg);
  if not ((Regel = '') or (Regel[1] = ';')) then ErrorEnd(15);

  if VOSoort = 'X' then
   begin
    if bPass = 3 then ErrorEnd(16) else
     if (BufPtr > 260) then OValue := BufPtr - 258  { worst case positioning }
      else OValue := BufPtr + 258;
   end;

  plo2 := BufPtr + 2 + lRaddress;

  if (   (OpcO = 0)
      or (uPmode in [7, 8])
      or (pos(GZextension, 'T') > 0)
      or (pos(GZextension, 'F') > 0)
      or (pos(GZextension, 'N') > 0)) then
   begin                                        { 20 bits }
    if (    ((bAddrWidth = 0) or (uPmode = 0))
        and (bPass = 3)) then ErrorEnd(19);

    if (    (   (OValue - plo2 > $7FFFF)
             or (plo2 - OValue > $80000))
        and (bPass = 3)                ) then ErrorEnd(19);

    if OValue >= plo2 then plo := OValue - plo2
     else plo := (256 * 256 * 16) + OValue - plo2;

    plo2 := (plo shr 16) and $0F;
    if ((plo2 <> 15) and (plo2 <> 0)) then Opc2 := Opc2 or plo2 or $10;
    if (pos(GZextension, 'T') > 0) then Opc2 := Opc2 or $20;
    Dump4byte3(Opc1, Opc2, plo and $FFFF);
   end
  else
   begin                                        { short = 8 bits }
    if (    ((OValue - plo2 > $7F) or (plo2 - OValue > $80))
        and (bPass = 3)) then ErrorEnd(19);

    if OValue >= plo2 then plo := OValue - plo2
     else plo := 256 + OValue - plo2;

    Dump2byte(OpcO, plo and $FF);
   end;

  Commentaar := Regel;
  Regel := '';
  bCodeType := 255;
end;


procedure OperFlag;
var
  by : byte;
  pst : str80;

  procedure sub(b1, b2 : byte);
  begin
    bOpcodeB1 := bOpcodeB1 or b1;
    bOpcodeB2 := bOpcodeB2 or b2;
  end;

begin
  if Opcode[1] = 'C' then bOpcodeB1 := $B3
   else bOpcodeB1 := $B3;

  if length(Regel) = 0 then ErrorEnd(16);
  bOpcodeB2 := $14;
  pst := '';
  by := 1;
  while ((by <= length(Regel)) and not(Regel[by] in [' ', ';', #9])) do
   begin
    pst := pst + Upcase(Regel[by]);
    inc(by)
   end;

  if pst = 'C'   then sub(0, 0) else
  if pst = 'Z'   then sub(0, $20) else
  if pst = 'I'   then sub(0, $40) else
  if pst = 'D'   then sub(0, $60) else
  if pst = 'B'   then sub(0, $80) else
  if pst = 'E'   then sub(0, $A0) else
  if pst = 'V'   then sub(0, $C0) else
  if pst = 'N'   then sub(0, $E0) else
  if pst = 'FDC' then sub(4, $40) else
  if pst = 'FIC' then sub(4, $60) else
  if pst = 'DCA' then sub(4, $80) else
  if pst = 'ICA' then sub(4, $A0) else
  if pst = 'FTL' then sub(4, $C0) else
  if pst = 'MMU' then sub(4, $E0) else
   ErrorEnd(16);

  Dump2byte(bOpcodeB1, bOpcodeB2);
  DeleteS8(Regel, 1, length(pst));
  Commentaar := Regel;
  Regel := '';
  bCodeType := 255;
end;


procedure OperImmediate(var OperandCode : longint; var Soort : byte);
var
  VOSoort : char;
begin
{* Scratch # *}
  DeleteS8(Regel, 1, 1);

  bRecurLevel := 0;
  ValidateOperand(OperandCode, VOSoort, cSrcReg);
  if not((Regel = '') or (Regel[1] = ';')) then ErrorEnd(1);

  if VOSoort = 'C' then Soort := 6 else
   if VOSoort = 'B' then Soort := 7 else
    if VOSoort = 'D' then Soort := 32 else
     Soort := 0;

  Commentaar := Regel;
  Regel := '';
end;


procedure OperIndirect(var OperandCode : longint; var Soort : byte);
var
  by : byte;
  VOSoort, c1, c2 : char;
  plo : longint;
  pst : str80;
label PL1;
begin
{* Scratch first ( *}
  DeleteS8(Regel, 1, 1);

  bRecurLevel := 0;


{* Check on '--R', 'R++' *}
  pst := '';
  by := 1;
  while ((by <= length(Regel)) and not(Regel[by] in [' ', ';', #9])) do
   begin
    pst := pst + Upcase(Regel[by]);
    inc(by)
   end;

  if (copy(pst, 2, 3) = '++)') then
   begin
    cSrcReg := pst[1];
    if (cSrcReg in ['A', 'C', 'G', 'J', 'P', 'S', 'T', 'X', 'Y', 'Z']) then
     begin
      Soort := 35;
      goto PL1;
     end
      else ErrorEnd(16);
   end
    else
  if (copy(pst, 2, 3) = '--)') then
   begin
    cSrcReg := pst[1];
    if (cSrcReg = 'S') then
     begin
      Soort := 34;
      goto PL1;
     end
      else ErrorEnd(16);
   end
    else
  if (    (copy(pst, 1, 2) = '--')
      and (pst[4] = ')')) then
   begin
    cSrcReg := pst[3];
    if (cSrcReg in ['A', 'C', 'G', 'J', 'P', 'S', 'T', 'X', 'Y', 'Z']) then
     begin
      Soort := 34;
      goto PL1;
     end
      else ErrorEnd(16);
   end
    else
  if (    (copy(pst, 1, 2) = '++')
      and (pst[4] = ')')) then
   begin
    cSrcReg := pst[3];
    if (cSrcReg = 'S') then
     begin
      Soort := 35;
      goto PL1;
     end
      else ErrorEnd(16);
   end;

  ValidateOperand(OperandCode, VOSoort, cSrcReg);

  pst := '';
  by := 1;
  while ((by <= length(Regel)) and not(Regel[by] in [' ', ';', #9, '!'])) do
   begin
    pst := pst + Upcase(Regel[by]);
    inc(by)
   end;

  if VOSoort = 'B' then
   begin
    if pst = ')' then Soort := 3 else           { (..) }
    if (    (pst[1] = ',')                      { (xx,Reg) }
        and (pst[3] = ')')
        and (pst[2] in ['A', 'C', 'G', 'J', 'P', 'S', 'T', 'X', 'Y', 'Z'])) then
     begin
      cSrcReg := pst[2];
      if (cSrcReg = 'X') then Soort := 4
       else Soort := 29;
     end
      else
    if (    (pst[1] = ')')                      { (xx),Y }
        and (pst[2] = ',')
        and (pst[3] in ['A', 'C', 'G', 'J', 'P', 'S', 'T', 'X', 'Y', 'Z'])) then
     begin
      cSrcReg := pst[3];
      if (cSrcReg = 'Y') then Soort := 5
       else Soort := 30;
     end
      else ErrorEnd(16);
   end
    else
  if VOSoort = 'C' then
   begin
    if pst = ')' then Soort := 1 else           { (xxxx) }
    if (    (pst[1] = ',')                      { (xxxx,Reg) }
        and (pst[3] = ')')
        and (pst[2] in ['A', 'C', 'G', 'J', 'P', 'S', 'T', 'X', 'Y', 'Z'])) then
     begin
      cSrcReg := pst[2];
      if (cSrcReg = 'X') then Soort := 2 else Soort := 27;
     end
      else
    if (    (pst[1] = ')')                      { (xxxx),Y }
        and (pst[2] = ',')
        and (pst[3] in ['A', 'C', 'G', 'J', 'P', 'S', 'T', 'X', 'Y', 'Z'])) then
     begin
      cSrcReg := pst[3];
      if (cSrcReg = 'Y') then Soort := 15 else Soort := 28;
     end
      else ErrorEnd(16);
   end
    else
  if (VOSoort = 'D') then
   begin
    if pst = ')' then Soort := 41 else          { (xxxxxxxx) }
     ErrorEnd(16);
   end
    else
  if VOSoort = 'R' then
   begin
    if pst = ')' then Soort := 26 else          { (reg) }
     ErrorEnd(16);
   end
    else Soort := 0;

PL1:
  delete(Regel, 1, by-1);

  if (Regel[1] = '!') then
   begin
    delete(Regel, 1, 1);
    ValidateOperand(plo, c1, c2);
    iShift := plo;
   end;

  Commentaar := Regel;
  Regel := '';
end;


procedure OperRest(var OperandCode : longint; var Soort : byte);
var
  R, Quote1, VOSoort : char;
  tel : integer;
  plo,plo2 : longint;
  pst : string;
label PL1,PL2,PL3,PL4;
begin
  bRecurLevel := 0;
  ValidateOperand(OperandCode, VOSoort, cSrcReg);

  if ((Regel = '') or (Regel[1] = ';')) then
   begin                                        { ABS / ZP }
    if VOSoort = 'C' then Soort := 8 else
     if VOSoort = 'B' then Soort := 9 else
      if VOSoort = 'D' then Soort := 16 else
       if VOSoort = 'R' then Soort := 31 else
        Soort := 0;
   end
    else
  if Regel[1] = ',' then
   begin                                        { ABS / ZP | ,X ,Y etc.}
    if (length(Regel) < 2) then ErrorEnd(16);
    R := upcase(Regel[2]);

    if (R in ['A', 'C', 'G', 'J', 'P', 'S', 'T', 'X', 'Y', 'Z']) then
     begin
      cSrcReg := Regel[2];

      if (VOsoort = 'X') then Soort := 0
       else

      if cSrcReg = 'X' then
       begin
        if VOSoort = 'B' then Soort := 10 else   { ZP ,X }
         if VOSoort = 'C' then Soort := 12 else  { ABS ,Y }
          ErrorEnd(16);
       end
        else

      if cSrcReg = 'Y' then
       begin
        if VOSoort = 'B' then Soort := 11 else   { ZP ,X }
         if VOSoort = 'C' then Soort := 13 else  { ABS ,Y }
          ErrorEnd(16);
       end
        else

      if VOSoort = 'B' then Soort := 38 else     { ZP ,reg }
       if VOSoort = 'C' then Soort := 39 else    { ABS ,reg }
        ErrorEnd(16);
     end
      else ErrorEnd(16);

    delete(Regel, 1, 2);
   end;

  Commentaar := short(copy(Regel,3,length(Regel)-2));
  Regel := '';
end;


procedure pCodeType(OpWaarde : longint);
var
  plo : longint;
begin
{
 INr = INstruction Register
}

  if (bCodeType in [1, 3]) then                 { ($nn) , ($nnnn) }
   begin
    Dump4byte3($87, $01, Opwaarde);             { LDT.w $nnnn }
    Write_Lst;
    OrgRegel := '';
    LstRegel := '$'+Dec2Hex(BufPtr, 6)+'     ';
    Dump2byte(bOpcodeB1, bOpcodeB2);            { INr   (T)    }
   end
    else

  if (bCodeType in [2, 4, 27, 29]) then         { ($nnnn,reg) }
   begin
    CheckWidth(Opwaarde, 2);
    Dump4byte3($87, bSrcReg or 1, Opwaarde);    { LDT.w $nnnn,reg }
    Write_Lst;
    OrgRegel := '';
    LstRegel := '$'+Dec2Hex(BufPtr, 6)+'     ';
    Dump2byte(bOpcodeB1, bOpcodeB2);            { INr   (T)    }
   end
    else

  if (bCodeType in [5, 15, 28, 30]) then        { ($nnnn),reg }
   begin
    CheckWidth(Opwaarde, 2);
    Dump4byte3($87, $01, Opwaarde);             { LDT.w $nnnn }
    Write_Lst;
    OrgRegel := '';
    LstRegel := '$'+Dec2Hex(BufPtr, 6)+'     ';
    Dump2byte($3B, bSrcReg or 3);               { ADDT.d reg }
    Write_Lst;
    LstRegel := '$'+Dec2Hex(BufPtr, 6)+'     ';
    Dump2byte(bOpcodeB1, bOpcodeB2);            { INr   (T)    }
   end
    else

  if (bCodeType in [6, 7]) then                 { #xxxx , #xx }
   begin
    CheckWidth(Opwaarde, bMemWidth);
    Dump4byte3(bOpcodeB1 or $0C, bOpcodeB2, OpWaarde);
   end
    else

  if (bCodeType in [8, 9]) then                 { $nnnn }
   begin
    CheckWidth(Opwaarde, 2);
    Dump4byte3(bOpcodeB1 or $04, bOpcodeB2, OpWaarde);
   end
    else

  if (bCodeType in [10..13, 17, 18, 38, 39]) then
   begin                                        { $nnnn,reg }
    CheckWidth(Opwaarde, 2);
    Dump4byte3(bOpcodeB1 or $04, bSrcReg or bOpcodeB2, OpWaarde);
   end
    else

  if (bCodeType in [16, 33]) then               { $nnnnmmmm }
   begin
    Dump4byte3($A7, $02, Opwaarde shr 16);      { LDT.h #$nnnn }
    Write_Lst;
    OrgRegel := '';
    LstRegel := '$'+Dec2Hex(BufPtr, 6)+'     ';
    Dump4byte3($A7, $01, Opwaarde and $FFFF);   { LDT.w #$mmmm }
    Write_Lst;
    LstRegel := '$'+Dec2Hex(BufPtr, 6)+'     ';
    Dump2byte(bOpcodeB1, bOpcodeB2);            { INr   (T)    }
   end
    else

  if (bCodeType = 26) then                      { (reg) }
   begin
    Dump2byte(bOpcodeB1, bOpcodeB2 or bSrcReg);
   end
    else

  if (bCodeType in [14, 31]) then               { reg }
   begin
    Dump2byte(bOpcodeB1 or 8, bSrcReg or bOpcodeB2);
   end
    else

  if (bCodeType = 32) then                      { #12345678 }
   begin
    plo := Opwaarde shr 16;
    if (plo > 0) then
     begin
      Dump4byte3($A7, $02, plo);                { LDT.h #1234 }
      Write_Lst;
      OrgRegel := '';
      LstRegel := '$' + Dec2Hex(BufPtr, 6) + '     ';
     end;

    plo := Opwaarde and $FFFF;
    if (plo > 0) then
     Dump4byte3(bOpcodeB1 or $0C, bOpcodeB2 or 3, plo)
    else
     Dump2byte(bOpcodeB1 or 8, bOpcodeB2 or 3); { INr T }
   end
    else

  if (bCodeType = 35) then                      { (R++) }
   begin
    Dump2byte(bOpcodeB1 or $08, bSrcReg or bOpcodeB2);
   end
    else

  if (bCodeType = 34) then                      { (--R) }
   begin
    Dump2byte(bOpcodeB1 or $0C, bSrcReg or bOpcodeB2);
   end
    else

  if (bCodeType = 41) then                      { ($nnnnmmmm) }
   begin
    Dump4byte3($A7, $02, Opwaarde shr 16);      { LDT.h #$nnnn }
    Write_Lst;
    OrgRegel := '';
    LstRegel := '$'+Dec2Hex(BufPtr, 6)+'     ';
    Dump4byte3($A7, $01, Opwaarde and $FFFF);   { LDT.w #$mmmm }
    Write_Lst;
    LstRegel := '$'+Dec2Hex(BufPtr, 6)+'     ';
    Dump2byte($93, $03);                        { LDT.d (T)    }
    Write_Lst;
    LstRegel := '$'+Dec2Hex(BufPtr, 6)+'     ';
    Dump2byte(bOpcodeB1, bOpcodeB2);            { INr   (T)    }
   end
    else
  if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);

  bCodeType := 255;
end;


function SourceReg2Code(c : char) : boolean;
begin
  SourceReg2Code := True;
  case c of
    'A' : bSrcReg := $20;
    'C' : bSrcReg := $E0;
    'G' : bSrcReg := $80;
    'J' : bSrcReg := $A0;
    'S' : bSrcReg := $C0;
    'T' : bSrcReg := $00;
    'X' : bSrcReg := $40;
    'Y' : bSrcReg := $60;
    'Z' : bSrcReg := $00;
     else SourceReg2Code := False;
  end;
end;


{============================================================================}


procedure CheckOpcode65;
var
  b1, bOpc : byte;
  plo, OpWaarde : longint;
  Opcode2, Opcode3 : string[5];
  sRegel, PrevRegel : str80;
label PL1, Pl2, PL3, Pl4, PL5, PL6, PL7, PL8, PL9, PL10;

 procedure CheckLine;
 begin
   if Regel = '' then ErrorEnd(15);
   if Regel[1] = '(' then OperIndirect(OpWaarde, bCodeType) else
    if Regel[1] = '#' then OperImmediate(OpWaarde, bCodeType) else
     OperRest(OpWaarde, bCodeType);
 end;

 procedure ExternalProc;
 var
   w1 : word;
   sProc : Str16;
 begin
   w1 := 0;

   while (    not(sRegel[w1+1] in [' ', #9])
          and (w1 < length(sRegel))
         ) do inc(w1);

   sProc := upper(copy(sRegel, 1, w1));
   w1 := 0;

   if wMarInfoTel > 0 then
    while w1 < wMarInfoTel do
     if MarInfo^[w1].name <> sProc then inc(w1)
      else exit;

   MarInfo^[w1].name := sProc;
   MarInfo^[w1].Used := False;
   inc(wMarInfoTel);
   boLoop := True;
 end;

begin
{* bCodeType  **
   0 = Invalid / undetermined
   1 = (xxxx)
   2 = (xxxx,X)
   3 = (xx)
   4 = (xx,X)
   5 = (xx),Y
   6 = #xxxx
   7 = #xx
   8 = xxxx
   9 = xx
  10 = xx,X
  11 = xx,Y
  12 = xxxx,X
  13 = xxxx,Y
  14 = implecite or register A
  15 = (xxxx),Y


65GZ032:
  16 = xxxxxx
  26 = (reg)
  27 = ($nnnn,reg)
  28 = ($nnnn),reg
  29 = ($nn,reg)
  30 = ($nn),reg
  31 = reg
  32 = #xxxxxxxx
  33 = xxxxxxxx
  34 = (--Reg)
  35 = (Reg++)
  38 = xx,reg
  39 = xxxx,reg

  41 = (xxxxxxxx)                 pseudo

254 = Macro found
255 = Opcode found
**}

  bMemWidth := 9;
  bAddrWidth := 9;
  bOpc := 0;
  iShift := 0;
  Opcode3 := copy(Opcode, 1, 3);
  Opcode2 := copy(Opcode, 1, 2);
  PrevRegel := Regel;


{* Hack to shorten code that adds .B to Opcode *}
  if ((length(Opcode) = 4) and (pos('.', Opcode) = 0)) then
   begin
PL1:
    Opcode := Opcode + '.B';
    Regel := PrevRegel;
   end;

  CheckExtension;
  DestReg2Code(Opcode[4]);
  sRegel := Regel;

  if Opcode3 = 'ADC' then
   begin
    CheckLine;
    if Opcode = 'ADC' then
     begin
      bOpc := $60;

  PL3:
      if ((bCodeType in [2, 4]) and (OpWaarde < 256)) then
        Dump2byte(bOpc + 1, OpWaarde) else
      if ((bCodeType in [5, 15]) and (OpWaarde < 256)) then
        Dump2byte(bOpc + $11, OpWaarde) else
      if ((bCodeType in [6, 7]) and (OpWaarde < 256)) then
        Dump2byte(bOpc + 9, OpWaarde) else
      if bCodeType =  8 then Dump3byte(bOpc + $0D, OpWaarde) else
      if bCodeType =  9 then Dump2byte(bOpc + $05, OpWaarde) else
      if bCodeType = 10 then Dump2byte(bOpc + $15, OpWaarde) else
      if bCodeType = 12 then Dump3byte(bOpc + $1D, OpWaarde) else
      if bCodeType in [11, 13] then Dump3byte(bOpc + $19, OpWaarde) else
      if (uPmode = 7) then goto PL1 else
      if (bPass = 3) then ErrorEnd(16);
     end
      else

    if (uPmode = 7) then
     begin
      bOpcodeB1 := $43;
PL2:
      if (iShift > 0) then ErrorEnd(47);

      bOpcodeB2 := bDesReg or bMemWidth;
      SourceReg2Code(cSrcReg);

      pCodeType(OpWaarde);
     end;
   end
    else

  if Opcode3 = 'ADD' then
   begin
    CheckLine;
    if Opcode = 'ADD' then bMemWidth := $00;
    if not(upMode in [7, 8]) then ErrorEnd(46);
    bOpcodeB1 := $33;
    goto PL2;
   end
    else

  if Opcode3 = 'AND' then
   begin
    CheckLine;

    if Opcode = 'AND' then
     begin
      bOpc := $20;
      goto PL3;
     end
      else

    if (uPmode = 7) then
     begin
      bOpcodeB1 := $13;
      goto PL2;
     end;
   end
    else

  if Opcode3 = 'ASL' then
   begin
    if ChkLabel(bCodeType) then
     CheckLine;

    if Opcode = 'ASL' then
     begin
      bOpc := 0;
PL9:
      if bCodeType =  8 then Dump3byte(bOpc + $0E, OpWaarde) else
      if bCodeType =  9 then Dump2byte(bOpc + $06, OpWaarde) else
      if bCodeType = 10 then Dump2byte(bOpc + $16, OpWaarde) else
      if bCodeType = 12 then Dump3byte(bOpc + $1E, OpWaarde) else
      if bCodeType = 14 then Dump1byte(bOpc + $0A) else
      if (uPmode = 7) then goto PL1 else
      if (bPass = 3) then ErrorEnd(16);
     end
      else

    if (uPmode = 7) then
     begin
      bOpcodeB1 := $C3;
PL4:
      if ((bPass < 3) or (iShift = 0)) then iShift := 1;
      if ((iShift < 1) or (iShift > 4)) then ErrorEnd(47);
      bOpcodeB2 := iShift shl 2;

      if Opcode3[1] = 'R' then bOpcodeB2 := $10 or bMemWidth or bOpcodeB2
       else bOpcodeB2 := bMemWidth or bOpcodeB2;

      if (opcode[4] <> '.') then cSrcReg := opcode[4];
      SourceReg2Code(cSrcReg);
      pCodeType(OpWaarde);
     end;
   end
    else

  if (Opcode3 = 'BPL') then OperBranchGZ($F3, $00, $10) else
  if (Opcode3 = 'BMI') then OperBranchGZ($F3, $40, $30) else
  if (Opcode3 = 'BVC') then OperBranchGZ($F3, $80, $50) else
  if (Opcode3 = 'BVS') then OperBranchGZ($F3, $C0, $70) else
  if (Opcode3 = 'BCC') then OperBranchGZ($F7, $00, $90) else
  if (Opcode3 = 'BCS') then OperBranchGZ($F7, $40, $B0) else
  if (Opcode3 = 'BNE') then OperBranchGZ($F7, $80, $D0) else
  if (Opcode3 = 'BEQ') then OperBranchGZ($F7, $C0, $F0) else
  if (Opcode3 = 'BLE') then OperBranchGZ($FB, $00, $00) else
  if (Opcode3 = 'BGE') then OperBranchGZ($FB, $40, $00) else
  if (Opcode3 = 'BLT') then OperBranchGZ($FB, $80, $00) else
  if (Opcode3 = 'BGT') then OperBranchGZ($FB, $C0, $00) else
  if (Opcode3 = 'BPO') then OperBranchGZ($FF, $00, $00) else
  if (Opcode3 = 'BRA') then OperBranchGZ($FF, $C0, $00) else

  if Opcode3 = 'BIT' then
   begin
    CheckLine;

    if Opcode = 'BIT' then
     begin
      bOpc := $20;
PL6:
      if bCodeType = 8 then Dump3byte(bOpc + $0C, OpWaarde) else
      if bCodeType = 9 then Dump2byte(bOpc + $04, OpWaarde) else
      if (uPmode = 7) then goto PL1 else
      if (bPass = 3) then ErrorEnd(16);
     end
      else

    if (uPmode = 7) then
     begin
      if (iShift > 0) then ErrorEnd(47);
      if (bDesReg <> 4) then ErrorEnd(16);
      bOpcodeB1 := $E3;
      SourceReg2Code(cSrcReg);
      bOpcodeB2 := bSrcReg or bMemWidth or $10;
      pCodeType(OpWaarde);
     end;
   end
    else

  if (Opcode = 'BRK') then Oper1Byte($00) else
  if (Opcode = 'CFL') or (Opcode = 'SFL') then OperFlag else
  if Opcode = 'CLC' then Oper1byte($18) else
  if Opcode = 'CLD' then Oper1byte($D8) else
  if Opcode = 'CLI' then Oper1byte($58) else
  if Opcode = 'CLV' then Oper1byte($B8) else

  if (Opcode3 = 'CMP') then
   begin
    DestReg2Code('A');
    CheckLine;

    if (Opcode = 'CMP') then
     begin
      bOpc := $C0;
      goto PL3;
     end
      else
    if (uPmode = 7) then
     begin
      bOpcodeB1 := $73;
      goto PL2;
     end;
   end
    else

  if (Opcode2 = 'CP') then
   begin
    DestReg2Code(Opcode[3]);
    CheckLine;

    if (length(Opcode) = 3) then
     begin
      if (Opcode3[3] = 'X') then bOpc := $E0 else
      if (Opcode3[3] = 'Y') then bOpc := $C0;
PL8:
      if ((bCodeType in [6, 7]) and (OpWaarde < 256)) then
        Dump2byte(bOpc, OpWaarde) else
      if bCodeType = 8 then Dump3byte(bOpc or $0C, OpWaarde) else
      if bCodeType = 9 then Dump2byte(bOpc or $04, OpWaarde) else
      if (uPmode = 7) then goto PL1
       else goto PL6;
     end
      else

    if (uPmode = 7) then
     begin
      bOpcodeB1 := $73;
      goto PL2;
     end;
   end
    else

  if Opcode3 = 'DEC' then
   begin
    CheckLine;

    if Opcode = 'DEC' then
     begin
      bOpc := $C2;
PL7:
      if bCodeType = 10 then Dump2byte(bOpc + $14, OpWaarde) else
      if bCodeType = 12 then Dump3byte(bOpc + $1C, OpWaarde)
       else goto PL6;
     end
      else

    if (uPmode = 7) then
     begin
      bOpcodeB1 := $E3;
      bDesReg := 4;
      goto PL2;
     end;
   end
    else

  if (Opcode2 = 'DE') then
   begin
    cSrcReg := Opcode3[3];
    if not SourceReg2Code(cSrcReg) then ErrorEnd(14);

    if (length(Opcode) = 3) then
     begin
      if cSrcReg = 'X' then Oper1Byte($CA) else
      if cSrcReg = 'Y' then Oper1Byte($88) else
      if (uPmode = 7) then goto PL1 else
      if (bPass = 3) then ErrorEnd(16);
     end
      else

    if (uPmode = 7) then
     begin
      bOpcodeB1 := $EB;
      bOpcodeB2 := $04 or bSrcReg or bMemWidth;
      Dump2byte(bOpcodeB1, bOpcodeB2);
     end
   end
    else

  if Opcode3 = 'EOR' then
   begin
    CheckLine;

    if Opcode = 'EOR' then
     begin
      bOpc := $40;
      goto PL3;
     end
      else

    if (uPmode = 7) then
     begin
      bOpcodeB1 := $23;
      goto PL2;
     end;
   end
    else

  if Opcode3 = 'INC' then
   begin
    CheckLine;

    if Opcode = 'INC' then
     begin
      bOpc := $E2;
      goto PL7;
     end
      else

    if (uPmode = 7) then
     begin
      bOpcodeB1 := $E3;
      bDesReg := 0;
      goto PL2;
     end;
   end
    else

  if Opcode2 = 'IN' then
   begin
    cSrcReg := Opcode3[3];
    if not SourceReg2Code(cSrcReg) then ErrorEnd(14);

    if (length(Opcode) = 3) then
     begin
      if cSrcReg = 'X' then Oper1Byte($E8) else
      if cSrcReg = 'Y' then Oper1Byte($C8) else
      if (uPmode = 7) then goto PL1 else
      if (bPass = 3) then ErrorEnd(16);
     end
      else

    if (uPmode = 7) then
     begin
      bOpcodeB1 := $EB;
      bOpcodeB2 := bSrcReg or bMemWidth;
      Dump2byte(bOpcodeB1, bOpcodeB2);
     end
   end
    else

  if Opcode2 = 'JM' then
   begin
    CheckLine;

    if ((bPass = 2) and (bCodeType = 0)) then ExternalProc
     else

    if Opcode = 'JMP' then
     begin
      if bCodeType in [1, 3] then Dump3byte($6C, OpWaarde) else
      if bCodeType in [8, 9] then Dump3byte($4C, OpWaarde) else
      if (uPmode = 7) then goto PL1 else
      if (bPass = 3) then ErrorEnd(16);
     end
      else

    if (uPmode = 7) then
     begin
      DestReg2Code('C');
      Opcode2 := 'LD';
      bOpcodeB1 := $A7;

      if (bAddrWidth = 3) then                { 32-bits addressing }
       begin
        bMemWidth := $03;
        if (bCodeType in [8, 9, 16, 33]) then bCodeType := 32 else
        if (bCodeType in [3, 1]) then bCodeType := 33 else
        if (bPass = 3) then ErrorEnd(16);
       end
      else
       begin                                    { 16-bits addressing }
        bMemWidth := $01;
        if (bCodeType in [8, 9]) then bCodeType := 6 else
        if (bCodeType in [3, 1]) then bCodeType := 8 else
        if (bPass = 3) then ErrorEnd(16);
       end;

      goto PL5;
     end;
   end
    else

  if Opcode2 = 'JS' then
   begin
    CheckLine;

    if ((bPass = 2) and (bCodeType = 0)) then ExternalProc
     else

    if Opcode = 'JSR' then
     begin
      if bCodeType in [8, 9] then Dump3byte($20, OpWaarde) else
      if (uPmode = 7) then goto PL1 else
      if (bPass = 3) then ErrorEnd(16);
     end
      else

    if (uPmode = 7) then
     begin
      bOpcodeB1 := $B3;
      bDesReg := 0;

      if (bAddrWidth = 3) then bMemWidth := 1  { 32-bits addressing }
       else bMemWidth := 0;                      { 16-bits addressing }

{## via andere routine? }
      if (bCodeType in [16, 33]) then            { JSR $nnnnmmmm }
       begin
        Dump4byte3($A7, $02, Opwaarde shr 16);  { LDT.h #$nnnn }
        Write_Lst;
        LstRegel := '$'+Dec2Hex(BufPtr, 6)+'     ';
        Dump4byte3($BF, $01, Opwaarde and $FFFF); { JSR.d #$mmmm }
       end
        else goto PL2;
     end;
   end
    else

  if (Opcode2 = 'LD') then                      { LoaD }
   begin
    CheckLine;

    if (length(Opcode) = 3) then
     begin
      if (Opcode3[3] = 'A') then
       begin
        bOpc := $A0;
        goto PL3;
       end
        else

      if (Opcode3[3] = 'X') then
       begin
        bOpc := $A2;
        if bCodeType = 11 then Dump2byte($B6, OpWaarde) else
        if bCodeType = 13 then Dump3byte($BE, OpWaarde)
         else goto PL8;
       end
        else

      if (Opcode3[3] = 'Y') then
       begin
        bOpc := $A0;
        if bCodeType = 10 then Dump2byte($B4, OpWaarde) else
        if bCodeType = 12 then Dump3byte($BC, OpWaarde)
         else goto PL8;
       end
        else

      if (uPmode = 7) then goto PL1
       else ErrorEnd(46);
     end
      else

    if (uPmode = 7) then
     begin
      DestReg2Code(Opcode[3]);
      SourceReg2Code(cSrcReg);
PL5:
      if (iShift > 0) then ErrorEnd(99);
      bOpcodeB2 := bDesReg or bMemWidth;

      if (bCodeType in [6, 7, 32]) then
       begin
        if (bCodeType = 32) then
         begin
          plo := Opwaarde shr 16;
          if (plo > 0) then
           begin
            Dump4byte3($A7, $02, plo);          { LDT.h #1234 }
            Write_Lst;
            LstRegel := '$' + Dec2Hex(BufPtr, 6) + '     ';
           end;
         end;

        bCodeType := 39;
        bOpcodeB1 := $A3;
        pCodeType(OpWaarde and $FFFF);
       end
        else

      if (bCodeType in [1..5, 8..13, 15, 16, 26..31, 33..39, 41]) then
       begin
        bOpcodeB1 := $83;
        pCodeType(OpWaarde);
       end
      else
       begin
        bCodeType := 26;
        bOpcodeB1 := $83;
        pCodeType(OpWaarde);
       end;
     end;
   end
    else

  if Opcode3 = 'LSR' then
   begin
    if ChkLabel(bCodeType) then CheckLine;

    if Opcode = 'LSR' then
     begin
      bOpc := $40;
      goto PL9;
     end
      else

    if (uPmode = 7) then
     begin
      bOpcodeB1 := $D3;
      goto PL4;
     end;
   end
    else

  if Opcode = 'NOP' then Oper1Byte($EA)
    else

  if Opcode2 = 'OR' then
   begin
    CheckLine;

    if Opcode = 'ORA' then
     begin
      bOpc := $00;
      goto PL3;
     end
      else

    if (uPmode = 7) then
     begin
      bOpcodeB1 := $03;
      goto PL2;
     end;
   end
    else

  if Opcode2 = 'PH' then            { push register }
   begin

    if Opcode = 'PHA' then Oper1Byte($48) else
    if Opcode = 'PHP' then Oper1Byte($08) else
    if (uPmode = 7) then
     begin
      if (Opcode[3] = 'P') then
       begin
        if (bMemWidth > 1) then ErrorEnd(23);
        bOpcodeB1 := $BB;
        bOpcodeB2 := $D2 or bMemWidth;
       end
      else
       begin
        DestReg2Code(Opcode[3]);
        SourceReg2Code('S');
        bOpcodeB1 := $8B;
        bOpcodeB2 := bSrcReg or bDesReg or bMemWidth;
       end;

      Dump2byte(bOpcodeB1, bOpcodeB2);
     end
      else ErrorEnd(14);
   end
    else

  if Opcode2 = 'PL' then            { pull register }
   begin

    if Opcode = 'PLA' then Oper1Byte($68) else
    if Opcode = 'PLP' then Oper1Byte($28) else
    if (uPmode = 7) then
     begin
      if (Opcode[3] = 'P') then
       begin
        if (bMemWidth > 1) then ErrorEnd(23);
        bOpcodeB1 := $BF;
        bOpcodeB2 := $D0 or bMemWidth;
       end
      else
       begin
        DestReg2Code('S');
        SourceReg2Code(Opcode[3]);
        bOpcodeB1 := $9F;
        bOpcodeB2 := bSrcReg or bDesReg or bMemWidth;
       end;

      Dump2byte(bOpcodeB1, bOpcodeB2);
     end
      else ErrorEnd(14);
   end
    else

  if Opcode3 = 'ROL' then
   begin
    if ChkLabel(bCodeType) then CheckLine;

    if Opcode = 'ROL' then
     begin
      bOpc := $20;
      goto PL9;
     end
      else

    if (uPmode = 7) then
     begin
      bOpcodeB1 := $C3;
      goto PL4;
     end;
   end
    else

  if Opcode3 = 'ROR' then
   begin
    if ChkLabel(bCodeType) then CheckLine;

    if Opcode = 'ROR' then
     begin
      bOpc := $60;
      goto PL9;
     end
      else

    if (uPmode = 7) then
     begin
      bOpcodeB1 := $D3;
      goto PL4;
     end;
   end
    else

  if Opcode3 = 'RTI' then
   begin
    if (Opcode = 'RTI') then Oper1Byte($40) else
    if (bAddrWidth = 1) then Dump2byte($B3, $0C) else
    if (bAddrWidth = 3) then Dump2byte($B3, $0D)
      else ErrorEnd(23);
   end
    else

  if Opcode3 = 'RTS' then
   begin
    if (Opcode = 'RTS') then Oper1Byte($60) else
    if (bAddrWidth = 1) then Dump2byte($B3, $04) else
    if (bAddrWidth = 3) then Dump2byte($B3, $08)
      else ErrorEnd(23);
   end
    else

  if Opcode3 = 'SBC' then
   begin
    CheckLine;

    if Opcode = 'SBC' then
     begin
      bOpc := $E0;
      goto PL3;
     end
      else

    if (uPmode = 7) then
     begin
      bOpcodeB1 := $63;
      goto PL2;
     end;
   end
    else

  if Opcode = 'SEC' then Oper1Byte($38)
    else

  if Opcode = 'SED' then Oper1Byte($F8)
    else

  if Opcode = 'SEI' then Oper1Byte($78)
    else

  if Opcode2 = 'ST' then
   begin
    CheckLine;

    if (Opcode = 'STA') then
     begin
      bOpc := $80;

      if ((bCodeType in [2, 4]) and (OpWaarde < 256)) then
        Dump2byte($81, OpWaarde) else
      if ((bCodeType in [5, 15]) and (OpWaarde < 256)) then
        Dump2byte($91, OpWaarde) else
      if bCodeType = 10 then Dump2byte($95, OpWaarde) else
      if bCodeType = 12 then Dump3byte($9D, OpWaarde) else
      if bCodeType in [11, 13] then Dump3byte($99, OpWaarde) else

PL10:
      if bCodeType =  8 then Dump3byte(bOpc + $0D, OpWaarde) else
      if bCodeType =  9 then Dump2byte(bOpc + $05, OpWaarde) else
      if (uPmode = 7) then goto PL1 else
      if (bPass = 3) then ErrorEnd(16);
     end
      else

    if (Opcode = 'STX') then
     begin
      bOpc := $81;

      if (   ((bCodeType = 13) and (OpWaarde < 256))
          or (bCodeType = 11)) then Dump2byte($96, OpWaarde)
       else goto PL10;
     end
      else

    if (Opcode = 'STY') then
     begin
      bOpc := $7F;

      if (   ((bCodeType = 12) and (OpWaarde < 256))
          or (bCodeType = 10)) then Dump2byte($94, OpWaarde)
       else goto PL10;
     end
      else

    if (uPmode = 7) then
     begin
      DestReg2Code(Opcode[3]);
      if (iShift > 0) then ErrorEnd(99);
      bOpcodeB2 := bDesReg or bMemWidth;
      SourceReg2Code(cSrcReg);

      if (bCodeType = 31) then
       begin
        bOpcodeB1 := $A3;
        pCodeType(OpWaarde);
       end
        else

      if (bCodeType in [6, 7, 32]) then ErrorEnd(16) else
       begin
        bOpcodeB1 := $93;
        pCodeType(OpWaarde);
       end;
     end
   end
    else

  if Opcode3 = 'SUB' then
   begin
    CheckLine;
    if Opcode = 'SUB' then bMemWidth := $00;
    if not(upMode in [7, 8]) then ErrorEnd(46);
    bOpcodeB1 := $53;
    goto PL2;
   end
    else

  if Opcode3[1] = 'T' then                      { Transfer REG REG }
   begin
    if (length(Opcode) = 3) then
     begin
      if Opcode = 'TAX' then Oper1Byte($AA) else
      if Opcode = 'TAY' then Oper1Byte($A8) else
      if Opcode = 'TSX' then Oper1Byte($BA) else
      if Opcode = 'TXA' then Oper1Byte($8A) else
      if Opcode = 'TXS' then Oper1Byte($9A) else
      if Opcode = 'TYA' then Oper1Byte($98);
     end
      else

    if (uPmode = 7) then
     begin
      DestReg2Code(Opcode[3]);
      if not SourceReg2Code(Opcode3[2]) then ErrorEnd(14);

  {##  sign extension ???}
      if (pos(GZextension, 'E') > 0) then bOpcodeB1 := $AB
       else bOpcodeB1 := $A3;

      bOpcodeB2 := bSrcReg or bDesReg or bMemWidth;
      Dump2byte(bOpcodeB1, bOpcodeB2);
     end
   end
    else

  if ((uPmode = 8) and (bCodeType = 0)) then
   begin
    if Opcode3 = 'RSL' then Oper2Byte($B3, $05) else
    if Opcode3 = 'RIL' then Oper2Byte($B3, $0D);
   end;

  if ((bCodeType = 0) and (bPass = 3)) then ErrorEnd(14);
end;


{============================================================================}


procedure OperImmediateGZ(var OperandCode : longint; var Soort : byte);
var
  VOSoort : char;
begin
  bRecurLevel := 0;
  ValidateOperand(OperandCode, VOSoort, cSrcReg);

  if VOSoort in ['B', 'C'] then Soort := 6 else
   if VOSoort = 'D' then ErrorEnd(16) else
    if VOSoort = 'R' then Soort := 31 else
     Soort := 0;
end;


procedure OperIndirectGZ(var OperandCode : longint; var Soort : byte);
var
  by : byte;
  VOSoort, c1 : char;
  plo : longint;
  pst : str80;

 procedure R2Reg(c : char);
 begin
   case c of
     '0' : cSrcReg := 'Z';
     '1' : cSrcReg := 'A';
     '2' : cSrcReg := 'X';
     '3' : cSrcReg := 'Y';
     '4' : cSrcReg := 'G';
     '5' : cSrcReg := 'J';
     '6' : cSrcReg := 'S';
     '7' : cSrcReg := 'C';
    end;

   DeleteS8(Regel, 1, 1);
 end;

begin
{* Scratch first [ *}
  DeleteS8(Regel, 1, 1);

  bRecurLevel := 0;


{* Check on '--R', 'R++', '++S', 'S--' *}
  pst := '';
  by := 1;
  while ((by <= length(Regel)) and not(Regel[by] in [' ', ';', #9])) do
   begin
    pst := pst + Upcase(Regel[by]);
    inc(by)
   end;

  if (copy(pst, 2, 3) = '++]') then
   begin
    cSrcReg := pst[1];

    if (cSrcReg in ['A', 'C', 'G', 'J', 'T', 'X', 'Y', 'Z']) then
     begin
      Soort := 35;
      delete(Regel, 1, 4);
      exit;
     end
    else ErrorEnd(16);
   end
    else

  if (copy(pst, 3, 3) = '++]') then
   begin
    if (pst[1] = 'R') and (pst[2] in ['0'..'5', '7']) then
     begin
      R2Reg(pst[2]);
      Soort := 35;
      delete(Regel, 1, 5);
      exit;
     end
      else

    if (copy(pst, 1, 2) = 'PC') then
     begin
      cSrcReg := 'C';
      Soort := 35;
      delete(Regel, 1, 5);
      exit;
     end
      else ErrorEnd(16);
   end
    else

  if (copy(pst, 1, 4) = 'S--]') then
   begin
    cSrcReg := 'S';
    Soort := 34;
    delete(Regel, 1, 4);
    exit;
   end
    else

  if    (copy(pst, 1, 5) = 'R6--]')
     or (copy(pst, 1, 5) = 'SP--]') then
   begin
    cSrcReg := 'S';
    Soort := 34;
    delete(Regel, 1, 5);
    exit;
   end
    else

  if (copy(pst, 1, 2) = '--') and (pst[4] = ']') then
   begin
    cSrcReg := pst[3];

    if (cSrcReg in ['A', 'C', 'G', 'J', 'T', 'X', 'Y', 'Z']) then
     begin
      Soort := 34;
      delete(Regel, 1, 4);
      exit;
     end
    else ErrorEnd(16);
   end
    else

  if (copy(pst, 1, 4) = '--PC') and (pst[5] = ']') then
   begin
    cSrcReg := 'C';
    Soort := 34;
    delete(Regel, 1, 5);
    exit;
   end
    else

  if (copy(pst, 1, 3) = '--R') and (pst[5] = ']') then
   begin
    if (pst[4] in ['0'..'5', '7']) then
     begin
      R2Reg(pst[4]);
      delete(Regel, 1, 5);
      Soort := 34;
      exit;
     end
    else ErrorEnd(16);
   end
    else

  if (copy(pst, 1, 4) = '++S]') then
   begin
    cSrcReg := 'S';
    delete(Regel, 1, 4);
    Soort := 35;
    exit;
   end
    else

  if    (copy(pst, 1, 5) = '++R6]')
     or (copy(pst, 1, 5) = '++SP]') then
   begin
    cSrcReg := 'S';
    Soort := 35;
    delete(Regel, 1, 5);
    exit;
   end;

  ValidateOperand(OperandCode, VOSoort, cSrcReg);

  pst := '';
  by := 1;
  while ((by <= length(Regel)) and not(Regel[by] in [' ', ';', #9, '!'])) do
   begin
    pst := pst + Upcase(Regel[by]);
    inc(by)
   end;

  if VOSoort in ['B', 'C'] then
   begin
    if pst[1] <> ']' then ErrorEnd(16);
    Soort := 8;                                 { [xxxx] }
    delete(Regel, 1, 1);
   end
    else
  if (VOSoort = 'D') then
   begin                                        { [xxxxxxxx] }
     ErrorEnd(16);
   end
    else
  if VOSoort = 'R' then
   begin
    if pst[1] = ']' then Soort := 26 else       { [reg] }
    if pst[1] = ',' then                        { [reg, xxxx] }
     begin
      Soort := 39;
      delete(Regel, 1, 1);
      ValidateOperand(OperandCode, VOSoort, c1);

      pst := '';
      by := 1;
      while ((by <= length(Regel)) and not(Regel[by] in [' ', ';', #9, '!'])) do
       begin
        pst := pst + Upcase(Regel[by]);
        inc(by)
       end;

      if pst[1] <> ']' then ErrorEnd(16);
     end
    else ErrorEnd(16);

    delete(Regel, 1, 1);
   end
    else Soort := 0;
end;





procedure CheckOpcodeGideon;
var
  b : byte;
  c1, c2 : char;
  plo, OpWaarde : longint;
label PL1;

 procedure CheckLine;
 begin
   if Regel = '' then ErrorEnd(15);

   if Regel[1] = '[' then OperIndirectGZ(OpWaarde, bCodeType) else
    begin
     OperImmediateGZ(OpWaarde, bCodeType);
     if (bMemWidth = 0) and (OpWaarde > $FF) and (OpWaarde <= $FFFF) then
      bMemWidth := 1;
    end;

   if Regel[1] <> ',' then ErrorEnd(60);
   delete(Regel, 1, 1);
   ValidateOperand(plo, c2, c1);
   DestReg2Code(c1);
   Commentaar := Regel;
   Regel := '';
 end;

 procedure CheckLine2;
 begin
   if Regel = '' then ErrorEnd(15);

   if Regel[1] = '[' then OperIndirectGZ(OpWaarde, bCodeType) else
    begin
     OperImmediateGZ(OpWaarde, bCodeType);
     if bCodeType = 6 then ErrorEnd(16);
    end;
 end;

 procedure SubOpcode(b : byte);
 begin
   CheckLine;
   bOpcodeB1 := b;
   bOpcodeB2 := bDesReg or bMemWidth;
   SourceReg2Code(cSrcReg);
   pCodeType(OpWaarde);
 end;

 procedure SubOpcode2(b1, b2 : byte);
 begin
   CheckLine2;
   bOpcodeB1 := b1;
   bOpcodeB2 := bMemWidth or b2;
   SourceReg2Code(cSrcReg);
   pCodeType(OpWaarde);
 end;

 procedure SubOpcode3(b2 : byte);
 begin
   CheckLine2;
   bOpcodeB1 := $B3;
   bOpcodeB2 := bMemWidth or b2;
   SourceReg2Code(cSrcReg);
   pCodeType(OpWaarde);
 end;

begin
  bMemWidth := 0;
  bAddrWidth := 0;
  iShift := 0;
  if pos('.', Opcode) = 0 then Opcode := Opcode + '.B';
  CheckExtension;

  if Opcode = 'ADD'  then subOpcode($33) else
  if Opcode = 'ADDC' then subOpcode($43) else
  if Opcode = 'AND'  then subOpcode($13) else

  if Opcode = 'BCC' then OperBranchGZ($F7, $00, $90) else
  if Opcode = 'BCS' then OperBranchGZ($F7, $40, $B0) else
  if Opcode = 'BEQ' then OperBranchGZ($F7, $C0, $F0) else
  if Opcode = 'BGE' then OperBranchGZ($FB, $40, $00) else
  if Opcode = 'BGT' then OperBranchGZ($FB, $C0, $00) else
  if Opcode = 'BIT' then subOpcode2($E3, $10) else
  if Opcode = 'BLE' then OperBranchGZ($FF, $00, $00) else
  if Opcode = 'BLT' then OperBranchGZ($FB, $80, $00) else
  if Opcode = 'BMI' then OperBranchGZ($F3, $40, $30) else
  if Opcode = 'BNE' then OperBranchGZ($F7, $80, $D0) else
  if Opcode = 'BPL' then OperBranchGZ($F3, $00, $10) else
  if Opcode = 'BPO' then OperBranchGZ($FF, $40, $00) else
  if Opcode = 'BRA' then OperBranchGZ($FB, $00, $00) else
  if Opcode = 'BRK' then Oper1Byte($00) else
  if Opcode = 'BVC' then OperBranchGZ($F3, $80, $50) else
  if Opcode = 'BVS' then OperBranchGZ($F3, $C0, $70) else

  if (Opcode = 'CFLAG') or (Opcode = 'SFLAG') then OperFlag else

  if Opcode = 'CLC'    then Oper1byte($18) else
  if Opcode = 'CLD'    then Oper1byte($D8) else
  if Opcode = 'CLI'    then Oper1byte($58) else
  if Opcode = 'CLV'    then Oper1byte($B8) else
  if Opcode = 'CMP'    then subOpcode($73) else
  if Opcode = 'DEC'    then subOpcode2($E3, 4) else
  if Opcode = 'EOR'    then subOpcode($23) else
  if Opcode = 'INC'    then subOpcode2($E3, 0) else
  if Opcode = 'JSR'    then subOpcode2($B3, 0) else
  if Opcode = 'LCNTR'  then subOpcode3($10) else
  if Opcode = 'LD'     then subOpcode($83) else
  if Opcode = 'LMMU0'  then subOpcode3($18) else
  if Opcode = 'LMMU1'  then subOpcode3($19) else
  if Opcode = 'MIRROR' then subOpcode2($E3, 12) else
  if Opcode = 'MOV'    then subOpcode($A3) else
  if Opcode = 'OR'     then subOpcode($23) else
  if Opcode = 'RET'    then Dump2byte($B3,  4 or bMemWidth) else
  if Opcode = 'RETI'   then Dump2byte($B3, 12 or bMemWidth) else
  if Opcode = 'SCNTR'  then subOpcode3($12) else

  if    (Opcode = 'SHL') or (Opcode = 'SHLC')
     or (Opcode = 'SHR') or (Opcode = 'SHRC') then
   begin
    if copy(Opcode, 1, 3) = 'SHL' then bOpcodeB1 := $C3
     else bOpcodeB1 := $D3;

    CheckLine2;
    delete(Regel, 1, 1);
    OperImmediateGZ(plo, b);

    if ((bPass < 3) or (plo = 0)) then plo := 1;
    if ((plo < 1) or (plo > 4)) then ErrorEnd(47);
    bOpcodeB2 := plo shl 2;

    if (length(Opcode) = 4) then bOpcodeB2 := $10 or bMemWidth or bOpcodeB2
     else bOpcodeB2 := bMemWidth or bOpcodeB2;

    SourceReg2Code(cSrcReg);
    pCodeType(OpWaarde);
   end
    else

  if Opcode = 'SMMU0'  then subOpcode3($1A) else
  if Opcode = 'SMMU1'  then subOpcode3($1B) else

  if Opcode = 'ST' then
   begin
    ValidateOperand(plo, c2, c1);
    DestReg2Code(c1);
    if Regel[1] <> ',' then ErrorEnd(60);
    delete(Regel, 1, 1);

    if Regel[1] = '[' then OperIndirectGZ(OpWaarde, bCodeType) else
     begin
      OperImmediateGZ(OpWaarde, bCodeType);
      if (bMemWidth = 0) and (OpWaarde > $FF) and (OpWaarde <= $FFFF) then
       bMemWidth := 1;
     end;

    bOpcodeB1 := $93;
    bOpcodeB2 := bDesReg or bMemWidth;
    SourceReg2Code(cSrcReg);
    pCodeType(OpWaarde);
    Commentaar := Regel;
    Regel := '';
   end
    else

  if Opcode = 'SUB'    then subOpcode($53) else
  if Opcode = 'SUBC'   then subOpcode($63) else
  if Opcode = 'SWAP'   then subOpcode2($E3, 8) else
  if (Opcode = 'TRAP') or (Opcode = 'TRAPB') then
   begin
    OperImmediateGZ(OpWaarde, bCodeType);
    if OpWaarde > $1F then ErrorEnd(60);
    bOpcodeB1 := $B3 or ((OpWaarde shr 1) and $0C);
    bOpcodeB2 := ((OpWaarde shl 5) and $E0);

    if Opcode = 'TRAP' then bOpcodeB2 := bOpcodeB2 or 8 or bMemWidth
     else bOpcodeB2 := bOpcodeB2 or 10 or bMemWidth;

    Dump2byte(bOpcodeB1, bOpcodeB2);
    Commentaar := Regel;
    Regel := '';
   end
  else ErrorEnd(60);
end;


begin
end.


