unit mp_asmu3;


interface


uses RB_unit0, MP_ASMU1, MP_ASMU4, MP_ASMU9;


procedure  CheckOpcodeZ80;


{============================================================================}



implementation


const
  BitOp   = '|RES|SET|';
  Reg8    = '|B|C|D|E|H|L|(HL)|A|';
  ShiftOp = '|RLC|RRC|RL|RR|SLA|SRA|SLL|SRL|';
  UndocSD = '|A|B|C|D|E|XH|XL|YH|YL|';
  UndocXY = '|XL|XH|YL|YH|';

{opcodes for undoc 8bit LD}
 ld80xy : array[0..55] of byte =
   { xl/xh/yl/yh  a/b/c/d/e/xh/lh/yh/yl }
   (   $DD,$6f       { ld xl,a }
   ,   $DD,$68       { ld xl,b }
   ,   $DD,$69       { ld xl,c }
   ,   $DD,$6a       { ld xl,d }
   ,   $DD,$6b       { ld xl,e }
   ,   $DD,$6c       { ld xl,xh }
   ,   $DD,$6d       { ld xl,xl }
   ,   $DD,$67       { ld xh,a }
   ,   $DD,$60       { ld xh,b }
   ,   $DD,$61       { ld xh,c }
   ,   $DD,$62       { ld xh,d }
   ,   $DD,$63       { ld xh,e }
   ,   $DD,$64       { ld xh,xh }
   ,   $DD,$65       { ld xh,xl }
   ,   $FD,$6f       { ld yl,a }
   ,   $FD,$68       { ld yl,b }
   ,   $FD,$69       { ld yl,c }
   ,   $FD,$6a       { ld yl,d }
   ,   $FD,$6b       { ld yl,e }
   ,   $FD,$6c       { ld yl,yh }
   ,   $FD,$6d       { ld yl,yl }
   ,   $FD,$67       { ld yl,a }
   ,   $FD,$60       { ld yh,b }
   ,   $FD,$61       { ld yh,c }
   ,   $FD,$62       { ld yh,d }
   ,   $FD,$63       { ld yh,e }
   ,   $FD,$64       { ld yh,yh }
   ,   $FD,$65  );   { ld yh,yl }

  ld80xy_n : array[0..7] of byte =
   (   $DD,$2e       { ld xl,nn }
   ,   $DD,$26       { ld xh,nn }
   ,   $FD,$2e       { ld yl,nn }
   ,   $FD,$26  );   { ld yh,nn }

  ld80xy2 : array[0..39] of byte =
   (   $DD,$7D     { ld a,xl }
   ,   $DD,$7C     { ld a,xh }
   ,   $FD,$7D     { ld a,yl }
   ,   $FD,$7C     { ld a,yh }
   ,   $DD,$45     { ld b,xl }
   ,   $DD,$44     { ld b,xh }
   ,   $FD,$45     { ld b,yl }
   ,   $FD,$44     { ld b,yh }
   ,   $DD,$4D     { ld c,xl }
   ,   $DD,$4C     { ld c,xh }
   ,   $FD,$4D     { ld c,yl }
   ,   $FD,$4C     { ld c,yh }
   ,   $DD,$55     { ld d,xl }
   ,   $DD,$54     { ld d,xh }
   ,   $FD,$55     { ld d,yl }
   ,   $FD,$54     { ld d,yh }
   ,   $DD,$5D     { ld e,xl }
   ,   $DD,$5C     { ld e,xh }
   ,   $FD,$5D     { ld e,yl }
   ,   $FD,$5C  ); { ld e,yh }



var
  bExtraOp      : byte;

  idx, tmp      : integer;

  PRegister1,
  PRegister2    : string[5];


{============================================================================}


procedure  Z80AritmLogic(code,immcode:byte; var OpWaarde,OpWaarde2:longint);
                                                                     forward;
procedure  Z80Shift(startcode:byte; var OpWaarde,OpWaarde2:longint); forward;


{============================================================================}


function FindSubstrIdx(what, where : string) : integer;
var
 tmp : string;
 p,q : pchar;
   i : integer;
  dc : char;
begin
  FindSubstrIdx := -1;
  i := pos('|' + what + '|', where);
  if i > 0 then FindSubstrIdx := i;
end;


function IsSubstr(what, where : string) : boolean;
begin
  IsSubstr := (pos('|' + what + '|', where) > 0);
end;


{ add/adc/sub/sbc/and/xor/or/cp xl/xh/yl/yh}
function undoc0(ur : string; base : byte) : word;
var
  i : integer;
  lb, hb : byte;
begin
  i := FindSubstrIdx(ur, UndocXY);
  hb := (base or 4) + (i and 1);

  case i and 2 of
    0 : lb := $DD;
    2 : lb := $FD;
   end;

  undoc0:=(hb shl 8) + lb;
end;


{ inc/dec xl/xh/yl/yh}
function undoc1(ur:string; base:byte):word;
var
  i : integer;
  lb, hb : byte;
begin
  i := FindSubstrIdx(ur, UndocXY);
  hb := base + ((i and 1 xor 1) shl 3);

  case i and 2 of
    0 : lb := $DD;
    2 : lb := $FD;
   end;

  undoc1:=(hb shl 8) + lb;
end;


function UndocReg(s : string) : boolean;
begin
  UndocReg := (pos('|' + s + '|', UndocXY) > 0);
end;


{============================================================================}


procedure Oper80_branch(Opcode : byte; Adres : longint);
var
  plo,plo2 : longint;
begin
  plo2 := BufPtr+2;

  if (    ((Adres - plo2 > $7F) or (plo2 - Adres > $80))
      and (bPass = 3)
     ) then ErrorEnd(19);

  if Adres >= plo2 then plo := Adres - plo2 else
    plo := 256 + Adres - plo2;

  Dump2byte(Opcode, plo and $FF);
end;


procedure oper80_displace(Opcode1, Opcode2 : byte; OperandCode : longint);
begin
  if ((OperandCode > $FF) and (bPass = 3)) then ErrorEnd(19);
  if Opcode1 = 0 then Dump2byte(Opcode2, OperandCode and $FF) else
   begin
    OperandCode := (OperandCode shl 8) + Opcode2;
    Dump3byte(Opcode1, OperandCode and $FFFF);
   end;
  bCodeType := 255;
end;


procedure oper80_first(var OperandCode, OprCode: longint; var Soort : byte);
var
  Found,Indirect : boolean;
  VOSoort1,VOSoort2 : char;
  by : byte;
  pst : string;
  negative : boolean;
begin
  VOSoort1 := 'B';
  VOSoort2 := 'B';
  OperandCode := 0;
  OprCode := 0;
  bExtraOp := $FF; { for ->reg8 handling }

{* Check for (...) *}
  Indirect := (Regel[1] = '(');
  if Indirect then Regel := copy(Regel, 2, length(Regel)-1);

{* Read first argument *}
  pst := '';
  by := 1;
  while (    (by <= length(Regel))
         and not(Regel[by] in [',', ' ', ';', ')', '+', '-', #9])) do
   begin
    pst := pst + Upcase(Regel[by]);
    inc(by)
   end;

  PRegister1 := '';
  Found := false;

{* Register... *}
  if (   (pst = 'A') or (pst = 'B') or (pst = 'C') or (pst = 'D')
      or (pst = 'E') or (pst = 'F') or (pst = 'H') or (pst = 'I')
      or (pst = 'L') or (pst = 'R') or (pst = 'AF') or (pst = 'BC')
      or (pst = 'DE') or (pst = 'HL') or (pst = 'IX') or (pst = 'IY')
      or (pst = 'SP') or (pst = 'NZ') or (pst = 'Z') or (pst = 'NC')
      or (pst = 'PO') or (pst = 'PE') or (pst = 'PE') or (pst = 'M')
      or (pst = 'P')) then
   begin
    Found := true;
    PRegister1 := pst;
    Regel := short(copy(regel, by, Length(Regel)-by+1));
    bCodeType := 1;
   end
    else

{* ...or label/value *}
   begin
    bRecurLevel := 0;
    ValidateOperand(OperandCode, VOSoort1, cSrcReg);
    Found := (VOSoort1 <> 'X');
    bCodeType := 2;
   end;

  if (Indirect and Found) then
   begin
    if Regel[1] in ['+', '-'] then
     begin
      negative:=(regel[1]='-');

  {*  (IX+d) or ((IY+d)  *}
      Regel := short(copy(regel, 2, Length(Regel)-1));
      bRecurLevel := 0;
      ValidateOperand(OperandCode, VOSoort1, cSrcReg);
      if negative then OperandCode:=256-OperandCode;
      Found := (VOSoort1 <> 'X');
      bCodeType := 3;
     end;

    if Regel[1] <> ')' then ErrorEnd(16);
    Regel := short(copy(regel, 2, Length(Regel)-1));
    bCodeType := bCodeType or 4;

{* handling the extra loading -> reg8 with shift (ix/iy+xx) *}
    if    IsSubstr(Opcode, ShiftOp)
      and (regel[1] = '-') and (regel[2] = '>') then
     begin
      idx := FindSubstrIdx(regel[3], reg8);
      if idx <> 6 then { (hl) invalid here }
       begin
        Regel := short(copy(regel, 4, Length(Regel)-3));
        bExtraOp := idx;
       end;
     end;
   end;

  if not Found then bCodeType := 0;
  if ((Regel = '') or (Regel[1] = ';')) then
   begin
    PRegister2 := PRegister1;
    Commentaar := Regel;
    Regel := '';
    exit;
   end;

  if Regel[1] <> ',' then ErrorEnd(16);
  Regel := short(copy(regel, 2, Length(Regel)-1));
  if ((Regel[1] = ';') or (Regel = '')) then ErrorEnd(16);

{* Check for (...) *}
  Indirect := (Regel[1] = '(');
  if Indirect then Regel := copy(Regel, 2, length(Regel)-1);

{* Read second argument *}
  pst := '';
  by := 1;
  while (    (by <= length(Regel))
         and not(Regel[by] in [',', ' ', ';', ')', '+', '-', #9])) do
   begin
    pst := pst + Upcase(Regel[by]);
    inc(by)
   end;

  PRegister2 := '';
  Found := false;

{* Register... *}
  if (   (pst = 'A') or (pst = 'B') or (pst = 'C') or (pst = 'D')
      or (pst = 'E') or (pst = 'F') or (pst = 'H') or (pst = 'I')
      or (pst = 'L') or (pst = 'R') or (pst = 'AF') or (pst = 'BC')
      or (pst = 'DE') or (pst = 'HL') or (pst = 'IX') or (pst = 'IY')
      or (pst = 'SP') or (pst = 'AF'#39)) then
   begin
    Found := true;
    PRegister2 := pst;
    Regel := short(copy(regel, by, Length(Regel)-by+1));
    bCodeType := bCodeType or 8;
   end
    else

{* ...or label/value *}
   begin
    bRecurLevel := 0;
    ValidateOperand(OprCode, VOSoort2, cSrcReg);
    Found := (VOSoort2 <> 'X');
    bCodeType := bCodeType or $10;
   end;

  if (Indirect and Found) then
   begin
    if Regel[1] in ['+', '-'] then
     begin
      negative:=(regel[1]='-');

  {*  (IX+d) or ((IY+d)  *}
      Regel := short(copy(regel, 2, Length(Regel)-1));
      bRecurLevel := 0;
      ValidateOperand(OprCode, VOSoort2, cSrcReg);
      if negative then OprCode:=256-OprCode;
      Found := (VOSoort2 <> 'X');
      bCodeType := bCodeType or $18;
     end;

    if Regel[1] <> ')' then ErrorEnd(16);
    Regel := short(copy(regel, 2, Length(Regel)-1));
    bCodeType := bCodeType or $20;

{* handling the extra loading ->reg8 with set/res (ix/iy+xx) *}
    if IsSubstr(Opcode,bitop)and(regel[1]='-')and(regel[2]='>') then
     begin
      idx:=FindSubstrIdx(regel[3],Reg8);
      if idx<>6 then { (hl) invalid here }
       begin
        Regel:=short(copy(regel, 4, Length(Regel)-3));
        bExtraOp:=idx;
       end;
     end;
   end;

  if VOSoort1 = 'W' then bCodeType := bCodeType or $40;
  if VOSoort2 = 'W' then bCodeType := bCodeType or $80;

  if not Found then bCodeType := 0;
  Commentaar := Regel;
  Regel := '';
end;


procedure Oper80_XXcccXXX(Opcode : byte; Adres : longint);
begin
  if Adres > $FFFF then ErrorEnd(3);
  if PRegister1 = 'NZ' then Dump3byte(Opcode or $00, Adres) else
  if PRegister1 = 'Z'  then Dump3byte(Opcode or $08, Adres) else
  if PRegister1 = 'NC' then Dump3byte(Opcode or $10, Adres) else
  if PRegister1 = 'C'  then Dump3byte(Opcode or $18, Adres) else
  if PRegister1 = 'PO' then Dump3byte(Opcode or $20, Adres) else
  if PRegister1 = 'PE' then Dump3byte(Opcode or $28, Adres) else
  if PRegister1 = 'P'  then Dump3byte(Opcode or $30, Adres) else
  if PRegister1 = 'M'  then Dump3byte(Opcode or $38, Adres) else
   ErrorEnd(16);
end;


procedure Oper80_XXXccXXX(Opcode : byte; Adres : longint);
var
  by : byte;
  plo,plo2 : longint;
begin
  plo2 := BufPtr+2;

  if (    ((Adres - plo2 > $7F) or (plo2 - Adres > $80))
      and (bPass = 3)
     ) then ErrorEnd(19);

  if Adres >= plo2 then plo := Adres - plo2 else
    plo := 256 + Adres - plo2;

  by :=  plo and $FF;
  if PRegister1 = 'NZ' then Dump2byte(Opcode or $00, by) else
  if PRegister1 = 'Z'  then Dump2byte(Opcode or $08, by) else
  if PRegister1 = 'NC' then Dump2byte(Opcode or $10, by) else
  if PRegister1 = 'C'  then Dump2byte(Opcode or $18, by) else
   ErrorEnd(16);
end;


procedure Oper80_XXqqXXXX(Opcode : byte);
begin
  if PRegister2 = 'AF' then Dump1Byte(Opcode or $30) else
  if PRegister2 = 'BC' then Dump1Byte(Opcode or $00) else
  if PRegister2 = 'DE' then Dump1Byte(Opcode or $10) else
  if PRegister2 = 'HL' then Dump1Byte(Opcode or $20) else
   ErrorEnd(16);
end;


procedure Oper80_XXppXXXX(Opcode : byte);
begin
  if PRegister2 = 'BC' then Dump2byte($DD, Opcode or $00) else
  if PRegister2 = 'DE' then Dump2byte($DD, Opcode or $10) else
  if PRegister2 = 'IX' then Dump2byte($DD, Opcode or $20) else
  if PRegister2 = 'SP' then Dump2byte($DD, Opcode or $30) else
   ErrorEnd(16);
end;


procedure Oper80_XXrrrrrr(Opcode : byte);
begin
  if PRegister2 = 'A' then Opcode := (Opcode or 7) else
  if PRegister2 = 'B' then Opcode := (Opcode or 0) else
  if PRegister2 = 'C' then Opcode := (Opcode or 1) else
  if PRegister2 = 'D' then Opcode := (Opcode or 2) else
  if PRegister2 = 'E' then Opcode := (Opcode or 3) else
  if PRegister2 = 'H' then Opcode := (Opcode or 4) else
  if PRegister2 = 'L' then Opcode := (Opcode or 5) else
   ErrorEnd(16);
  if PRegister1 = 'A' then Dump1Byte(Opcode or $38) else
  if PRegister1 = 'B' then Dump1Byte(Opcode or 0) else
  if PRegister1 = 'C' then Dump1Byte(Opcode or 8) else
  if PRegister1 = 'D' then Dump1Byte(Opcode or $10) else
  if PRegister1 = 'E' then Dump1Byte(Opcode or $18) else
  if PRegister1 = 'H' then Dump1Byte(Opcode or $20) else
  if PRegister1 = 'L' then Dump1Byte(Opcode or $28) else
   ErrorEnd(16);
end;


procedure Oper80_XXrrrXXX(Opcode : byte; PRegister : string);
begin
  if PRegister = 'A' then Dump1Byte(Opcode or $38) else
  if PRegister = 'B' then Dump1Byte(Opcode or 0) else
  if PRegister = 'C' then Dump1Byte(Opcode or 8) else
  if PRegister = 'D' then Dump1Byte(Opcode or $10) else
  if PRegister = 'E' then Dump1Byte(Opcode or $18) else
  if PRegister = 'H' then Dump1Byte(Opcode or $20) else
  if PRegister = 'L' then Dump1Byte(Opcode or $28) else
   ErrorEnd(16);
end;


procedure Oper80_XXrrrXXX2(Opc2, Opc1 : byte; PRegister : string);
begin
  if PRegister = 'A' then Opc1 := (Opc1 or $38) else
  if PRegister = 'B' then Opc1 := (Opc1 or 0) else
  if PRegister = 'C' then Opc1 := (Opc1 or 8) else
  if PRegister = 'D' then Opc1 := (Opc1 or $10) else
  if PRegister = 'E' then Opc1 := (Opc1 or $18) else
  if PRegister = 'H' then Opc1 := (Opc1 or $20) else
  if PRegister = 'L' then Opc1 := (Opc1 or $28) else
   ErrorEnd(16);
  Dump2byte(Opc2, Opc1);
end;


procedure Oper80_XXrrrXXXd(Opc1, Opc2 : byte; Dis : longint; Pregister : string);
begin
  if ((Dis > $FF) and (bPass = 3)) then ErrorEnd(19);
  if PRegister = 'A' then Opc2 := (Opc2 or $38) else
  if PRegister = 'B' then Opc2 := (Opc2 or 0) else
  if PRegister = 'C' then Opc2 := (Opc2 or 8) else
  if PRegister = 'D' then Opc2 := (Opc2 or $10) else
  if PRegister = 'E' then Opc2 := (Opc2 or $18) else
  if PRegister = 'H' then Opc2 := (Opc2 or $20) else
  if PRegister = 'L' then Opc2 := (Opc2 or $28) else
   ErrorEnd(16);
  Dump3byte(Opc1, (Dis shl 8) + Opc2);
end;


procedure Oper80_XXrrrXXXn(Opc1 : byte; Data : longint);
begin
  if PRegister1 = 'A' then Opc1 := (Opc1 or $38) else
  if PRegister1 = 'B' then Opc1 := (Opc1 or 0) else
  if PRegister1 = 'C' then Opc1 := (Opc1 or 8) else
  if PRegister1 = 'D' then Opc1 := (Opc1 or $10) else
  if PRegister1 = 'E' then Opc1 := (Opc1 or $18) else
  if PRegister1 = 'H' then Opc1 := (Opc1 or $20) else
  if PRegister1 = 'L' then Opc1 := (Opc1 or $28) else
   ErrorEnd(16);
  Dump2byte(Opc1, Data and $FF);
end;


procedure Oper80_XXrrXXXX(Opcode : byte);
begin
  if PRegister2 = 'BC' then Dump2byte($FD, Opcode or $00) else
  if PRegister2 = 'DE' then Dump2byte($FD, Opcode or $10) else
  if PRegister2 = 'IY' then Dump2byte($FD, Opcode or $20) else
  if PRegister2 = 'SP' then Dump2byte($FD, Opcode or $30) else
   ErrorEnd(16);
end;


procedure Oper80_XXssXXXX(Opcode : byte);
begin
  if PRegister2 = 'BC' then Dump2byte($ED, Opcode or $00) else
  if PRegister2 = 'DE' then Dump2byte($ED, Opcode or $10) else
  if PRegister2 = 'HL' then Dump2byte($ED, Opcode or $20) else
  if PRegister2 = 'SP' then Dump2byte($ED, Opcode or $30) else
   ErrorEnd(16);
end;


procedure Oper80_XXssXXXX2(Opcode : byte; PRegister : string);
begin
  if PRegister = 'BC' then Dump1Byte(Opcode or $00) else
  if PRegister = 'DE' then Dump1Byte(Opcode or $10) else
  if PRegister = 'HL' then Dump1Byte(Opcode or $20) else
  if PRegister = 'SP' then Dump1Byte(Opcode or $30) else
   ErrorEnd(16);
end;


procedure Oper80_XXssXXXXnn(Opcode : byte; Adres : longint);
begin
  if PRegister2 = 'BC' then Dump4byte3($ED, Opcode or $00, Adres) else
  if PRegister2 = 'DE' then Dump4byte3($ED, Opcode or $10, Adres) else
  if PRegister2 = 'HL' then Dump4byte3($ED, Opcode or $20, Adres) else
  if PRegister2 = 'SP' then Dump4byte3($ED, Opcode or $30, Adres) else
   ErrorEnd(16);
end;


procedure Oper80_XXssXXXXnn2(Opcode : byte; Adres : longint);
begin
  if PRegister2 = 'BC' then Dump3byte(Opcode or $00, Adres) else
  if PRegister2 = 'DE' then Dump3byte(Opcode or $10, Adres) else
  if PRegister2 = 'HL' then Dump3byte(Opcode or $20, Adres) else
  if PRegister2 = 'SP' then Dump3byte(Opcode or $30, Adres) else
   ErrorEnd(16);
end;


procedure Oper80_XXXXXrrr(Opcode : byte);
begin
  if PRegister2 = 'A' then Dump1Byte(Opcode or 7) else
  if PRegister2 = 'B' then Dump1Byte(Opcode or 0) else
  if PRegister2 = 'C' then Dump1Byte(Opcode or 1) else
  if PRegister2 = 'D' then Dump1Byte(Opcode or 2) else
  if PRegister2 = 'E' then Dump1Byte(Opcode or 3) else
  if PRegister2 = 'H' then Dump1Byte(Opcode or 4) else
  if PRegister2 = 'L' then Dump1Byte(Opcode or 5) else
   ErrorEnd(16);
end;


procedure Oper80_XXXXXrrr2(Opc1, Opc2 : byte);
begin
  if PRegister2 = 'A' then Dump2Byte(Opc1, Opc2 or 7) else
  if PRegister2 = 'B' then Dump2Byte(Opc1, Opc2 or 0) else
  if PRegister2 = 'C' then Dump2Byte(Opc1, Opc2 or 1) else
  if PRegister2 = 'D' then Dump2Byte(Opc1, Opc2 or 2) else
  if PRegister2 = 'E' then Dump2Byte(Opc1, Opc2 or 3) else
  if PRegister2 = 'H' then Dump2Byte(Opc1, Opc2 or 4) else
  if PRegister2 = 'L' then Dump2Byte(Opc1, Opc2 or 5) else
   ErrorEnd(16);
end;


procedure Oper80_XXXXXrrrd(Opc1, Opc2 : byte; Dis : longint);
begin
  if ((Dis > $FF) and (bPass = 3)) then ErrorEnd(19);
  if PRegister2 = 'A' then Opc2 := (Opc2 or 7) else
  if PRegister2 = 'B' then Opc2 := (Opc2 or 0) else
  if PRegister2 = 'C' then Opc2 := (Opc2 or 1) else
  if PRegister2 = 'D' then Opc2 := (Opc2 or 2) else
  if PRegister2 = 'E' then Opc2 := (Opc2 or 3) else
  if PRegister2 = 'H' then Opc2 := (Opc2 or 4) else
  if PRegister2 = 'L' then Opc2 := (Opc2 or 5) else
   ErrorEnd(16);
  Dump3byte(Opc1, (Dis shl 8) + Opc2);
end;



{============================================================================}


procedure CheckOpcodeZ80;
var
  by : byte;
  Tel, Tel2 : integer;
  OpWaarde, OpWaarde2 : longint;
  TWaarde : string;
begin
{****  Z80

operand        sub-operand      register

b                               bit

cc                              conditie

e                               data  8 bit  relatief

m              r                A
                                B
                                C
                                D
                                E
                                H
                                L

               (HL)

               (IX+d)

               (IY+d)

nn                              data  L/H  16 bit

pp                              BC
                                DE
                                IX
                                SP

qq                              AF
                                BC
                                DE
                                HL

rr                              BC
                                DE
                                IY
                                SP

s              r                A
                                B
                                C
                                D
                                E
                                H
                                L

               n                data  8 bit

               (HL)

               (IX+d)

               (IY+d)

ss                              BC
                                DE
                                HL
                                SP

Combinaties:

       A,I     DE,HL   IY      (BC),A  (IX+d),r(nn),A  b,m     r,(C)   ss,nn   
        A,R     HL,(nn) IY,nn   (C),r   (IY)    (nn),HL b,r     r,(HL)  ss,(nn)
         A,(BC)  HL,ss   IY,(nn)  (DE),A  (IY+d),n (nn),IX  cc      r,(IX+d) n     
          A,(DE)   I,A     IY,rr   (HL)    (IY+d),r (nn),IY  cc,e    r,(IY+d)      
           A,(n)    IX      R,A     (HL),n   (SP),HL  (nn),ss  cc,nn    r,n         
            A,(nn)   IX,nn    SP,HL    (HL),r   (SP),IX  b,(HL)   e       r,r        
             A,s      IX,(nn)  SP,IX    (IX)     (SP),IY  b,(IX+d) m       s = A,s    
              AF,AF'   IX,pp    SP,IY    (IX+d),n (n),A    b,(IY+d) nn       ss        
                                                                               
Opcodes:                                                                       
                                                                               
ADC          X   X                                                             ADC
ADD          X   X    X   X       X                                            ADD
AND                                                                  X         AND
BIT                                                 XXX X                      BIT
CALL                                                       X  X                CALL
CCF                                                                            CCF
CP                                                                   X         CP
CPD                                                                            CPD
CPDR                                                                           CPDR
CPI                                                                            CPI
CPIR                                                                           CPIR
CPL                                                                            CPL
DAA                                                                            DAA
DEC                X   X                                     X        X        DEC
DI                                                                             DI
DJNZ                                                        X                  DJNZ
EI                                                                             EI
EX            XX                           XXX                                 EX
EXX                                                                            EXX
HALT                                                                           HALT
IM                                                                       X     IM
IN         X                                                   X               IN
INC                X   X                                     X         X       INC
IND                                                                            IND
INDR                                                                           INDR
INI                                                                            INI
INIR                                                                           INIR
JP                                X  X  X                 XX  X                JP
JR                                                          X                  JR
LD     XXXX X   X X XX  XX XXXXX X XX XX XX    XXXXX            XXXXX  XX      LD
LDD                                                                            LDD
LDDR                                                                           LDDR
LDI                                                                            LDI

       A,I     DE,HL   IY      (BC),A  (IX+d),r(nn),A  b,m     r,(C)   ss,nn   
        A,R     HL,(nn) IY,nn   (C),r   (IY)    (nn),HL b,r     r,(HL)  ss,(nn)
         A,(BC)  HL,ss   IY,(nn)  (DE),A  (IY+d),n (nn),IX  cc      r,(IX+d) n     
          A,(DE)   I,A     IY,rr    (HL)    (IY+d),r (nn),IY  cc,e    r,(IY+d) pp   
           A,(n)    IX      R,A      (HL) n   (SP),HL  (nn),ss  cc,nn    r,n     qq  
            A,(nn)   IX,nn    SP,HL    (HL),r   (SP),IX  b,(HL)   e       r,r        
             A,s      IX,(nn)  SP,IX    (IX)     (SP),IY  b,(IX+d) m       s = A,s    
              AF,AF'   IX,pp    SP,IY    (IX+d),n (n),A    b,(IY+d) nn       ss        
                                                                               
LDIR                                                                           LDIR
NEG                                                                            NEG
NOP                                                                            NOP
OR                                                                   X         OR
OTDR                                                                           OTDR
OTIR                                                                           OTIR
OUT                             X             X                                OUT
OUTD                                                                           OUTD
OUTI                                                                           OUTI
POP                XX                                                      X   POP
PUSH               XX                                                      X   PUSH
RES                                                    X                       RES
RET                                                      X                     RET
RETI                                                                           RETI
RETN                                                                           RETN
RL                                                           X                 RL
RLA                                                                            RLA
RLC                                                          X                 RLC
RLCA                                                                           RLCA
RLD                                                                            RLD
RR                                                           X                 RR
RRA                                                                            RRA
RRC                                                          X                 RRC
RRCA                                                                           RRCA
RRD                                                                            RRD
RST                                                                      X     RST
SBC          X   X                                                             SBC
SCF                                                                            SCF
SET                                                    X                       SET
SLA                                                          X                 SLA
SRA                                                          X                 SRA
SRL                                                          X                 SRL
SUB                                                                  X         SUB
XOR                                                                  X         XOR

       A,I     DE,HL   IY      (BC),A  (IX+d),r(nn),A  b,m     r,(C)   ss,nn   
        A,R     HL,(nn) IY,nn   (C),r   (IY)    (nn),HL b,r     r,(HL)  ss,(nn)
         A,(BC)  HL,ss   IY,(nn)  (DE),A  (IY+d),n (nn),IX  cc      r,(IX+d) n     
          A,(DE)   I,A     IY,rr    (HL)    (IY+d),r (nn),IY  cc,e    r,(IY+d)      
           A,(n)    IX      R,A      (HL) n   (SP),HL  (nn),ss  cc,nn    r,n         
            A,(nn)   IX,nn    SP,HL    (HL),r   (SP),IX  b,(HL)   e       r,r        
             A,s      IX,(nn)  SP,IX    (IX)     (SP),IY  b,(IX+d) m       s = A,s    
              AF,AF'   IX,pp    SP,IY    (IX+d),n (n),A    b,(IY+d) nn       ss        
                                                                               


bCodeType:
 0000 0000 = Invalid / undetermined

First part of operand:
 x0xx xx01 = Opcode
 xxxx xx10 = Label/Value
 xxxx xx11 = IX/IY + d
 xxxx x1xx = (....)
 x0xx xxxx = Label/Value/d = byte
 x1xx xxxx = Label/Value/d = word

Second part of operand:
 0xx0 1xxx = Opcode
 xxx1 0xxx = Label/Value
 xxx1 1xxx = IX/IY + d
 xx1x xxxx = (....)
 0xxx xxxx = Label/Value/d = byte
 1xxx xxxx = Label/Value/d = word

****}
  if Opcode = 'ADC' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    if ((bCodeType and $47 = 1) and (PRegister1 = 'A')) then
     begin
      if UndocReg(PRegister2) then DumpWord(undoc0(PRegister2,$88)) else
      if bCodeType and $F8 = 8 then Oper80_XXXXXrrr($88) else
      if ((bCodeType and $78 = $10) and (OpWaarde2 < 256)) then
        Dump2byte($CE, OpWaarde2) else
      if ((bCodeType and $F8 = $28) and (PRegister2 = 'HL')) then
        Dump1Byte($8E) else
      if ((bCodeType and $68 = $28) and (PRegister2 = 'IX')) then
        oper80_displace($DD, $8E, OpWaarde2) else
      if ((bCodeType and $68 = $28) and (PRegister2 = 'IY')) then
        oper80_displace($FD, $8E, OpWaarde2) else
       ErrorEnd(16);
     end
      else
    if ((bCodeType = 9) and (PRegister1 = 'HL')) then Oper80_XXssXXXX($4A)
      else
    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'ADD' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    if ((bCodeType and $47 = 1) and (PRegister1 = 'A')) then
     begin
      if UndocReg(PRegister2) then
        DumpWord(undoc0(PRegister2,$80)) else
      if bCodeType and $F8 = 8 then Oper80_XXXXXrrr($80) else
      if ((bCodeType and $78 = $10) and (OpWaarde2 < 256)) then
        Dump2byte($C6, OpWaarde2) else
      if ((bCodeType and $F8 = $28) and (PRegister2 = 'HL')) then
        Dump1Byte($86) else
      if ((bCodeType and $68 = $28) and (PRegister2 = 'IX')) then
        oper80_displace($DD, $86, OpWaarde2) else
      if ((bCodeType and $68 = $28) and (PRegister2 = 'IY')) then
        oper80_displace($FD, $86, OpWaarde2) else
       ErrorEnd(16);
     end
      else
    if ((bCodeType = 9) and (PRegister1 = 'HL')) then
     Oper80_XXssXXXX2($09, PRegister2) else
    if ((bCodeType = 9) and (PRegister1 = 'IX')) then Oper80_XXppXXXX($09)
      else
    if ((bCodeType = 9) and (PRegister1 = 'IY')) then Oper80_XXrrXXXX($09)
      else
    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'AND' then Z80AritmLogic($a0,$e6,OpWaarde,OpWaarde2) else
  if Opcode = 'BIT' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    if PRegister1 ='' then Opwaarde := OpWaarde and $FFFF;
    if ((bCodeType and 7 = 2) and (OpWaarde < 8)) then
     begin
      if bCodeType and $B8 = 8 then
       begin
        by := (OpWaarde shl 3) and $38 + $40;
        Oper80_XXXXXrrr2($CB, by);
       end
        else
      if ((bCodeType and $F8 = $28) and (PRegister2 = 'HL')) then
        Dump2byte($CB, $46  or ((OpWaarde and $FF) shl 3)) else
      if ((bCodeType and $68 = $28) and (PRegister2 = 'IX')) then
        Dump4byte2($DD, $CB, OpWaarde2 and $FF, OpWaarde, $46) else
      if ((bCodeType and $68 = $28) and (PRegister2 = 'IY')) then
        Dump4byte2($FD, $CB, OpWaarde2 and $FF, OpWaarde, $46) else
       ErrorEnd(16);
     end
      else
    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'CALL' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    if bCodeType and $7F = $11 then Oper80_XXcccXXX($C4, OpWaarde2) else
    if bCodeType and $BF = 2 then Dump3Byte($CD, OpWaarde) else
    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'CCF' then Oper1Byte($3F) else
  if Opcode = 'CP' then Z80AritmLogic($b8,$fe,OpWaarde,OpWaarde2) else
  if Opcode = 'CPD' then Oper2Byte($ED, $A9) else
  if Opcode = 'CPDR' then Oper2Byte($ED, $B9) else
  if Opcode = 'CPI' then Oper2Byte($ED, $A1) else
  if Opcode = 'CPIR' then Oper2Byte($ED, $B1) else
  if Opcode = 'CPL' then Oper1Byte($2F) else
  if Opcode = 'DAA' then Oper1Byte($27) else
  if Opcode = 'DEC' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    if UndocReg(PRegister1) then
      DumpWord(undoc1(PRegister1,$25)) else

    if ((bCodeType = 1) and (PRegister1 = 'IX')) then Dump2Byte($DD, $2B) else
    if ((bCodeType = 1) and (PRegister1 = 'IY')) then Dump2Byte($FD, $2B) else
    if ((bCodeType = 1) and (length(Pregister1) = 1)) then
     Oper80_XXrrrXXX($05, Pregister1) else
    if bCodeType = 1 then Oper80_XXssXXXX2($0B, PRegister1) else
    if ((bCodeType = 5) and (PRegister1 = 'HL')) then Dump1Byte($35) else
    if ((bCodeType and $BD = 5) and (PRegister1 = 'IX')) then
      oper80_displace($DD, $35, OpWaarde) else
    if ((bCodeType and $BD = 5) and (PRegister1 = 'IY')) then
      oper80_displace($FD, $35, OpWaarde) else
    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'DI' then Oper1Byte($F3) else
  if Opcode = 'DJNZ' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    if bCodeType and $BF = 2 then oper80_branch($10, OpWaarde) else
    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'EI' then Oper1Byte($FB) else
  if Opcode = 'EX' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    if (    (bCodeType = 9) and (PRegister1 = 'AF')
        and (PRegister2 = 'AF'#39)) then Dump1Byte($08) else
    if (    (bCodeType = 9) and (PRegister1 = 'DE')
        and (PRegister2 = 'HL')) then Oper1Byte($EB) else
    if (    (bCodeType = $0D) and (PRegister1 = 'SP')
        and (PRegister2 = 'HL')) then Oper1Byte($E3) else
    if (    (bCodeType = $0D) and (PRegister1 = 'SP')
        and (PRegister2 = 'IX')) then Dump2Byte($DD, $E3) else
    if (    (bCodeType = $0D) and (PRegister1 = 'SP')
        and (PRegister2 = 'IY')) then Dump2Byte($FD, $E3) else
    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'EXX' then Oper1Byte($D9) else
  if Opcode = 'HALT' then Oper1Byte($76) else
  if Opcode = 'IM' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    if ((bCodeType and $BF = 2) and (OpWaarde = 0)) then Dump2Byte($ED, $46)
      else
    if ((bCodeType and $BF = 2) and (OpWaarde = 1)) then Dump2Byte($ED, $56)
      else
    if ((bCodeType and $BF = 2) and (OpWaarde = 2)) then Dump2Byte($ED, $5E)
      else
    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'IN' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    if (    (bCodeType and $BF = $31) and (OpWaarde2 < 256)
        and (PRegister1 = 'A')) then Dump2byte($DB, OpWaarde2) else
    if (    (bCodeType = $29) and (PRegister2 = 'C')) then
      Oper80_XXrrrXXX2($ED, $40, PRegister1) else
    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'INC' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    if UndocReg(PRegister1) then
      DumpWord(undoc1(PRegister1,$24)) else

    if ((bCodeType = 1) and (PRegister1 = 'IX')) then Dump2Byte($DD, $23) else
    if ((bCodeType = 1) and (PRegister1 = 'IY')) then Dump2Byte($FD, $23) else
    if ((bCodeType = 1) and (length(Pregister1) = 1)) then
     Oper80_XXrrrXXX($04, Pregister1) else
    if bCodeType = 1 then Oper80_XXssXXXX2($03, PRegister1) else
    if ((bCodeType = 5) and (PRegister1 = 'HL')) then Dump1Byte($34) else
    if ((bCodeType and $BD = 5) and (PRegister1 = 'IX')) then
      oper80_displace($DD, $34, OpWaarde) else
    if ((bCodeType and $BD = 5) and (PRegister1 = 'IY')) then
      oper80_displace($FD, $34, OpWaarde) else
    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'IND' then Oper2Byte($ED, $AA) else
  if Opcode = 'INDR' then Oper2Byte($ED, $BA) else
  if Opcode = 'INI' then Oper2Byte($ED, $A2) else
  if Opcode = 'INIR' then Oper2Byte($ED, $B2) else
  if Opcode = 'JP' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    if bCodeType and $7F = $11 then Oper80_XXcccXXX($C2, OpWaarde2) else
    if bCodeType and $BF = 2 then Dump3Byte($C3, OpWaarde) else
    if ((bCodeType = 5) and (PRegister1 = 'HL')) then Dump1Byte($E9) else
    if ((bCodeType = 5) and (PRegister1 = 'IX')) then Dump2Byte($DD, $E9) else
    if ((bCodeType = 5) and (PRegister1 = 'IY')) then Dump2Byte($FD, $E9) else
    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'JR' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    if bCodeType and $7F = $11 then Oper80_XXXccXXX($20, OpWaarde2) else
    if bCodeType and $BF = 2 then oper80_branch($18, OpWaarde) else
    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'LD' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    if UndocReg(PRegister1) then
     { ld xl/xh/yl/yh, a/b/c/d/e/xl/xh/yl/yh/nn8 }
     begin
      idx:=FindSubstrIdx(Pregister2,undocsd);
      if idx>-1 then
       begin
        tmp := FindSubstrIdx(Pregister1, UndocXY);
        if ((tmp<2)and(idx>6))or((tmp>1)and(idx in [5,6])) then
         ErrorEnd(16); { xl,yl xh,yl etc not allowed}
        if idx>6 then dec(idx,2); { yl/yh --> xl/xh }
        tmp:=7*tmp+idx; { index for the word table }
        Dump1Byte(ld80xy[tmp]);
        Dump1Byte(ld80xy[tmp + 1]);
       end
      else
      if (bCodeType and $7F = $11) and (OpWaarde<256) then
       begin { ld xl/xh/yl/yh, nn8 }
        idx:=FindSubstrIdx(PRegister1, UndocXY);
        Dump1Byte(ld80xy_n[idx]);
        Dump1Byte(ld80xy_n[idx + 1]);
        Dump1Byte(OpWaarde2);
       end else ErrorEnd(16);
     end
    else
    if UndocReg(PRegister2) then { ld a/b/c/d/e y, xl/xh/yl/yh }
     begin
      idx:=FindSubstrIdx(Pregister1, undocsd);
      if idx>-1 then
       begin
        tmp:=FindSubstrIdx(Pregister2, UndocXY);
        tmp:=4*idx+tmp;
        Dump1Byte(ld80xy2[tmp]);
        Dump1Byte(ld80xy2[tmp + 1]);
       end else ErrorEnd(16);
     end
    else
    if (    (bCodeType = $29) and (PRegister1 = 'A')
        and (PRegister2 = 'BC')) then Dump1Byte($0A) else
    if (    (bCodeType = $29) and (PRegister1 = 'A')
        and (PRegister2 = 'DE')) then Dump1Byte($1A) else
    if (    (bCodeType = 9) and (PRegister1 = 'A')
        and (PRegister2 = 'I')) then Dump2Byte($ED, $57) else
    if (    (bCodeType = 9) and (PRegister1 = 'A')
        and (PRegister2 = 'R')) then Dump2Byte($ED, $5F) else
    if (    (bCodeType = 9) and (PRegister1 = 'R')
        and (PRegister2 = 'A')) then Dump2Byte($ED, $4F) else
    if (    (bCodeType and $7F = $31) and (PRegister1 = 'A')) then
      Dump3byte($3A, OpWaarde2) else
    if (    (bCodeType and $BF = $31) and (PRegister1 = 'HL')) then
      Dump3byte($2A, OpWaarde2) else
    if (    (bCodeType and $BF = $15) and (PRegister1 = 'HL')
        and (OpWaarde2 < 256)) then Dump2byte($36, OpWaarde2) else
    if (    (bCodeType = $0D) and (PRegister1 = 'BC')
        and (PRegister2 = 'A')) then Dump1Byte($02) else
    if (    (bCodeType = $0D) and (PRegister1 = 'DE')
        and (PRegister2 = 'A')) then Dump1Byte($12) else
    if (    (bCodeType = $0D) and (PRegister1 = 'HL')) then
      Oper80_XXXXXrrr($70) else
    if (    (bCodeType = $29) and (PRegister2 = 'HL')) then
      Oper80_XXrrrXXX($46, PRegister1) else
    if (    (bCodeType = 9) and (PRegister1 = 'I')
        and (PRegister2 = 'A')) then Dump2Byte($ED, $47) else

    if (    (bCodeType and $7F = $11) and (PRegister1 = 'IX')) then
      Dump4byte3($DD, $21, OpWaarde2) else
    if (    (bCodeType and $7F = $31) and (PRegister1 = 'IX')) then
      Dump4byte3($DD, $2A, OpWaarde2) else
    if (    (bCodeType and $3F = $17) and (PRegister1 = 'IX')
        and (OpWaarde < 256) and (OpWaarde2 < 256)) then
      Dump4byte2($DD, $36, OpWaarde, 0, OpWaarde2) else
    if (    (bCodeType and $BF = $0F) and (PRegister1 = 'IX')
        and (OpWaarde < 256)) then
      Oper80_XXXXXrrrd($DD, $70, OpWaarde) else

    if (    (bCodeType and $7F = $11) and (PRegister1 = 'IY')) then
      Dump4byte3($FD, $21, OpWaarde2) else
    if (    (bCodeType and $7F = $31) and (PRegister1 = 'IY')) then
      Dump4byte3($FD, $2A, OpWaarde2) else
    if (    (bCodeType and $3F = $17) and (PRegister1 = 'IY')
        and (OpWaarde2 < 256)) then
      Dump4byte2($FD, $36, OpWaarde, 0, OpWaarde2) else
    if (    (bCodeType and $BF = $0F) and (PRegister1 = 'IY')
        and (OpWaarde2 < 256)) then
      Oper80_XXXXXrrrd($FD, $70, OpWaarde) else

    if (    (bCodeType and $BF = $0E) and (PRegister2 = 'A')) then
      Dump3byte($32, OpWaarde) else
    if (    (bCodeType and $BF = $0E) and (PRegister2 = 'HL')) then
      Dump3byte($22, OpWaarde) else
    if (    (bCodeType and $BF = $0E) and (PRegister2 = 'IX')) then
      Dump4byte3($DD, $22, OpWaarde) else
    if (    (bCodeType and $BF = $0E) and (PRegister2 = 'IY')) then
      Dump4byte3($FD, $22, OpWaarde) else

    if bCodeType and $BF = $0E then Oper80_XXssXXXXnn($43, OpWaarde) else

    if (    (bCodeType and $6D = $29) and (PRegister2 = 'IX')
        and (OpWaarde < 256)) then
      Oper80_XXrrrXXXd($DD, $46, OpWaarde2, Pregister1) else
    if (    (bCodeType and $6D = $29) and (PRegister2 = 'IY')
        and (OpWaarde < 256)) then
      Oper80_XXrrrXXXd($FD, $46, OpWaarde2, PRegister1) else

    if (    (bCodeType and $7F = $11) and (OpWaarde < 256)
        and (PRegister1[0] = #1)) then Oper80_XXrrrXXXn($06, OpWaarde2) else

    if (    (bCodeType = 9) and (PRegister1 = 'SP')
        and (PRegister2 = 'HL')) then Dump1Byte($F9) else
    if (    (bCodeType = 9) and (PRegister1 = 'SP')
        and (PRegister2 = 'IX')) then Dump2Byte($DD, $F9) else
    if (    (bCodeType = 9) and (PRegister1 = 'SP')
        and (PRegister2 = 'IY')) then Dump2Byte($FD, $F9) else

    if bCodeType = 9 then Oper80_XXrrrrrr($40) else

    if bCodeType and $7F = $11 then
     begin
      PRegister2 := Pregister1;
      Oper80_XXssXXXXnn2($01, OpWaarde2);
     end
      else
    if bCodeType and $7F = $31 then
     begin
      PRegister2 := Pregister1;
      Oper80_XXssXXXXnn($4B, OpWaarde2);
     end
      else

    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'LDD' then Oper2Byte($ED, $A8) else
  if Opcode = 'LDDR' then Oper2Byte($ED, $B8) else
  if Opcode = 'LDI' then Oper2Byte($ED, $A0) else
  if Opcode = 'LDIR' then Oper2Byte($ED, $B0) else
  if Opcode = 'NEG' then Oper2Byte($ED, $44) else
  if Opcode = 'NOP' then Oper1Byte($00) else
  if Opcode = 'OR' then Z80AritmLogic($b0,$f6,OpWaarde,OpWaarde2) else
  if Opcode = 'OTDR' then Oper2Byte($ED, $BB) else
  if Opcode = 'OTIR' then Oper2Byte($ED, $B3) else
  if Opcode = 'OUT' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    if (    (bCodeType and $BF = $0E) and (OpWaarde < 256)
        and (PRegister2 = 'A')) then Dump2byte($D3, OpWaarde) else
    if (    (bCodeType = $0D) and (PRegister1 = 'C')) then
      Oper80_XXrrrXXX2($ED, $41, Pregister2) else
    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'OUTD' then Oper2Byte($ED, $AB) else
  if Opcode = 'OUTI' then Oper2Byte($ED, $A3) else
  if Opcode = 'POP' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    if ((bCodeType = 1) and (PRegister1 = 'IX')) then Dump2Byte($DD, $E1) else
    if ((bCodeType = 1) and (PRegister1 = 'IY')) then Dump2Byte($FD, $E1) else
    if bCodeType = 1 then Oper80_XXqqXXXX($C1) else
    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'PUSH' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    if ((bCodeType = 1) and (PRegister1 = 'IX')) then Dump2Byte($DD, $E5) else
    if ((bCodeType = 1) and (PRegister1 = 'IY')) then Dump2Byte($FD, $E5) else
    if bCodeType = 1 then Oper80_XXqqXXXX($C5) else
    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'RES' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    tmp:=$86;
    if bExtraOp<>$FF then
     begin
      tmp:=$80 or bExtraOp;
      bExtraOp:=$FF;
     end;

    if PRegister1 ='' then Opwaarde := OpWaarde and $FFFF;
    if ((bCodeType and 7 = 2) and (OpWaarde < 8)) then
     begin
      if bCodeType and $B8 = 8 then
       begin
        by := (OpWaarde shl 3) and $38 + $80;
        Oper80_XXXXXrrr2($CB, by);
       end
        else
      if ((bCodeType and $F8 = $28) and (PRegister2 = 'HL')) then
        Dump2byte($CB, $86  or ((OpWaarde and $FF) shl 3)) else
      if ((bCodeType and $68 = $28) and (PRegister2 = 'IX')) then
        Dump4byte2($DD, $CB, OpWaarde2 and $FF, OpWaarde, tmp) else
      if ((bCodeType and $68 = $28) and (PRegister2 = 'IY')) then
        Dump4byte2($FD, $CB, OpWaarde2 and $FF, OpWaarde, tmp) else
       ErrorEnd(16);
     end
      else
    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'RET' then
   begin
    if Regel = '' then Oper1Byte($C9) else
     begin
      oper80_first(OpWaarde, OpWaarde2, bCodeType);

      if bCodeType = 1 then
       begin
        if PRegister1 = 'NZ' then Dump1Byte($C0) else
        if PRegister1 = 'Z'  then Dump1Byte($C8) else
        if PRegister1 = 'NC' then Dump1Byte($D0) else
        if PRegister1 = 'C'  then Dump1Byte($D8) else
        if PRegister1 = 'PO' then Dump1Byte($E0) else
        if PRegister1 = 'PE' then Dump1Byte($E8) else
        if PRegister1 = 'P'  then Dump1Byte($F0) else
        if PRegister1 = 'M'  then Dump1Byte($F8) else
         ErrorEnd(16);
       end
        else
      if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
      bCodeType := 255;
     end;
   end
    else
  if Opcode = 'RETI' then Oper2Byte($ED, $4D) else
  if Opcode = 'RETN' then Oper2Byte($ED, $45) else
  if Opcode = 'RL' then Z80Shift($10,OpWaarde,OpWaarde2) else
  if Opcode = 'RLA' then Oper1Byte($17) else
  if Opcode = 'RLC' then Z80Shift($00,OpWaarde,OpWaarde2) else
  if Opcode = 'RLCA' then Oper1Byte($07) else
  if Opcode = 'RLD' then Oper2Byte($ED, $6F) else
  if Opcode = 'RR' then Z80Shift($18,OpWaarde,OpWaarde2) else
  if Opcode = 'RRA' then Oper1Byte($1F) else
  if Opcode = 'RRC' then Z80Shift($08,OpWaarde,OpWaarde2) else
  if Opcode = 'RRCA' then Oper1Byte($0F) else
  if Opcode = 'RRD' then Oper2Byte($ED, $67) else
  if Opcode = 'RST' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    if ((bCodeType and $BF = 2) and (OpWaarde = OpWaarde and $38)) then
      Dump1Byte($c7 or OpWaarde) else
    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'SBC' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    if ((bCodeType and $47 = 1) and (PRegister1 = 'A')) then
     begin
      if UndocReg(PRegister2) then
        DumpWord(undoc0(PRegister2,$98)) else

      if bCodeType and $F8 = 8 then Oper80_XXXXXrrr($98) else
      if ((bCodeType and $78 = $10) and (OpWaarde < 256)) then
        Dump2byte($DE, OpWaarde2) else
      if ((bCodeType and $F8 = $28) and (PRegister2 = 'HL')) then
        Dump1Byte($9E) else
      if ((bCodeType and $68 = $28) and (PRegister2 = 'IX')) then
        oper80_displace($DD, $9E, OpWaarde2) else
      if ((bCodeType and $68 = $28) and (PRegister2 = 'IY')) then
        oper80_displace($FD, $9E, OpWaarde2) else
       ErrorEnd(16);
     end
      else
    if ((bCodeType = 9) and (PRegister1 = 'HL')) then Oper80_XXssXXXX($42)
      else
    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'SCF' then Oper1Byte($37) else
  if Opcode = 'SET' then
   begin
    if Regel = '' then ErrorEnd(15);
    oper80_first(OpWaarde, OpWaarde2, bCodeType);

    tmp:=$C6;
    if bExtraOp<>$FF then
     begin
      tmp:=$c0 or bExtraOp;
      bExtraOp := $FF;
     end;

    if ((bCodeType and 7 = 2) and (OpWaarde < 8)) then
     begin
      if bCodeType and $B8 = 8 then
       begin
        by := (OpWaarde shl 3) and $38 + $C0;
        Oper80_XXXXXrrr2($CB, by);
       end
        else
      if ((bCodeType and $F8 = $28) and (PRegister2 = 'HL')) then
        Dump2byte($CB, $C6  or ((OpWaarde and $FF) shl 3)) else
      if ((bCodeType and $68 = $28) and (PRegister2 = 'IX')) then
        Dump4byte2($DD, $CB, OpWaarde2 and $FF, OpWaarde, tmp) else
      if ((bCodeType and $68 = $28) and (PRegister2 = 'IY')) then
        Dump4byte2($FD, $CB, OpWaarde2 and $FF, OpWaarde, tmp) else
       ErrorEnd(16);
     end
      else
    if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
    bCodeType := 255;
   end
    else
  if Opcode = 'SLA' then Z80Shift($20,OpWaarde,OpWaarde2) else
  if Opcode = 'SRA' then Z80Shift($28,OpWaarde,OpWaarde2) else

{* undocumented shift SLL *}
  if Opcode = 'SLL' then Z80Shift($30,OpWaarde,OpWaarde2) else

  if Opcode = 'SRL' then Z80Shift($38,OpWaarde,OpWaarde2) else
  if Opcode = 'SUB' then Z80AritmLogic($90,$D6,OpWaarde,OpWaarde2) else
  if Opcode = 'XOR' then Z80AritmLogic($A8,$EE,OpWaarde,OpWaarde2);

  if bCodeType = 0 then Look4Macro;

  if ((bCodeType = 0) and (bPass = 3)) then ErrorEnd(14);
end;


procedure Z80AritmLogic(code,immcode:byte; var OpWaarde,OpWaarde2:longint);
{* for sub,and,xor,or and cp *}
begin
  if Regel = '' then ErrorEnd(15);
  oper80_first(OpWaarde, OpWaarde2, bCodeType);

  if UndocReg(PRegister1) then DumpWord(undoc0(PRegister1,code))
    else

{* immediate data, for example and $FE *}
  if ((bCodeType = 2) and (OpWaarde < 256)) then Dump2byte(immcode, OpWaarde)
    else
  if ((bCodeType = 5) and (PRegister1 = 'HL')) then Dump1Byte(code+6)
    else
  if ((bCodeType and $BD = 5) and (PRegister1 = 'IX')) then
   oper80_displace($DD, code+6, OpWaarde)
    else
  if ((bCodeType and $BD = 5) and (PRegister1 = 'IY')) then
   oper80_displace($FD, code+6, OpWaarde)
    else
  if bCodeType = 1 then
   begin
    PRegister2 := Pregister1;
    Oper80_XXXXXrrr(code);
   end
    else
  if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
  bCodeType := 255;
end;


procedure Z80Shift(startcode:byte; var OpWaarde,OpWaarde2:longint);
{* for rlc,rrc,rl,rr,sla,sra,sll(UNDOC) and srl *}
var
  hlcode : byte;
begin
  if Regel = '' then ErrorEnd(15);
  oper80_first(OpWaarde, OpWaarde2, bCodeType);

  hlcode := startcode+6;
  tmp := hlcode;
  if bExtraOp <> $ff then
   begin
    tmp:=startcode or bExtraOp;
    bExtraOp:=$ff;
   end;

  if bCodeType = 1 then Oper80_XXXXXrrr2($CB, startcode)
    else
  if ((bCodeType = 5) and (PRegister1 = 'HL')) then Dump2Byte($CB, hlcode)
    else
  if ((bCodeType and $BD = 5) and (PRegister1 = 'IX')) then
   Dump4byte2($DD, $CB, OpWaarde, 0, tmp)
    else
  if ((bCodeType and $BD = 5) and (PRegister1 = 'IY')) then
   Dump4byte2($FD, $CB, OpWaarde, 0, tmp)
    else
  if not((bCodeType = 0) and (bPass < 3)) then ErrorEnd(16);
  bCodeType := 255;
end;


begin
end.
